package com.nordicpeak.flowengine.evaluators.addclosestmanagerasflowinstancemanagerevaluator;

import se.unlogic.standardutils.annotations.RequiredIfSet;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluator;

@Table(name = "add_closest_manager_as_flow_instance_manager_evaluators")
@XMLElement
public class AddClosestManagerAsFlowInstanceManagerEvaluator extends BaseEvaluator {
	
	private static final long serialVersionUID = 5501896243489595373L;
	
	@DAOManaged
	@WebPopulate(maxLength = 255)
	@RequiredIfSet(paramNames = "sendEmail")
	@XMLElement
	private String emailSubject;
	
	@DAOManaged
	@WebPopulate(maxLength = 65536)
	@RequiredIfSet(paramNames = "sendEmail")
	@XMLElement
	private String emailMessage;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean attachPDF;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean showInLog;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean sendEmail;
	
	public String getEmailSubject() {
		
		return emailSubject;
	}
	
	public void setEmailSubject(String emailSubject) {
		
		this.emailSubject = emailSubject;
	}
	
	public String getEmailMessage() {
		
		return emailMessage;
	}
	
	public void setEmailMessage(String emailMessage) {
		
		this.emailMessage = emailMessage;
	}
	
	public boolean attachPDF() {
		
		return attachPDF;
	}
	
	public void setAttachPDF(boolean attachPDF) {
		
		this.attachPDF = attachPDF;
	}
	
	public boolean isShowInLog() {
		
		return showInLog;
	}
	
	public void setShowInLog(boolean showInLog) {
		
		this.showInLog = showInLog;
	}
	
	public boolean sendEmail() {
		return sendEmail;
	}
	
	public void setSendEmail(boolean sendEmail) {
		this.sendEmail = sendEmail;
	}
	
	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {
		
		emailSubject = xmlParser.getString("emailSubject");
		
		emailMessage = xmlParser.getString("emailMessage");
		
		attachPDF = xmlParser.getPrimitiveBoolean("attachPDF");
		
		showInLog = xmlParser.getPrimitiveBoolean("showInLog");
		
		sendEmail = xmlParser.getPrimitiveBoolean("sendEmail");
	}
	
	@Override
	public String toString() {
		
		return evaluatorDescriptor.toString();
	}
	
}
