package com.nordicpeak.flowengine.addflowinstanceasmanager;

import java.io.Serializable;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.bool.BooleanUtils;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "add_flowinstance_as_manager_settings")
@XMLElement(name = "Settings")
public class FlowFamilyAddInstanceSettings extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 5949025706273639735L;

	@DAOManaged
	@Key
	@XMLElement
	private Integer flowFamilyID;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean allowAnonymous;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean allowInternalUsers;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean allowExistingUsers;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean allowCreatingUsers;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean allowRestrictedManagers;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean suppressSubmittedUserSubmitNotification;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean suppressManagersSubmitNotification;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean suppressArchiveNotification;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean requirePublishedFlow;

	public Integer getFlowFamilyID() {

		return flowFamilyID;
	}

	public void setFlowFamilyID(Integer flowFamilyID) {

		this.flowFamilyID = flowFamilyID;
	}

	public boolean isAllowAnonymous() {

		return allowAnonymous;
	}

	public void setAllowAnonymous(boolean allowAnonymous) {

		this.allowAnonymous = allowAnonymous;
	}
	
	public boolean isAllowInternalUsers() {
		return allowInternalUsers;
	}

	public void setAllowInternalUsers(boolean allowInternalUsers) {
		this.allowInternalUsers = allowInternalUsers;
	}

	public boolean isAllowExistingUsers() {

		return allowExistingUsers;
	}

	public void setAllowExistingUsers(boolean allowExistingUsers) {

		this.allowExistingUsers = allowExistingUsers;
	}

	public boolean isAllowCreatingUsers() {

		return allowCreatingUsers;
	}

	public boolean isAllowRestrictedManagers() {
		return allowRestrictedManagers;
	}

	public void setAllowRestrictedManagers(boolean allowRestrictedManagers) {
		this.allowRestrictedManagers = allowRestrictedManagers;
	}

	public void setAllowCreatingUsers(boolean allowCreatingUsers) {

		this.allowCreatingUsers = allowCreatingUsers;
	}

	public boolean isSuppressSubmittedUserSubmitNotification() {
		return suppressSubmittedUserSubmitNotification;
	}

	public void setSuppressSubmittedUserSubmitNotification(boolean suppressSubmittedUserSubmitNotification) {
		this.suppressSubmittedUserSubmitNotification = suppressSubmittedUserSubmitNotification;
	}

	public boolean isSuppressManagersSubmitNotification() {
		return suppressManagersSubmitNotification;
	}

	public void setSuppressManagersSubmitNotification(boolean suppressManagersSubmitNotification) {
		this.suppressManagersSubmitNotification = suppressManagersSubmitNotification;
	}

	public boolean isSuppressArchiveNotification() {
		return suppressArchiveNotification;
	}

	public void setSuppressArchiveNotification(boolean suppressArchiveNotification) {
		this.suppressArchiveNotification = suppressArchiveNotification;
	}

	public boolean isEmpty() {

		return BooleanUtils.isFalse(allowAnonymous, allowInternalUsers, allowCreatingUsers, allowExistingUsers);
	}

	public boolean isRequirePublishedFlow() {
	
		return requirePublishedFlow;
	}

	public void setRequirePublishedFlow(boolean requirePublishedFlow) {
	
		this.requirePublishedFlow = requirePublishedFlow;
	}
}
