package com.nordicpeak.flowengine.evaluators.agequerystateevaluator;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.EnumPopulator;
import se.unlogic.standardutils.populators.PositiveStringIntegerPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLValidationUtils;

import com.nordicpeak.flowengine.evaluators.calculatequerystateevaluator.CalculatedQueryStateEvaluator;

@Table(name = "age_query_state_evaluators")
@XMLElement
public class AgeQueryStateEvaluator extends CalculatedQueryStateEvaluator {

	private static final EnumPopulator<AgeCalculateMode> CALCULATEMODE_POPULATOR = new EnumPopulator<AgeCalculateMode>(AgeCalculateMode.class);
	
	private static final long serialVersionUID = 7118908804861062008L;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private Integer textFieldID;

	@DAOManaged
	@WebPopulate(required = true)
	@XMLElement
	private AgeCalculateMode calculateMode;

	public Integer getTextFieldID() {

		return textFieldID;
	}

	public void setTextFieldID(Integer textFieldID) {

		this.textFieldID = textFieldID;
	}

	public AgeCalculateMode getCalculateMode() {

		return calculateMode;
	}

	public void setCalculateMode(AgeCalculateMode calculateMode) {

		this.calculateMode = calculateMode;
	}

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		super.populate(xmlParser);
		
		List<ValidationError> errors = new ArrayList<ValidationError>();
		
		textFieldID = XMLValidationUtils.validateParameter("textFieldID", xmlParser, false, PositiveStringIntegerPopulator.getPopulator(), errors);
		
		calculateMode = XMLValidationUtils.validateParameter("calculateMode", xmlParser, true, CALCULATEMODE_POPULATOR, errors);
		
		if (!errors.isEmpty()) {
			
			throw new ValidationException(errors);
		}
		
	}
	
}
