$(function() {
	
	setQueryRequiredFunctions["AlternativeListCheckboxQueryInstance"] = makeAlternativeListCheckBoxQueryRequired;
	
});

function initAlternativeListCheckBoxQuery(queryID) {
	
	var $query = $("#query_" + queryID);
	
	var $freeTextAlternative = $query.find("input[type='checkbox'].freeTextAlternative")
	
	if($freeTextAlternative.length > 0) { 
	
		$freeTextAlternative.on("change", function(e, data) {
			
			var $this = $(this);
			
			if($this.is(":checked")) {
				$("#" + $this.attr("name") + "Value").removeAttr("disabled").parent().show();
			} else {
				$("#" + $this.attr("name") + "Value").attr("disabled", "disabled").parent().hide();
			}
			
//			if(data == undefined || !data.manual) {
//			
//				if($query.hasClass("enableAjaxPosting")) {
//					
//					runCheckBoxEvaluators($this, queryID);
//					
//				}
//			
//			}
			
		});
		
		$freeTextAlternative.trigger("change", [{manual: true}]);
		
		if($query.hasClass("enableAjaxPosting")) {
			
			bindAlternativeListCheckBoxChangeEvent($query.find("input[type='checkbox']"), queryID);
			
		}
		
	} else {
		
		if($query.hasClass("enableAjaxPosting")) {
			
			bindAlternativeListCheckBoxChangeEvent($query.find("input[type='checkbox']"), queryID);
			
		}
		
	}
	
	var maxChecked = $query.data("maxchecked");
	
	if(maxChecked != "") {
		
		var checkboxes = $query.find("input[type='checkbox']");
		
		runAlternativeListCheckBoxMaxAlternatives(checkboxes, maxChecked);
		
		checkboxes.on("change", function() {
			runAlternativeListCheckBoxMaxAlternatives(checkboxes, maxChecked);
		});
	}
	
}

function runAlternativeListCheckBoxMaxAlternatives($checkboxes, maxChecked) {
	
	var checked = 0;
	
	$checkboxes.each(function(index){
		
		if($(this).prop("checked")){
			checked += 1;
		}
	});
	
	if(checked >= maxChecked){
		
		$checkboxes.each(function(index){
			
			var checkbox = $(this); 
			
			if(!checkbox.prop("checked")){
				checkbox.prop("disabled", true);
				checkbox.siblings("label").addClass("disabled");
			}
		});
		
	} else {
		
		$checkboxes.prop("disabled", false);
		$checkboxes.siblings("label").removeClass("disabled");
	}
}

function bindAlternativeListCheckBoxChangeEvent($checkboxes, queryID) {
	
	$checkboxes.on("change", function() {
		
		runAlternativeListCheckBoxEvaluators($(this), queryID);
	});
}

function runAlternativeListCheckBoxEvaluators($this, queryID) {
	
	var parameters = {};
	
	var $inputWrapper = $this.parent().parent();
	
	$inputWrapper.find(".alternative input[type='checkbox']:checked").each(function () {
		
		var $checkbox = $(this);
		
		parameters[$checkbox.attr("name")] = $checkbox.val();
		
		if($checkbox.hasClass("freeTextAlternative")){
			
			parameters["q" + queryID + "_freeTextAlternativeValue"] = $("#q" + queryID + "_freeTextAlternativeValue").val();
		}
		
	});
	
	runQueryEvaluators(queryID, parameters);
	
}

function makeAlternativeListCheckBoxQueryRequired(queryID) {
	
	$("#query_" + queryID).find(".heading-wrapper h2").addClass("required");
	
}