<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/jquery-ui.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>	

	<xsl:variable name="scripts">
		/common/js/queryadmin.js
		/js/alternativelistpriorityqueryadmin.js
	</xsl:variable>

	<xsl:template match="Document">	
		
		<div id="AlternativeListPriorityQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdateAlternativeListPriorityQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdateAlternativeListPriorityQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="AlternativeListPriorityQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateAlternativeListPriorityQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="AlternativeListPriorityQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full bigmarginbottom" id="exportIDDiv" style="display:none">
					<div class="floatleft full">
						<xsl:call-template name="createCheckbox">
							<xsl:with-param name="id" select="'exportAlternativeID'" />
							<xsl:with-param name="name" select="'exportAlternativeID'" />
							<xsl:with-param name="element" select="AlternativeListPriorityQuery" />
						</xsl:call-template>
							
						<label for="exportAlternativeID">
							<xsl:value-of select="$i18n.exportAlternativeID" />
						</label>
				    </div>
				    <div class="floatleft fifty">
						<span class="tiny"><xsl:value-of select="$i18n.exportAlternativeIDInformation" /></span>
					</div>
				</div>

				<label for="listName">
					<xsl:value-of select="$i18n.ListName" />
				</label>

				<div class="floatleft full">
				
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'listName'"/>
						<xsl:with-param name="name" select="'listName'"/>
						<xsl:with-param name="element" select="Lists/List"/>
						<xsl:with-param name="labelElementName" select="'Name'"/>
						<xsl:with-param name="valueElementName" select="'ID'"/>
						<xsl:with-param name="selectedValue" select="CurrentList"/>
						<xsl:with-param name="class" select="'full'"/>
					</xsl:call-template>
				
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="emptyListDescription" class="floatleft clearboth"><xsl:value-of select="$i18n.EmptyListDescription" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextArea">
						<xsl:with-param name="id" select="'emptyListDescription'" />
						<xsl:with-param name="name" select="'emptyListDescription'" />
						<xsl:with-param name="element" select="AlternativeListPriorityQuery" />
						<xsl:with-param name="rows">4</xsl:with-param>
					</xsl:call-template>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="minChoices" class="floatleft"><xsl:value-of select="$i18n.MinChoices" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'minChoices'"/>
						<xsl:with-param name="name" select="'minChoices'"/>
						<xsl:with-param name="title" select="$i18n.MinChoices"/>
						<xsl:with-param name="size" select="'30'"/>
						<xsl:with-param name="element" select="AlternativeListPriorityQuery" />
					</xsl:call-template>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="maxChoices" class="floatleft"><xsl:value-of select="$i18n.MaxChoices" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'maxChoices'"/>
						<xsl:with-param name="name" select="'maxChoices'"/>
						<xsl:with-param name="title" select="$i18n.MaxChoices"/>
						<xsl:with-param name="size" select="'30'"/>
						<xsl:with-param name="element" select="AlternativeListPriorityQuery" />
					</xsl:call-template>
			    </div>
			</div>
		
			<h2 class="floatleft full bigmargintop"><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full marginbottom">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="AlternativeListPriorityQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
			    </div>
			    <div class="floatleft full tiny"><xsl:value-of select="$i18n.attributeInfo" /></div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="AlternativeListPriorityQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			    </div>
			</div>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
		
	</xsl:template>

	<xsl:template name="appendCreateCommonFieldsFormConterAfterName">
	
		<div class="floatleft full bigmarginbottom">
			<label for="shortDescription" class="floatleft clearboth"><xsl:value-of select="$i18n.ShortDescription" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'shortDescription'"/>
					<xsl:with-param name="name" select="'shortDescription'"/>
					<xsl:with-param name="title" select="$i18n.ShortDescription"/>
					<xsl:with-param name="element" select="AlternativeListPriorityQuery" />
				</xsl:call-template>
		    </div>
		</div>	
	
	</xsl:template>

	<xsl:template match="PriorityAlternative">
		
		<xsl:call-template name="createAlternative">
			<xsl:with-param name="alternativeID" select="alternativeID" />
			<xsl:with-param name="sortOrder" select="sortIndex" />
			<xsl:with-param name="value" select="name" />
		</xsl:call-template>
		
	</xsl:template>
	
	<!-- From /FlowEngine/src/com/nordicpeak/flowengine/queries/common/xsl/QueryAdminCommonTemplates.xsl -->
	<xsl:template name="createAlternativesForm">
		
		<xsl:param name="alternatives" />
		<xsl:param name="requestparameters" select="requestparameters" />
		
		<script type="text/javascript">
			Alternativesi18n = {
				deleteConfirm: "<xsl:value-of select="$i18n.DeleteAlternativeConfirm"/>",
				title: "<xsl:value-of select="$i18n.AlternativeExtraTitle"/>",
			};
		</script>
		
		<div class="alternatives-container full floatleft bigmarginbottom">
			<label class="floatleft clearboth"><xsl:value-of select="$i18n.Alternative" /></label>
			
			<div class="full floatleft marginleft">
				<div class="floatright" style="margin-right: 35px;"><xsl:value-of select="$i18n.PriorityAlternative.AllowMultiple"/></div>
			</div>
			
			<div class="alternatives full floatleft marginleft sortable">
				
				<xsl:choose>
					<xsl:when test="$requestparameters">
						<xsl:apply-templates select="$requestparameters/parameter[starts-with(name,'alternative_')]" mode="alternative" >
							<xsl:with-param name="editExtraValues" select="'false'"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="$alternatives" >
							<xsl:with-param name="editExtraValues" select="'false'"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			
			</div>
			
			<div class="alternative-template" style="display: none;">
				<xsl:call-template name="createAlternative">
					<xsl:with-param name="alternativeID" select="''" />
					<xsl:with-param name="sortOrder" select="'sortIndex'" />
					<xsl:with-param name="value" select="''" />
					<xsl:with-param name="disabled" select="'true'" />
				</xsl:call-template>
			</div>
			
			<div class="floatright marginright margintop">
				<a href="#" onclick="addAlternative(this, event)" title="{$i18n.AddAlternative}">
					<xsl:value-of select="$i18n.AddAlternative"/>
				</a>
				<a href="#" onclick="addAlternative(this, event)" title="{$i18n.AddAlternative}">
					<img class="vertical-align-bottom marginleft" src="{$commonImagePath}/add.png"/>
				</a>
			</div>
		
		</div>
		
	</xsl:template>
	
	<!-- From /FlowEngine/src/com/nordicpeak/flowengine/queries/common/xsl/QueryAdminCommonTemplates.xsl -->
	<xsl:template name="createAlternative">
		
		<xsl:param name="alternativeID" />
		<xsl:param name="sortOrder" />
		<xsl:param name="value" />
		<xsl:param name="disabled" select="null" />
		
		<div class="alternative full floatleft margintop marginbottom">
			<img class="vertical-align-middle marginright cursor-move" src="{$commonImagePath}/move.png" title="{$i18n.MoveAlternative}"/>
			
			<!-- TODO Use of //requestparameters below is very slow and needs to be replaced -->
			
			<xsl:call-template name="createHiddenField">
				<xsl:with-param name="id" select="concat('alternativeID_', $alternativeID)"/>
				<xsl:with-param name="name" select="'alternativeID'"/>
				<xsl:with-param name="value" select="$alternativeID"/>
				<xsl:with-param name="disabled" select="$disabled"/>
			</xsl:call-template>
			<xsl:call-template name="createHiddenField">
				<xsl:with-param name="id" select="concat('sortorder_', $alternativeID)" />
				<xsl:with-param name="name" select="concat('sortorder_', $alternativeID)" />
				<xsl:with-param name="value" select="$sortOrder" />
				<xsl:with-param name="class" select="'sortorder'" />
				<xsl:with-param name="requestparameters" select="//requestparameters" />
				<xsl:with-param name="disabled" select="$disabled"/>
			</xsl:call-template>
			<xsl:call-template name="createTextField">
				<xsl:with-param name="id" select="concat('alternative_', $alternativeID)"/>
				<xsl:with-param name="name" select="concat('alternative_', $alternativeID)"/>
				<xsl:with-param name="title" select="name"/>
				<xsl:with-param name="value" select="$value"/>
				<xsl:with-param name="width" select="'calc(100% - 150px)'"/>
				<xsl:with-param name="class" select="'name'" />
				<xsl:with-param name="requestparameters" select="//requestparameters" />
				<xsl:with-param name="disabled" select="$disabled"/>
			</xsl:call-template>
			
			<div class="floatright bigmarginright" style="margin-top: 19px;">
				<div class="bigmarginleft display-inline" style="margin-right: 55px;">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="concat('allowmultiple_', $alternativeID)" />
						<xsl:with-param name="name" select="concat('allowmultiple_', $alternativeID)" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="title" select="$i18n.PriorityAlternative.AllowMultiple"/>
						<xsl:with-param name="checked" select="allowMultiple" />
						<xsl:with-param name="requestparameters" select="//requestparameters" />
					</xsl:call-template>
				</div>
				
				<a href="#" onclick="deleteAlternative(this, event)" title="{$i18n.DeleteAlternative}">
					<img class="vertical-align-middle marginleft" src="{$commonImagePath}/delete.png"/>
				</a>
			</div>
			
		</div>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedAlternativeListPriorityQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.AlternativeListPriorityQueryNotFound" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'MinChoicesBiggerThanMaxChoices']">
		
		<p class="error">
			<xsl:value-of select="$i18n.MinChoicesBiggerThanMaxChoices" />
		</p>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'MinChoicesTooSmall']">
		
		<p class="error">
			<xsl:value-of select="$i18n.MinChoicesTooSmall" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'MaxChoicesOutOfRange']">
		
		<p class="error">
			<xsl:value-of select="$i18n.MaxChoicesOutOfRange" />
		</p>
		
	</xsl:template>
	

	<xsl:template match="fieldName">
	
		<xsl:variable name="fieldName" select="." />
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'listName'">
				<xsl:value-of select="$i18n.ListName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'shortDescription'">
				<xsl:value-of select="$i18n.shortDescription" />
			</xsl:when>
			<xsl:when test="$fieldName = 'minChoices'">
				<xsl:value-of select="$i18n.minChoices" />
			</xsl:when>
			<xsl:when test="$fieldName = 'maxChoices'">
				<xsl:value-of select="$i18n.maxChoices" />
			</xsl:when>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.attributeName" />
			</xsl:when>			
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>