<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>

	<xsl:variable name="scripts">
		/js/alternativelistradiobuttonquery.js
	</xsl:variable>
	
	<xsl:variable name="links">
		/css/alternativelistradiobuttonquery.css
	</xsl:variable>

	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		<xsl:apply-templates select="ShowQueryForm"/>
		
	</xsl:template>

	<xsl:template match="ShowQueryValues">
	
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="AlternativeListRadioButtonQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
		
			<article>
				
				<div class="heading-wrapper">
					<h2>
						<xsl:attribute name="class">
							<xsl:if test="AlternativeListRadioButtonQueryInstance/QueryInstanceDescriptor/queryState = 'VISIBLE_REQUIRED'">
								<xsl:text>required</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="AlternativeListRadioButtonQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
					</h2>
					
					<xsl:call-template name="createUpdateButton">
						<xsl:with-param name="queryID" select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/queryID" />
					</xsl:call-template>
					
				</div>
				
				<xsl:if test="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/description">
					<span class="italic">
						<xsl:if test="/Document/useCKEditorForDescription = 'true'"><xsl:attribute name="class">italic html-description</xsl:attribute></xsl:if>
						<xsl:value-of select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
				<div class="clearboth"/>
				
				<xsl:choose>
					<xsl:when test="AlternativeListRadioButtonQueryInstance/alternativeName">
						<xsl:value-of select="AlternativeListRadioButtonQueryInstance/alternativeName"/>
					</xsl:when>
					<xsl:when test="AlternativeListRadioButtonQueryInstance/freeTextAlternativeValue">
						<xsl:value-of select="AlternativeListRadioButtonQueryInstance/freeTextAlternativeValue"/>
					</xsl:when>
				</xsl:choose>
				
			</article>
		
		</div>		
	
	</xsl:template>
		
	<xsl:template match="ShowQueryForm">
	
		<xsl:variable name="queryID" select="concat('query_', AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/queryID)" />
	
		<div id="{$queryID}">
		
			<xsl:attribute name="class">
				<xsl:text>query alternativelistradiobuttonquery</xsl:text>
				<xsl:if test="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/freeTextAlternative">
					<xsl:text> hasFreeTextAlternative</xsl:text>
				</xsl:if>
				<xsl:if test="EnableAjaxPosting"><xsl:text> enableAjaxPosting</xsl:text></xsl:if>
				<xsl:if test="AlternativeListRadioButtonQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
		
			<a name="{$queryID}" />
		
			<xsl:if test="ValidationErrors/validationError">
				<div id="{$queryID}-validationerrors" class="validationerrors">
					<div class="info-box error">
						<xsl:apply-templates select="ValidationErrors/validationError"/>
						<div class="marker"></div>
					</div>
				</div>
			</xsl:if>
	
			<article>
			
				<xsl:if test="ValidationErrors/validationError">
					<xsl:attribute name="class">error</xsl:attribute>
				</xsl:if>
			
				<div class="heading-wrapper">
					
					<h2>
						<xsl:attribute name="class">
							<xsl:if test="AlternativeListRadioButtonQueryInstance/QueryInstanceDescriptor/queryState = 'VISIBLE_REQUIRED'">
								<xsl:text>required</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="AlternativeListRadioButtonQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
					</h2>
					
					<xsl:if test="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/helpText">		
						<xsl:apply-templates select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/helpText" />
					</xsl:if>
					
				</div>
				
				<xsl:if test="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/description">
					<span class="italic">
						<xsl:if test="/Document/useCKEditorForDescription = 'true'"><xsl:attribute name="class">italic html-description</xsl:attribute></xsl:if>
						<xsl:value-of select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
					<xsl:choose>
					<xsl:when test="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/Alternatives/Alternative">
						
						<xsl:apply-templates select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/Alternatives/Alternative" mode="form"/>
						
						<xsl:if test="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/freeTextAlternative">
				
							<xsl:variable name="freeTextAlternativeName">
								<xsl:value-of select="'q'"/>
								<xsl:value-of select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/queryID"/>
								<xsl:value-of select="'_alternative'"/>
							</xsl:variable>
						
							<div class="alternative">
							
								<xsl:attribute name="class">
									<xsl:text>alternative</xsl:text>
									<xsl:choose>
										<xsl:when test="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/columns = 'TWO'"> floatleft fifty</xsl:when>
										<xsl:when test="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/columns = 'THREE'"> floatleft thirty</xsl:when>
									</xsl:choose>
								</xsl:attribute>
						
								<xsl:call-template name="createRadio">
									<xsl:with-param name="id" select="concat($freeTextAlternativeName, '_freeTextAlternative')" />
									<xsl:with-param name="name" select="$freeTextAlternativeName" />
									<xsl:with-param name="class" select="'freeTextAlternative'" />
									<xsl:with-param name="value" select="'freeTextAlternative'" />
									<xsl:with-param name="checked" select="AlternativeListRadioButtonQueryInstance/freeTextAlternativeValue" />
								</xsl:call-template>
								
								<xsl:text>&#x20;</xsl:text>	
								<label for="{concat($freeTextAlternativeName, '_freeTextAlternative')}" class="radio"><xsl:value-of select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/freeTextAlternative" /></label>
						
							</div>
						
							<div class="freeTextAlternativeValue hidden">
								<xsl:call-template name="createTextField">
									<xsl:with-param name="id" select="concat($freeTextAlternativeName,'Value')" />
									<xsl:with-param name="name" select="concat($freeTextAlternativeName,'Value')" />
									<xsl:with-param name="value" select="AlternativeListRadioButtonQueryInstance/freeTextAlternativeValue" />
									<xsl:with-param name="disabled" select="disabled" />
								</xsl:call-template>
							</div>
							
						</xsl:if>
						
					</xsl:when>
					<xsl:otherwise>
					
						<span class="italic html-description">
							<p class="error">
								<xsl:call-template name="replaceLineBreak">
									<xsl:with-param name="string" select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/emptyListDescription" />
								</xsl:call-template>
							</p>
						</span>
					
					</xsl:otherwise>
				</xsl:choose>
				
			</article>
		
		</div>
		
		<script type="text/javascript">$(function(){initAlternativeListRadioButtonQuery('<xsl:value-of select="AlternativeListRadioButtonQueryInstance/AlternativeListRadioButtonQuery/queryID" />');});</script>
		
	</xsl:template>
	
	<xsl:template match="Alternative" mode="form">
	
		<div class="alternative">
		
			<xsl:attribute name="class">
				<xsl:text>alternative</xsl:text>
				<xsl:choose>
					<xsl:when test="../../columns = 'TWO'"> floatleft fifty</xsl:when>
					<xsl:when test="../../columns = 'THREE'"> floatleft thirty</xsl:when>
				</xsl:choose>
			</xsl:attribute>

			<xsl:variable name="radioID">
				<xsl:value-of select="'q'"/>
				<xsl:value-of select="../../queryID"/>
				<xsl:value-of select="'_alternative'"/>
				<xsl:value-of select="alternativeID" />
			</xsl:variable>
		
			<xsl:variable name="alternativeID" select="alternativeID"/>
		
			<xsl:call-template name="createRadio">
				<xsl:with-param name="id" select="$radioID" />
				<xsl:with-param name="name">
					<xsl:value-of select="'q'"/>
					<xsl:value-of select="../../queryID"/>
					<xsl:value-of select="'_alternative'"/>
				</xsl:with-param>
				<xsl:with-param name="value" select="alternativeID"/>
				<xsl:with-param name="elementName" select="'alternativeID'" />
				<xsl:with-param name="checked">
					<xsl:if test="../../../alternativeID = $alternativeID">true</xsl:if>
				</xsl:with-param>
				<xsl:with-param name="requestparameters" select="../../../../requestparameters"/>
			</xsl:call-template>
			<label for="{$radioID}" class="radio"><xsl:value-of select="name" /></label>
				
		</div>
	
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'RequiredQuery']">
		
		<span>
			<strong data-icon-before="!">
			<xsl:value-of select="$i18n.RequiredQuery"/>
			</strong>
		</span>
		
	</xsl:template>		
	
	<xsl:template match="validationError">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.UnknownValidationError"/>
			</strong>
		</span>
		
	</xsl:template>			
	
</xsl:stylesheet>