<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
		/jquery/jquery-ui.js?v=1
	</xsl:variable>
	
	<xsl:variable name="globallinks">
		/css/openhierarchy-jquery-ui.css
	</xsl:variable>

	<xsl:variable name="scripts">
		/js/jquery.ui.datepicker-sv.js
		/js/attributesumlimitqueryadmin.js
	</xsl:variable>

	<xsl:template match="Document">

		<div id="AttributeSumLimitQueryProvider" class="contentitem">

			<xsl:apply-templates select="validationError" />
			<xsl:apply-templates select="UpdateAttributeSumLimitQuery" />

		</div>

	</xsl:template>

	<xsl:template match="UpdateAttributeSumLimitQuery">

		<h1>
			<xsl:value-of select="$i18n.UpdateQuery" />
			<xsl:text>:&#160;</xsl:text>
			<xsl:value-of select="AttributeSumLimitQuery/QueryDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form id="updateAttributeSumLimitQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="AttributeSumLimitQuery" />
			</xsl:call-template>

			<div class="floatleft full marginbottom bigmargintop">
				<h2><xsl:value-of select="$i18n.AttributeAndLimitSettings.Title" /></h2>
			</div>

			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth">
					<xsl:value-of select="$i18n.attributeName" />
				</label>
				<div><p class="tiny clearboth"><xsl:value-of select="$i18n.attributeInfo"></xsl:value-of></p></div>				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="AttributeSumLimitQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
				</div>
			</div>

			<label class="floatleft"><xsl:value-of select="$i18n.UseEndpoint.Title"/></label>
				
			<div class="clearboth floatleft marginbottom"><xsl:value-of select="$i18n.UseEndpoint.Description"/></div>
			
				<div class="floatleft full marginbottom">
							
				<div class="floatleft full">
					<xsl:call-template name="createRadio">
						<xsl:with-param name="id" select="'useEndpointFalse'"/>
						<xsl:with-param name="name" select="'useEndpoint'"/>
						<xsl:with-param name="value" select="'false'"/>
						<xsl:with-param name="element" select="AttributeSumLimitQuery" />
					</xsl:call-template>
					
					<label for="useEndpointFalse">
						<xsl:value-of select="$i18n.UseEndpoint.False" />
					</label>
				</div>
			</div>		
			
			<div class="floatleft full marginbottom">
							
				<div class="floatleft full">
					<xsl:call-template name="createRadio">
						<xsl:with-param name="id" select="'useEndpointTrue'"/>
						<xsl:with-param name="name" select="'useEndpoint'"/>
						<xsl:with-param name="value" select="'true'"/>
						<xsl:with-param name="element" select="AttributeSumLimitQuery" />
					</xsl:call-template>
					
					<label for="useEndpointTrue">
						<xsl:value-of select="$i18n.UseEndpoint.True" />
					</label>
				</div>
			</div>	

			<div id="manualForm">

				<div class="floatleft full bigmarginbottom date-field">
					
					<div class="floatleft full">
						<label for="minDate">
							<xsl:value-of select="$i18n.minDate" />
						</label>
				
						<xsl:call-template name="createTextField">
							<xsl:with-param name="id" select="'minDate'" />
							<xsl:with-param name="name" select="'minDate'" />
							<xsl:with-param name="title" select="$i18n.minDate"/>
							<xsl:with-param name="type" select="'date'"/>
							<xsl:with-param name="element" select="AttributeSumLimitQuery"/>
						</xsl:call-template>
					</div>
				</div>
				
				<div class="floatleft full bigmarginbottom date-field">
					
					<div class="floatleft full">
						<label for="maxDate">
							<xsl:value-of select="$i18n.maxDate" />
						</label>
				
						<xsl:call-template name="createTextField">
							<xsl:with-param name="id" select="'maxDate'" />
							<xsl:with-param name="name" select="'maxDate'" />
							<xsl:with-param name="title" select="$i18n.maxDate"/>
							<xsl:with-param name="type" select="'date'"/>
							<xsl:with-param name="element" select="AttributeSumLimitQuery"/>
						</xsl:call-template>
					</div>
				</div>
			
				<div class="floatleft full bigmarginbottom">
					<label for="limit" class="floatleft clearboth">
						<xsl:value-of select="$i18n.limit" />
					</label>
					<div class="floatleft full">
						<xsl:call-template name="createTextField">
							<xsl:with-param name="id" select="'limit'"/>
							<xsl:with-param name="name" select="'limit'"/>
							<xsl:with-param name="title" select="$i18n.limit"/>
							<xsl:with-param name="element" select="AttributeSumLimitQuery" />
						</xsl:call-template>
					</div>
				</div>
			
			</div>
			
			<div id="enpointForm">
			
				<div class="floatleft hugemarginright">
					<div>
						<label for="endpoint" class="floatleft clearboth">
							<xsl:value-of select="$i18n.Endpoint.title" />
						</label>
					</div>
					<div>
						<xsl:call-template name="createDropdown">
							<xsl:with-param name="id" select="'endpoint'" />
							<xsl:with-param name="name" select="'endpointID'" />
							<xsl:with-param name="title" select="$i18n.Endpoint.title"/>
							<xsl:with-param name="labelElementName" select="'name'" />
							<xsl:with-param name="valueElementName" select="'endpointID'" />
							<xsl:with-param name="element" select="Endpoints/Endpoint" />
							<xsl:with-param name="class" select="'marginright'" />
							<xsl:with-param name="addEmptyOption" select="$i18n.Endpoint.EmptyOption" />
							<xsl:with-param name="selectedValue" select="AttributeSumLimitQuery/Endpoint/endpointID" />
						</xsl:call-template>
					</div>
				</div>			
			
				<div class="floatleft full bigmarginbottom">
					<label for="limitExceededText">
						<xsl:value-of select="$i18n.apiErrorDescription" />
					</label>
					
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'apiErrorDescription'"/>
						<xsl:with-param name="name" select="'apiErrorDescription'"/>
						<xsl:with-param name="title" select="$i18n.apiErrorDescription"/>
						<xsl:with-param name="element" select="AttributeSumLimitQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
						<xsl:with-param name="placeholder" select="$i18n.apiErrorDescription.Placeholder"/>
					</xsl:call-template>
				</div>			
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'showRemaining'" />
						<xsl:with-param name="name" select="'showRemaining'" />
						<xsl:with-param name="element" select="AttributeSumLimitQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="showRemaining">
						<xsl:value-of select="$i18n.showRemaining" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="maxRemainingAmountToShow">
					<xsl:value-of select="$i18n.maxRemainingAmountToShow" />
				</label>
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'maxRemainingAmountToShow'"/>
					<xsl:with-param name="name" select="'maxRemainingAmountToShow'"/>
					<xsl:with-param name="title" select="$i18n.maxRemainingAmountToShow"/>
					<xsl:with-param name="element" select="AttributeSumLimitQuery" />
				</xsl:call-template>
			</div>

			<div class="floatleft full bigmarginbottom">
				<label for="noneRemainingText">
					<xsl:value-of select="$i18n.noneRemainingText" />
				</label>
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'noneRemainingText'"/>
					<xsl:with-param name="name" select="'noneRemainingText'"/>
					<xsl:with-param name="title" select="$i18n.noneRemainingText"/>
					<xsl:with-param name="element" select="AttributeSumLimitQuery" />
					<xsl:with-param name="maxlength" select="'255'"/>
					<xsl:with-param name="placeholder" select="$i18n.noneRemainingText.Placeholder"/>
				</xsl:call-template>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="limitExceededText">
					<xsl:value-of select="$i18n.limitExceededText" />
				</label>
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'limitExceededText'"/>
					<xsl:with-param name="name" select="'limitExceededText'"/>
					<xsl:with-param name="title" select="$i18n.limitExceededText"/>
					<xsl:with-param name="element" select="AttributeSumLimitQuery" />
					<xsl:with-param name="maxlength" select="'45'"/>
					<xsl:with-param name="placeholder" select="$i18n.limitExceededText.Placeholder"/>
				</xsl:call-template>
			</div>
						
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>

		</form>

	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'UpdateFailedAttributeSumLimitQueryNotFound']">

		<p class="error">
			<xsl:value-of select="$i18n.AttributeSumLimitQueryNotFound" />
		</p>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.attributeName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'minDate'">
				<xsl:value-of select="$i18n.minDate" />
			</xsl:when>
			<xsl:when test="$fieldName = 'maxDate'">
				<xsl:value-of select="$i18n.maxDate" />
			</xsl:when>
			<xsl:when test="$fieldName = 'limit'">
				<xsl:value-of select="$i18n.limit" />
			</xsl:when>
			<xsl:when test="$fieldName = 'maxRemainingAmountToShow'">
				<xsl:value-of select="$i18n.maxRemainingAmountToShow" />
			</xsl:when>
			<xsl:when test="$fieldName = 'noneRemainingText'">
				<xsl:value-of select="$i18n.noneRemainingText" />
			</xsl:when>
			<xsl:when test="$fieldName = 'limitExceededText'">
				<xsl:value-of select="$i18n.limitExceededText" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>