package com.nordicpeak.flowengine.queries.basetablequery;

import java.io.Serializable;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement(name = "CellValue")
public abstract class TableCellValue<DropAlternative extends BaseDropDownAlternative, Query extends BaseTableQuery<DropAlternative, Query, Column>, Row extends TableRow<DropAlternative, Column, Query>, Column extends BaseTableColumn<DropAlternative, Column, Query>> extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 854568573886179411L;

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer cellValueID;

	@DAOManaged
	@XMLElement
	private String value;

	@DAOManaged
	@XMLElement
	private String displayValue;

	@DAOManaged
	@XMLElement
	private String xmlValue;

	public TableCellValue() {}

	public TableCellValue(String value) {

		this.value = value;
	}

	public TableCellValue(String value, String displayValue, String xmlValue) {

		this.value = value;
		this.displayValue = displayValue;
		this.xmlValue = xmlValue;
	}

	@Override
	public String toString() {

		return "(cellValueID=" + cellValueID + ", value=" + value + ", displayValue=" + displayValue + ", xmlValue=" + xmlValue + ")";
	}

	public Integer getCellValueID() {

		return cellValueID;
	}

	public void setCellValueID(Integer textFieldValueID) {

		this.cellValueID = textFieldValueID;
	}

	public String getValue() {

		return value;
	}

	public void setValue(String value) {

		this.value = value;
	}

	public String getDisplayValue() {

		return displayValue;
	}

	public void setDisplayValue(String displayValue) {

		this.displayValue = displayValue;
	}

	public String getXmlValue() {

		return xmlValue;
	}

	public void setXmlValue(String xmlValue) {

		this.xmlValue = xmlValue;
	}

	public abstract Column getColumn();

	public abstract Row getRow();

}
