<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Column" mode="thead-show">
	
		<th class="paddingright">
		
			<xsl:if test="width">
				<xsl:attribute name="width">
					<xsl:value-of select="width"/>
					<xsl:value-of select="'%'"/>
				</xsl:attribute>
			</xsl:if>
			
			<xsl:value-of select="label"/>
			
		</th>
	
	</xsl:template>

	<xsl:template match="Column" mode="tbody-show">
	
		<xsl:param name="rowID" select="null"/>
		<xsl:variable name="columnID" select="columnID"/>
		
		<td>
			<xsl:attribute name="class">
				<xsl:text>padding</xsl:text>
				
				<xsl:choose>
					<xsl:when test="summarise = 'true'">
						<xsl:text> text-align-right bigpaddingright</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<!-- <xsl:text> text-align-center</xsl:text> -->
					</xsl:otherwise>
				</xsl:choose>
				
				<xsl:if test="required = 'true' and ../../Rows/Row[rowID = $rowID]/required=true">
					<xsl:text> required</xsl:text>
				</xsl:if>
			</xsl:attribute>
		
			<xsl:variable name="cell" select="../../../Values/CellValue[Row/rowID = $rowID and Column/columnID = $columnID]"/>
			<xsl:variable name="value" select="$cell/value"/>
			<xsl:variable name="displayValue" select="$cell/displayValue"/>
			
			<xsl:choose>
			
				<xsl:when test="columnType='CHECKBOX'">
				
					<xsl:choose>
						<xsl:when test="$value='true'">
							<xsl:value-of select="$i18n.True"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$i18n.False"/>
						</xsl:otherwise>
					</xsl:choose>
				
				</xsl:when>
				
				<xsl:when test="columnType='DROPDOWN'">
				
					<xsl:value-of select="DropDownAlternatives/DropDownAlternative[alternativeID = $value]/name"/>
				
				</xsl:when>
				
				<xsl:when test="columnType='DROPDOWN_ALTERNATIVE_LIST'">
				
					<xsl:value-of select="$displayValue"/>
				
				</xsl:when>
				
				<xsl:otherwise>
				
					<xsl:choose>
						<xsl:when test="$value">
							<xsl:value-of select="$value"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>&#160;</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
					
				</xsl:otherwise>
				
			</xsl:choose>
			
		</td>
	
	</xsl:template>
	
</xsl:stylesheet>