package com.nordicpeak.flowengine.booking.comparators;

import java.sql.Timestamp;
import java.util.Comparator;

import com.nordicpeak.flowengine.booking.beans.Booking;
import com.nordicpeak.flowengine.booking.beans.BookingSlot;

public class BookingStartComparator implements Comparator<Booking> {

	@Override
	public int compare(Booking o1, Booking o2) {

		if (o1 != null && o2 != null) {

			BookingSlot b1 = o1.getBookingSlot();
			BookingSlot b2 = o2.getBookingSlot();

			if (b1 != null && b2 != null) {

				Timestamp s1 = b1.getStart();
				Timestamp s2 = b2.getStart();

				if (s1.equals(s2)) {

					return b1.getEnd().compareTo(b2.getEnd());
				}

				return s1.compareTo(s2);
			}
		}

		return 0;
	}

}
