package com.nordicpeak.flowengine.booking.events;

import java.io.Serializable;

import com.nordicpeak.flowengine.booking.beans.Booking;
import com.nordicpeak.flowengine.booking.beans.BookingEvent;
import com.nordicpeak.flowengine.booking.beans.ExternalMessage;
import com.nordicpeak.flowengine.enums.SenderType;

public class ExternalMessageAddedEvent implements Serializable {

	private static final long serialVersionUID = 1873981649620240956L;

	private final Booking booking;
	private final BookingEvent event;
	private final ExternalMessage externalMessage;
	private final SenderType senderType;

	public ExternalMessageAddedEvent(Booking booking, BookingEvent event, ExternalMessage externalMessage, SenderType senderType) {

		this.booking = booking;
		this.event = event;
		this.externalMessage = externalMessage;
		this.senderType = senderType;
	}

	public Booking getBooking() {

		return booking;
	}

	public BookingEvent getEvent() {

		return event;
	}

	public ExternalMessage getExternalMessage() {

		return externalMessage;
	}

	public SenderType getSenderType() {

		return senderType;
	}

	@Override
	public String toString() {

		return "ExternalMessageAddedEvent (booking=" + booking + ", event=" + event + ", senderType=" + senderType + ")";
	}

}
