<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/jquery-ui.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>

	<xsl:variable name="scripts">
		/common/js/queryadmin.js
		/js/bookingqueryadmin.js?v=1
	</xsl:variable>

	<xsl:template match="Document">	
		
		<div id="BookingQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdateBookingQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdateBookingQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="BookingQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateBookingQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="BookingQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">

				<label for="calendarID">
					<xsl:value-of select="$i18n.Calendar" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'calendarID'" />
						<xsl:with-param name="name" select="'calendarID'" />
						<xsl:with-param name="labelElementName" select="'name'" />
						<xsl:with-param name="valueElementName" select="'calendarID'" />
						<xsl:with-param name="element" select="Calendars/Calendar" />
						<xsl:with-param name="width" select="'50%'" />
						<xsl:with-param name="selectedValue" select="BookingQuery/Calendar/calendarID" />
						<xsl:with-param name="addEmptyOption" select="$i18n.Calendar.Choose" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full marginbottom">
			
				<label for="acceptText" class="floatleft clearboth"><xsl:value-of select="$i18n.AcceptText" /></label>
			
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'acceptText'"/>
					<xsl:with-param name="name" select="'acceptText'"/>
					<xsl:with-param name="value" select="BookingQuery/acceptText"/>
				</xsl:call-template>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<label for="customPriceText" class="floatleft clearboth"><xsl:value-of select="$i18n.CustomPriceText" /></label>
			
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'customPriceText'"/>
					<xsl:with-param name="name" select="'customPriceText'"/>
					<xsl:with-param name="element" select="BookingQuery"/>
				</xsl:call-template>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<label for="invoiceLineText" class="floatleft clearboth"><xsl:value-of select="$i18n.InvoiceLineText" /></label>
			
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'invoiceLineText'"/>
					<xsl:with-param name="name" select="'invoiceLineText'"/>
					<xsl:with-param name="value" select="BookingQuery/invoiceLineText"/>
				</xsl:call-template>
			</div>
			
			<div class="floatleft full marginbottom">
						
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'addBookingSlotManagersToFlowInstance'"/>
					<xsl:with-param name="name" select="'addBookingSlotManagersToFlowInstance'"/>
					<xsl:with-param name="element" select="BookingQuery" />
				</xsl:call-template>
				
				<label for="addBookingSlotManagersToFlowInstance"><xsl:value-of select="$i18n.AddBookingSlotManagersToFlowInstance" /></label>
			</div>			
			
			<div class="floatleft full marginbottom">
					
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showLocationInList'"/>
					<xsl:with-param name="name" select="'showLocationInList'"/>
					<xsl:with-param name="element" select="BookingQuery" />
				</xsl:call-template>
				
				<label for="showLocationInList"><xsl:value-of select="$i18n.ShowLocationInList" /></label>
			</div>
		
			<div class="floatleft full marginbottom">
					
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showLocationFilter'"/>
					<xsl:with-param name="name" select="'showLocationFilter'"/>
					<xsl:with-param name="element" select="BookingQuery" />
				</xsl:call-template>
				
				<label for="showLocationFilter"><xsl:value-of select="$i18n.ShowLocationFilter" /></label>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showCommentField'"/>
					<xsl:with-param name="name" select="'showCommentField'"/>
					<xsl:with-param name="element" select="BookingQuery" />
				</xsl:call-template>
				
				<label for="showCommentField"><xsl:value-of select="$i18n.ShowCommentField" /></label>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<label for="commentName" class="floatleft clearboth"><xsl:value-of select="$i18n.CommentFieldName" /></label>
			
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'commentName'"/>
					<xsl:with-param name="name" select="'commentName'"/>
					<xsl:with-param name="value" select="BookingQuery/commentName"/>
				</xsl:call-template>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showFirstFreeSlot'"/>
					<xsl:with-param name="name" select="'showFirstFreeSlot'"/>
					<xsl:with-param name="element" select="BookingQuery" />
				</xsl:call-template>
				
				<label for="showFirstFreeSlot"><xsl:value-of select="$i18n.ShowFirstFreeSlot" /></label>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<label for="noFreeSlotsText" class="floatleft clearboth"><xsl:value-of select="$i18n.NoFreeSlotsText" /></label>
			
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'noFreeSlotsText'"/>
					<xsl:with-param name="name" select="'noFreeSlotsText'"/>
					<xsl:with-param name="element" select="BookingQuery"/>
				</xsl:call-template>
			</div>
			
			<div class="floatleft full marginbottom">
					
				<label for="minVisibleDays" class="floatleft clearboth"><xsl:value-of select="$i18n.MinVisibleDays" /></label>
			
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'minVisibleDays'"/>
					<xsl:with-param name="name" select="'minVisibleDays'"/>
					<xsl:with-param name="element" select="BookingQuery"/>
				</xsl:call-template>
			</div>
			
			<fieldset>
				<legend class="">
					<xsl:value-of select="$i18n.Query.Booking.StatusTitle"/>
				</legend>
						
				<label for="informationStatus" class="floatleft clearboth"><xsl:value-of select="$i18n.Query.bookingStatusInformation" /></label>
						
			
			<div class="floatleft full bigmarginbottom">

				<label for="archiveStatusID">
					<xsl:value-of select="$i18n.Query.archiveStatusID" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'archiveStatusID'" />
						<xsl:with-param name="name" select="'archiveStatusID'" />
						<xsl:with-param name="labelElementName" select="'name'" />
						<xsl:with-param name="valueElementName" select="'statusID'" />
						<xsl:with-param name="element" select="Statuses/Status[not(contentType = 'NEW' or contentType = 'WAITING_FOR_MULTISIGN' or contentType = 'WAITING_FOR_PAYMENT')]" />
						<xsl:with-param name="addEmptyOption" select="$i18n.Query.archiveStatusID.empty" />
						<xsl:with-param name="selectedValue" select="BookingQuery/archiveStatusID" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full bigmargintop">

				<label for="archiveStatusID">
					<xsl:value-of select="$i18n.Query.bookingSlotPassedStatusID " />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'bookingSlotPassedStatusID'" />
						<xsl:with-param name="name" select="'bookingSlotPassedStatusID'" />
						<xsl:with-param name="labelElementName" select="'name'" />
						<xsl:with-param name="valueElementName" select="'statusID'" />
						<xsl:with-param name="element" select="Statuses/Status[not(contentType = 'NEW' or contentType = 'WAITING_FOR_MULTISIGN' or contentType = 'WAITING_FOR_PAYMENT')]" />
						<xsl:with-param name="addEmptyOption" select="$i18n.Query.archiveStatusID.empty" />
						<xsl:with-param name="selectedValue" select="BookingQuery/bookingSlotPassedStatusID" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom" id="bookingPassedSlotTime">

				<label for="archiveStatusID">
					<xsl:value-of select="$i18n.Query.bookingSlotPassedStatusTime" />
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'bookingSlotPassedStatusTime'"/>
					<xsl:with-param name="name" select="'bookingSlotPassedStatusTime'"/>
					<xsl:with-param name="element" select="BookingQuery"/>
				</xsl:call-template>
				</div>
			</div>
			
			</fieldset>
			
			<div class="floatleft full bigmargintop">
				<h2><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="BookingQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.Query.setAsAttribute" />
					</label>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.Query.attributeName" /></label>
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.Query.attributeName"/>
						<xsl:with-param name="element" select="BookingQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			  </div>
			</div>
			
			<p class="floatleft clearboth"><xsl:value-of select="$i18n.attributeDescription" /></p>
			
			<table class="floatleft clearboth border">
				<thead>
					<th><xsl:value-of select="$i18n.attributes.name" /></th>
					<th><xsl:value-of select="$i18n.attributes.value" /></th>
				</thead>
				<tbody>
					<tr>
						<td>prefix.calendar</td>
						<td><xsl:value-of select="$java.exportCalendar" /></td>
					</tr>
					<tr>
						<td>prefix.date</td>
						<td><xsl:value-of select="$java.exportDate" /></td>
					</tr>
					<tr>
						<td>prefix.time</td>
						<td><xsl:value-of select="$java.exportTime" /></td>
					</tr>
					<tr>
						<td>prefix.location</td>
						<td><xsl:value-of select="$java.exportLocation" /></td>
					</tr>
					<tr>
						<td>prefix.managers</td>
						<td><xsl:value-of select="$java.exportManagers" /></td>
					</tr>
					<tr>
						<td>prefix.managerFirstNames</td>
						<td><xsl:value-of select="$java.exportManagerFirstNames" /></td>
					</tr>
					<tr>
						<td>prefix.size</td>
						<td><xsl:value-of select="$i18n.attribute.size" /></td>
					</tr>
					<tr>
						<td>prefix.url</td>
						<td><xsl:value-of select="$i18n.attribute.url" /></td>
					</tr>
					<tr>
						<td>prefix.bookingID</td>
						<td><xsl:value-of select="$i18n.attribute.bookingID" /></td>
					</tr>
					<tr>
						<td>prefix.bookingSlotID</td>
						<td><xsl:value-of select="$i18n.attribute.bookingSlotID" /></td>
					</tr>
					
				</tbody>
			</table>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
					
		<script type="text/javascript">
			calendarSettings = {
				<xsl:for-each select="Calendars/Calendar">
					<xsl:value-of select="calendarID"/>: {
						requireConfirmation: <xsl:value-of select="requireConfirmation"/>,
						viewMode: "<xsl:value-of select="viewMode"/>"
					}
					<xsl:if test="position() != last()">,</xsl:if>
				</xsl:for-each>
			};
		</script>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedBookingQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.BookingQueryNotFound" />
		</p>
		
	</xsl:template>

	<xsl:template match="fieldName">
	
		<xsl:variable name="fieldName" select="." />
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'calendarID'">
				<xsl:value-of select="$i18n.Calendar" />
			</xsl:when>
			<xsl:when test="$fieldName = 'acceptText'">
				<xsl:value-of select="$i18n.AcceptText" />
			</xsl:when>
			<xsl:when test="$fieldName = 'invoiceLineText'">
				<xsl:value-of select="$i18n.InvoiceLineText" />
			</xsl:when>
			<xsl:when test="$fieldName = 'minVisibleDays'">
				<xsl:value-of select="$i18n.MinVisibleDays" />
			</xsl:when>
			<xsl:when test="$fieldName = 'customPriceText'">
				<xsl:value-of select="$i18n.CustomPriceText" />
			</xsl:when>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.Query.attributeName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'archiveStatusID'">
				<xsl:value-of select="$i18n.Query.archiveStatusID" />
			</xsl:when>
			<xsl:when test="$fieldName = 'bookingSlotPassedStatusID'">
				<xsl:value-of select="$i18n.Query.bookingSlotPassedStatusID" />
			</xsl:when>
			<xsl:when test="$fieldName = 'bookingSlotPassedStatusTime'">
				<xsl:value-of select="$i18n.Query.bookingSlotPassedStatusTime" />
			</xsl:when>
			<xsl:when test="$fieldName = 'noFreeSlotsText'">
				<xsl:value-of select="$i18n.NoFreeSlotsText" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>