function initBookingSizeSelector($parent) {

	addBookingSizeButtonListener(".decrease", function(size) {
		
		return size - 1;
	});
	
	addBookingSizeButtonListener(".increase", function(size) {
		
		return size + 1;
	});
	
	function addBookingSizeButtonListener(selector, sizeCallback) {
		
		$parent.on("click", ".booking-size-selector " + selector, function() {
			
			var $bookingSizeSelector = $(this).closest(".booking-size-selector");
			
			var $sizeInput = $bookingSizeSelector.find("input");
			var $sizeText = $bookingSizeSelector.find(".size");
			
			var size = parseInt($sizeInput.val());
			
			var newSize = sizeCallback(size);
			var maxSize = $bookingSizeSelector.data("max-size");
			
			if (newSize <= 0) {
				
				return;
			}
			
			if (maxSize && newSize > maxSize) {
				
				newSize = maxSize;
			}
			
			$sizeInput.val(newSize);
			$sizeText.text(newSize);
		});
	}
}