<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="links">
		/css/controlplanmodule.css
	</xsl:variable>

	<xsl:template match="Document">
	
		<xsl:apply-templates select="TabContents" />
	
	</xsl:template>
	
	<xsl:template match="TabContents">
	
		<div id="boverket" class="tabs-content">
			
			<div class="errands-wrapper">
			
				<div class="heading-wrapper">
					<h2><xsl:value-of select="$i18n.ControlPlan" /></h2>
				</div>
			
				<table id="controlplan" class="clearboth full coloredtable oep-table" cellspacing="0">
					<thead>	
						<tr>
							<th width="120"><span><xsl:value-of select="$i18n.Done" /></span></th>
							<th><span><xsl:value-of select="$i18n.ControlPoint" /></span></th>
							<th width="100"><span><xsl:value-of select="$i18n.Type" /></span></th>
							<th><span><xsl:value-of select="$i18n.Constitution" /></span></th>
							<th width="150"><span><xsl:value-of select="$i18n.Method" /></span></th>
						</tr>
					</thead>
					<tbody>
						<xsl:choose>
							<xsl:when test="not(Errand/ControlPlan)">
								<tr>
									<td colspan="5">
										<xsl:value-of select="$i18n.NoControlPlan" />
									</td>
								</tr>
							</xsl:when>
							<xsl:otherwise>
								
								<xsl:apply-templates select="Errand/ControlPlan/controlPoints/ControlPoint" mode="list"/>
								
							</xsl:otherwise>
						</xsl:choose>
					</tbody>
				</table>
				
			</div>
			
		</div>
	
	</xsl:template>
	
	<xsl:template match="ControlPoint" mode="list">
		
		<xsl:if test="propertyType != ''">
			<tr class="property-type">
				<td colspan="5"><xsl:value-of select="propertyType" /></td>
			</tr>
		</xsl:if>
		
		<tr>
			<td data-title="{$i18n.Done}" class="status">
				<xsl:choose>
					<xsl:when test="finished = 'true'"><span class="done" data-icon-before="c"><xsl:value-of select="status" /></span></xsl:when>
					<xsl:otherwise><span data-icon-before="x"><xsl:value-of select="status" /></span></xsl:otherwise>
				</xsl:choose>
			</td>
			<td data-title="{$i18n.ControlPoint}"><xsl:value-of select="name" /></td>
			<td data-title="{$i18n.Type}"><xsl:value-of select="type" /></td>
			<td data-title="{$i18n.Constitution}"><xsl:value-of select="constitution" /></td>
			<td data-title="{$i18n.Method}"><xsl:value-of select="method" /></td>
		</tr>
						
	</xsl:template>
	
</xsl:stylesheet>