package com.nordicpeak.flowengine.integration.boverket.beans;

import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

@XMLElement
public class ControlPoint extends GeneratedElementable implements Comparable<ControlPoint> {

	@XMLElement
	private String uuid;

	@XMLElement
	private String constitutionUuid;

	@XMLElement
	private String constitution;

	@XMLElement
	private String name;

	@XMLElement
	private String propertyType;

	@XMLElement
	private String method;

	@XMLElement
	private String status;

	@XMLElement
	private String type;

	@XMLElement
	private boolean finished;

	public ControlPoint(XMLParser xmlParser) {

		uuid = xmlParser.getString("UUID");
		constitutionUuid = xmlParser.getString("Forfattning_UUID");
		name = xmlParser.getString("Namn");
		propertyType = xmlParser.getString("Kontrollegenskapstyp/Varde");
		method = xmlParser.getString("Kontrollmetod/Varde");
		status = xmlParser.getString("Kontrollpunktstatus/Varde");

		if (status.equalsIgnoreCase("Genomfrd")) {
			finished = true;
		}

		type = xmlParser.getString("Kontrollpunktstyp/Varde");

	}

	public String getUuid() {

		return uuid;
	}

	public void setUuid(String uuid) {

		this.uuid = uuid;
	}

	public String getConstitutionUuid() {

		return constitutionUuid;
	}

	public void setConstitutionUuid(String constitutionUuid) {

		this.constitutionUuid = constitutionUuid;
	}

	public String getConstitution() {

		return constitution;
	}

	public void setConstitution(String constitution) {

		this.constitution = constitution;
	}

	public String getName() {

		return name;
	}

	public void setName(String name) {

		this.name = name;
	}

	public String getPropertyType() {

		return propertyType;
	}

	public void setPropertyType(String propertyType) {

		this.propertyType = propertyType;
	}

	public String getMethod() {

		return method;
	}

	public void setMethod(String method) {

		this.method = method;
	}

	public String getStatus() {

		return status;
	}

	public void setStatus(String status) {

		this.status = status;
	}

	public String getType() {

		return type;
	}

	public void setType(String type) {

		this.type = type;
	}

	public boolean isFinished() {

		return finished;
	}

	public void setFinished(boolean finished) {

		this.finished = finished;
	}

	@Override
	public int compareTo(ControlPoint o) {

		return propertyType.compareTo(o.getPropertyType());
	}

}
