package com.nordicpeak.flowengine.integration.castor.beans;

import java.util.List;

import se.unlogic.emailutils.populators.EmailPopulator;
import se.unlogic.standardutils.annotations.PopulateOnlyIfRequired;
import se.unlogic.standardutils.annotations.RequiredIfSet;
import se.unlogic.standardutils.annotations.SplitOnLineBreak;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.SimplifiedRelation;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.PositiveStringIntegerPopulator;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.integration.base.beans.BaseIntegrationSettings;

@Table(name = "castor_integration_settings")
@XMLElement
public class IntegrationSettings extends BaseIntegrationSettings {

	@DAOManaged(columnName = "endpointID")
	@ManyToOne(autoGet = true)
	@XMLElement
	private IntegrationEndpoint endpoint;

	@DAOManaged
	@WebPopulate(required = true, populator = PositiveStringIntegerPopulator.class)
	@XMLElement
	private Integer templateID;

	@DAOManaged
	@WebPopulate(required = true)
	@XMLElement
	private String partnerID;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseCareOf;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseZIPCode;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String casePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String casePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseMobilePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseEmail;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseRealEstateName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseRealEstateNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseRealEstateAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseRealEstatePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String caseRealEstateZIPCode;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean realEstateOwnerEnabled;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerCareOf;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerZIPCode;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerPostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerPhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerMobilePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerEmail;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerRealEstateName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerRealEstateNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerRealEstateAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerRealEstatePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String realEstateOwnerRealEstateZIPCode;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean invoiceRecipientEnabled;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientCareOf;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientZIPCode;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientPostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientPhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientMobilePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientEmail;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientRealEstateName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientRealEstateNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientRealEstateAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientRealEstatePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String invoiceRecipientRealEstateZIPCode;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean inspectionManagerEnabled;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerCareOf;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerZIPCode;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerPostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerPhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerMobilePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerEmail;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerRealEstateName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerRealEstateNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerRealEstateAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerRealEstatePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String inspectionManagerRealEstateZIPCode;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean contactPersonEnabled;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonCareOf;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonZIPCode;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonPostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonPhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonMobilePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonEmail;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonRealEstateName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonRealEstateNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonRealEstateAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonRealEstatePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String contactPersonRealEstateZIPCode;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean appellantEnabled;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantCareOf;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantZIPCode;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantPostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantPhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantMobilePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantEmail;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantRealEstateName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantRealEstateNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantRealEstateAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantRealEstatePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String appellantRealEstateZIPCode;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean coApplicantEnabled;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantCareOf;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantZIPCode;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantPostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantPhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantMobilePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantEmail;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantRealEstateName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantRealEstateNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantRealEstateAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantRealEstatePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String coApplicantRealEstateZIPCode;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean constructionDeveloperEnabled;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperCareOf;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperZIPCode;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperPostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperPhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperMobilePhone;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperEmail;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperRealEstateName;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperRealEstateNumber;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperRealEstateAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperRealEstatePostalAddress;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String constructionDeveloperRealEstateZIPCode;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean addAttachmentsSeparately;

	@DAOManaged
	@OneToMany(autoAdd = true, autoGet = true, autoUpdate = true)
	@XMLElement(fixCase = true)
	private List<AttachmentTypeMapping> attachmentTypeMappings;

	@DAOManaged
	@WebPopulate
	@RequiredIfSet(paramNames = "addAttachmentsSeparately")
	@PopulateOnlyIfRequired
	@XMLElement
	private Integer defaultAttachmentTypeID;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean createCaseOnSpecificStatus;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@RequiredIfSet(paramNames = "createCaseOnSpecificStatus")
	@XMLElement
	private String caseStatusName;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean sendErrorEmail;

	@DAOManaged
	@OneToMany(autoAdd = true, autoGet = true, autoUpdate = true)
	@SimplifiedRelation(table = "castor_integration_email_recipients_error", remoteValueColumnName = "email")
	@WebPopulate(maxLength = 255, populator = EmailPopulator.class)
	@RequiredIfSet(paramNames = "sendErrorEmail")
	@SplitOnLineBreak
	@XMLElement(fixCase = true, childName = "Address")
	private List<String> errorEmailAddresses;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean sendConfigurationErrorEmail;

	@DAOManaged
	@OneToMany(autoAdd = true, autoGet = true, autoUpdate = true)
	@SimplifiedRelation(table = "castor_integration_email_recipients_configuration_error", remoteValueColumnName = "email")
	@WebPopulate(maxLength = 255, populator = EmailPopulator.class)
	@RequiredIfSet(paramNames = "sendConfigurationErrorEmail")
	@SplitOnLineBreak
	@XMLElement(fixCase = true, childName = "Address")
	private List<String> configurationErrorEmailAddresses;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean sendInvalidCaseIDErrorEmail;

	@DAOManaged
	@OneToMany(autoAdd = true, autoGet = true, autoUpdate = true)
	@SimplifiedRelation(table = "castor_integration_email_recipients_invalid_case_id_error", remoteValueColumnName = "email")
	@WebPopulate(maxLength = 255, populator = EmailPopulator.class)
	@RequiredIfSet(paramNames = "sendInvalidCaseIDErrorEmail")
	@SplitOnLineBreak
	@XMLElement(fixCase = true, childName = "Address")
	private List<String> invalidCaseIDErrorEmailAddresses;

	@Override
	public boolean isPopulated() {

		return isEnabled() || endpoint != null || templateID != null || partnerID != null;
	}

	public Integer getTemplateID() {

		return templateID;
	}

	public void setTemplateID(Integer templateID) {

		this.templateID = templateID;
	}

	public String getPartnerID() {

		return partnerID;
	}

	public void setPartnerID(String partnerID) {

		this.partnerID = partnerID;
	}

	public String getCaseNumber() {

		return caseNumber;
	}

	public void setCaseNumber(String caseNumber) {

		this.caseNumber = caseNumber;
	}

	public String getCaseName() {

		return caseName;
	}

	public void setCaseName(String caseName) {

		this.caseName = caseName;
	}

	public String getCaseCareOf() {

		return caseCareOf;
	}

	public void setCaseCareOf(String caseCareOf) {

		this.caseCareOf = caseCareOf;
	}

	public String getCaseAddress() {

		return caseAddress;
	}

	public void setCaseAddress(String caseAddress) {

		this.caseAddress = caseAddress;
	}

	public String getCaseZIPCode() {

		return caseZIPCode;
	}

	public void setCaseZIPCode(String caseZIPCode) {

		this.caseZIPCode = caseZIPCode;
	}

	public String getCasePostalAddress() {

		return casePostalAddress;
	}

	public void setCasePostalAddress(String casePostalAddress) {

		this.casePostalAddress = casePostalAddress;
	}

	public String getCasePhone() {

		return casePhone;
	}

	public void setCasePhone(String casePhone) {

		this.casePhone = casePhone;
	}

	public String getCaseMobilePhone() {

		return caseMobilePhone;
	}

	public void setCaseMobilePhone(String caseMobilePhone) {

		this.caseMobilePhone = caseMobilePhone;
	}

	public String getCaseEmail() {

		return caseEmail;
	}

	public void setCaseEmail(String caseEmail) {

		this.caseEmail = caseEmail;
	}

	public String getCaseRealEstateName() {

		return caseRealEstateName;
	}

	public void setCaseRealEstateName(String caseRealEstateName) {

		this.caseRealEstateName = caseRealEstateName;
	}

	public String getCaseRealEstateNumber() {

		return caseRealEstateNumber;
	}

	public void setCaseRealEstateNumber(String caseRealEstateNumber) {

		this.caseRealEstateNumber = caseRealEstateNumber;
	}

	public String getCaseRealEstateAddress() {

		return caseRealEstateAddress;
	}

	public void setCaseRealEstateAddress(String caseRealEstateAddress) {

		this.caseRealEstateAddress = caseRealEstateAddress;
	}

	public String getCaseRealEstatePostalAddress() {

		return caseRealEstatePostalAddress;
	}

	public void setCaseRealEstatePostalAddress(String caseRealEstatePostalAddress) {

		this.caseRealEstatePostalAddress = caseRealEstatePostalAddress;
	}

	public String getCaseRealEstateZIPCode() {

		return caseRealEstateZIPCode;
	}

	public void setCaseRealEstateZIPCode(String caseRealEstateZIPCode) {

		this.caseRealEstateZIPCode = caseRealEstateZIPCode;
	}

	public boolean isRealEstateOwnerEnabled() {

		return realEstateOwnerEnabled;
	}

	public void setRealEstateOwnerEnabled(boolean realEstateOwnerEnabled) {

		this.realEstateOwnerEnabled = realEstateOwnerEnabled;
	}

	public String getRealEstateOwnerNumber() {

		return realEstateOwnerNumber;
	}

	public void setRealEstateOwnerNumber(String realEstateOwnerNumber) {

		this.realEstateOwnerNumber = realEstateOwnerNumber;
	}

	public String getRealEstateOwnerName() {

		return realEstateOwnerName;
	}

	public void setRealEstateOwnerName(String realEstateOwnerName) {

		this.realEstateOwnerName = realEstateOwnerName;
	}

	public String getRealEstateOwnerCareOf() {

		return realEstateOwnerCareOf;
	}

	public void setRealEstateOwnerCareOf(String realEstateOwnerCareOf) {

		this.realEstateOwnerCareOf = realEstateOwnerCareOf;
	}

	public String getRealEstateOwnerAddress() {

		return realEstateOwnerAddress;
	}

	public void setRealEstateOwnerAddress(String realEstateOwnerAddress) {

		this.realEstateOwnerAddress = realEstateOwnerAddress;
	}

	public String getRealEstateOwnerZIPCode() {

		return realEstateOwnerZIPCode;
	}

	public void setRealEstateOwnerZIPCode(String realEstateOwnerZIPCode) {

		this.realEstateOwnerZIPCode = realEstateOwnerZIPCode;
	}

	public String getRealEstateOwnerPostalAddress() {

		return realEstateOwnerPostalAddress;
	}

	public void setRealEstateOwnerPostalAddress(String realEstateOwnerPostalAddress) {

		this.realEstateOwnerPostalAddress = realEstateOwnerPostalAddress;
	}

	public String getRealEstateOwnerPhone() {

		return realEstateOwnerPhone;
	}

	public void setRealEstateOwnerPhone(String realEstateOwnerPhone) {

		this.realEstateOwnerPhone = realEstateOwnerPhone;
	}

	public String getRealEstateOwnerMobilePhone() {

		return realEstateOwnerMobilePhone;
	}

	public void setRealEstateOwnerMobilePhone(String realEstateOwnerMobilePhone) {

		this.realEstateOwnerMobilePhone = realEstateOwnerMobilePhone;
	}

	public String getRealEstateOwnerEmail() {

		return realEstateOwnerEmail;
	}

	public void setRealEstateOwnerEmail(String realEstateOwnerEmail) {

		this.realEstateOwnerEmail = realEstateOwnerEmail;
	}

	public String getRealEstateOwnerRealEstateName() {

		return realEstateOwnerRealEstateName;
	}

	public void setRealEstateOwnerRealEstateName(String realEstateOwnerRealEstateName) {

		this.realEstateOwnerRealEstateName = realEstateOwnerRealEstateName;
	}

	public String getRealEstateOwnerRealEstateNumber() {

		return realEstateOwnerRealEstateNumber;
	}

	public void setRealEstateOwnerRealEstateNumber(String realEstateOwnerRealEstateNumber) {

		this.realEstateOwnerRealEstateNumber = realEstateOwnerRealEstateNumber;
	}

	public String getRealEstateOwnerRealEstateAddress() {

		return realEstateOwnerRealEstateAddress;
	}

	public void setRealEstateOwnerRealEstateAddress(String realEstateOwnerRealEstateAddress) {

		this.realEstateOwnerRealEstateAddress = realEstateOwnerRealEstateAddress;
	}

	public String getRealEstateOwnerRealEstatePostalAddress() {

		return realEstateOwnerRealEstatePostalAddress;
	}

	public void setRealEstateOwnerRealEstatePostalAddress(String realEstateOwnerRealEstatePostalAddress) {

		this.realEstateOwnerRealEstatePostalAddress = realEstateOwnerRealEstatePostalAddress;
	}

	public String getRealEstateOwnerRealEstateZIPCode() {

		return realEstateOwnerRealEstateZIPCode;
	}

	public void setRealEstateOwnerRealEstateZIPCode(String realEstateOwnerRealEstateZIPCode) {

		this.realEstateOwnerRealEstateZIPCode = realEstateOwnerRealEstateZIPCode;
	}

	public boolean isInvoiceRecipientEnabled() {

		return invoiceRecipientEnabled;
	}

	public void setInvoiceRecipientEnabled(boolean invoiceRecipientEnabled) {

		this.invoiceRecipientEnabled = invoiceRecipientEnabled;
	}

	public String getInvoiceRecipientNumber() {

		return invoiceRecipientNumber;
	}

	public void setInvoiceRecipientNumber(String invoiceRecipientNumber) {

		this.invoiceRecipientNumber = invoiceRecipientNumber;
	}

	public String getInvoiceRecipientName() {

		return invoiceRecipientName;
	}

	public void setInvoiceRecipientName(String invoiceRecipientName) {

		this.invoiceRecipientName = invoiceRecipientName;
	}

	public String getInvoiceRecipientCareOf() {

		return invoiceRecipientCareOf;
	}

	public void setInvoiceRecipientCareOf(String invoiceRecipientCareOf) {

		this.invoiceRecipientCareOf = invoiceRecipientCareOf;
	}

	public String getInvoiceRecipientAddress() {

		return invoiceRecipientAddress;
	}

	public void setInvoiceRecipientAddress(String invoiceRecipientAddress) {

		this.invoiceRecipientAddress = invoiceRecipientAddress;
	}

	public String getInvoiceRecipientZIPCode() {

		return invoiceRecipientZIPCode;
	}

	public void setInvoiceRecipientZIPCode(String invoiceRecipientZIPCode) {

		this.invoiceRecipientZIPCode = invoiceRecipientZIPCode;
	}

	public String getInvoiceRecipientPostalAddress() {

		return invoiceRecipientPostalAddress;
	}

	public void setInvoiceRecipientPostalAddress(String invoiceRecipientPostalAddress) {

		this.invoiceRecipientPostalAddress = invoiceRecipientPostalAddress;
	}

	public String getInvoiceRecipientPhone() {

		return invoiceRecipientPhone;
	}

	public void setInvoiceRecipientPhone(String invoiceRecipientPhone) {

		this.invoiceRecipientPhone = invoiceRecipientPhone;
	}

	public String getInvoiceRecipientMobilePhone() {

		return invoiceRecipientMobilePhone;
	}

	public void setInvoiceRecipientMobilePhone(String invoiceRecipientMobilePhone) {

		this.invoiceRecipientMobilePhone = invoiceRecipientMobilePhone;
	}

	public String getInvoiceRecipientEmail() {

		return invoiceRecipientEmail;
	}

	public void setInvoiceRecipientEmail(String invoiceRecipientEmail) {

		this.invoiceRecipientEmail = invoiceRecipientEmail;
	}

	public String getInvoiceRecipientRealEstateName() {

		return invoiceRecipientRealEstateName;
	}

	public void setInvoiceRecipientRealEstateName(String invoiceRecipientRealEstateName) {

		this.invoiceRecipientRealEstateName = invoiceRecipientRealEstateName;
	}

	public String getInvoiceRecipientRealEstateNumber() {

		return invoiceRecipientRealEstateNumber;
	}

	public void setInvoiceRecipientRealEstateNumber(String invoiceRecipientRealEstateNumber) {

		this.invoiceRecipientRealEstateNumber = invoiceRecipientRealEstateNumber;
	}

	public String getInvoiceRecipientRealEstateAddress() {

		return invoiceRecipientRealEstateAddress;
	}

	public void setInvoiceRecipientRealEstateAddress(String invoiceRecipientRealEstateAddress) {

		this.invoiceRecipientRealEstateAddress = invoiceRecipientRealEstateAddress;
	}

	public String getInvoiceRecipientRealEstatePostalAddress() {

		return invoiceRecipientRealEstatePostalAddress;
	}

	public void setInvoiceRecipientRealEstatePostalAddress(String invoiceRecipientRealEstatePostalAddress) {

		this.invoiceRecipientRealEstatePostalAddress = invoiceRecipientRealEstatePostalAddress;
	}

	public String getInvoiceRecipientRealEstateZIPCode() {

		return invoiceRecipientRealEstateZIPCode;
	}

	public void setInvoiceRecipientRealEstateZIPCode(String invoiceRecipientRealEstateZIPCode) {

		this.invoiceRecipientRealEstateZIPCode = invoiceRecipientRealEstateZIPCode;
	}

	public boolean isInspectionManagerEnabled() {

		return inspectionManagerEnabled;
	}

	public void setInspectionManagerEnabled(boolean inspectionManagerEnabled) {

		this.inspectionManagerEnabled = inspectionManagerEnabled;
	}

	public String getInspectionManagerNumber() {

		return inspectionManagerNumber;
	}

	public void setInspectionManagerNumber(String inspectionManagerNumber) {

		this.inspectionManagerNumber = inspectionManagerNumber;
	}

	public String getInspectionManagerName() {

		return inspectionManagerName;
	}

	public void setInspectionManagerName(String inspectionManagerName) {

		this.inspectionManagerName = inspectionManagerName;
	}

	public String getInspectionManagerCareOf() {

		return inspectionManagerCareOf;
	}

	public void setInspectionManagerCareOf(String inspectionManagerCareOf) {

		this.inspectionManagerCareOf = inspectionManagerCareOf;
	}

	public String getInspectionManagerAddress() {

		return inspectionManagerAddress;
	}

	public void setInspectionManagerAddress(String inspectionManagerAddress) {

		this.inspectionManagerAddress = inspectionManagerAddress;
	}

	public String getInspectionManagerZIPCode() {

		return inspectionManagerZIPCode;
	}

	public void setInspectionManagerZIPCode(String inspectionManagerZIPCode) {

		this.inspectionManagerZIPCode = inspectionManagerZIPCode;
	}

	public String getInspectionManagerPostalAddress() {

		return inspectionManagerPostalAddress;
	}

	public void setInspectionManagerPostalAddress(String inspectionManagerPostalAddress) {

		this.inspectionManagerPostalAddress = inspectionManagerPostalAddress;
	}

	public String getInspectionManagerPhone() {

		return inspectionManagerPhone;
	}

	public void setInspectionManagerPhone(String inspectionManagerPhone) {

		this.inspectionManagerPhone = inspectionManagerPhone;
	}

	public String getInspectionManagerMobilePhone() {

		return inspectionManagerMobilePhone;
	}

	public void setInspectionManagerMobilePhone(String inspectionManagerMobilePhone) {

		this.inspectionManagerMobilePhone = inspectionManagerMobilePhone;
	}

	public String getInspectionManagerEmail() {

		return inspectionManagerEmail;
	}

	public void setInspectionManagerEmail(String inspectionManagerEmail) {

		this.inspectionManagerEmail = inspectionManagerEmail;
	}

	public String getInspectionManagerRealEstateName() {

		return inspectionManagerRealEstateName;
	}

	public void setInspectionManagerRealEstateName(String inspectionManagerRealEstateName) {

		this.inspectionManagerRealEstateName = inspectionManagerRealEstateName;
	}

	public String getInspectionManagerRealEstateNumber() {

		return inspectionManagerRealEstateNumber;
	}

	public void setInspectionManagerRealEstateNumber(String inspectionManagerRealEstateNumber) {

		this.inspectionManagerRealEstateNumber = inspectionManagerRealEstateNumber;
	}

	public String getInspectionManagerRealEstateAddress() {

		return inspectionManagerRealEstateAddress;
	}

	public void setInspectionManagerRealEstateAddress(String inspectionManagerRealEstateAddress) {

		this.inspectionManagerRealEstateAddress = inspectionManagerRealEstateAddress;
	}

	public String getInspectionManagerRealEstatePostalAddress() {

		return inspectionManagerRealEstatePostalAddress;
	}

	public void setInspectionManagerRealEstatePostalAddress(String inspectionManagerRealEstatePostalAddress) {

		this.inspectionManagerRealEstatePostalAddress = inspectionManagerRealEstatePostalAddress;
	}

	public String getInspectionManagerRealEstateZIPCode() {

		return inspectionManagerRealEstateZIPCode;
	}

	public void setInspectionManagerRealEstateZIPCode(String inspectionManagerRealEstateZIPCode) {

		this.inspectionManagerRealEstateZIPCode = inspectionManagerRealEstateZIPCode;
	}

	public boolean isContactPersonEnabled() {

		return contactPersonEnabled;
	}

	public void setContactPersonEnabled(boolean contactPersonEnabled) {

		this.contactPersonEnabled = contactPersonEnabled;
	}

	public String getContactPersonNumber() {

		return contactPersonNumber;
	}

	public void setContactPersonNumber(String contactPersonNumber) {

		this.contactPersonNumber = contactPersonNumber;
	}

	public String getContactPersonName() {

		return contactPersonName;
	}

	public void setContactPersonName(String contactPersonName) {

		this.contactPersonName = contactPersonName;
	}

	public String getContactPersonCareOf() {

		return contactPersonCareOf;
	}

	public void setContactPersonCareOf(String contactPersonCareOf) {

		this.contactPersonCareOf = contactPersonCareOf;
	}

	public String getContactPersonAddress() {

		return contactPersonAddress;
	}

	public void setContactPersonAddress(String contactPersonAddress) {

		this.contactPersonAddress = contactPersonAddress;
	}

	public String getContactPersonZIPCode() {

		return contactPersonZIPCode;
	}

	public void setContactPersonZIPCode(String contactPersonZIPCode) {

		this.contactPersonZIPCode = contactPersonZIPCode;
	}

	public String getContactPersonPostalAddress() {

		return contactPersonPostalAddress;
	}

	public void setContactPersonPostalAddress(String contactPersonPostalAddress) {

		this.contactPersonPostalAddress = contactPersonPostalAddress;
	}

	public String getContactPersonPhone() {

		return contactPersonPhone;
	}

	public void setContactPersonPhone(String contactPersonPhone) {

		this.contactPersonPhone = contactPersonPhone;
	}

	public String getContactPersonMobilePhone() {

		return contactPersonMobilePhone;
	}

	public void setContactPersonMobilePhone(String contactPersonMobilePhone) {

		this.contactPersonMobilePhone = contactPersonMobilePhone;
	}

	public String getContactPersonEmail() {

		return contactPersonEmail;
	}

	public void setContactPersonEmail(String contactPersonEmail) {

		this.contactPersonEmail = contactPersonEmail;
	}

	public String getContactPersonRealEstateName() {

		return contactPersonRealEstateName;
	}

	public void setContactPersonRealEstateName(String contactPersonRealEstateName) {

		this.contactPersonRealEstateName = contactPersonRealEstateName;
	}

	public String getContactPersonRealEstateNumber() {

		return contactPersonRealEstateNumber;
	}

	public void setContactPersonRealEstateNumber(String contactPersonRealEstateNumber) {

		this.contactPersonRealEstateNumber = contactPersonRealEstateNumber;
	}

	public String getContactPersonRealEstateAddress() {

		return contactPersonRealEstateAddress;
	}

	public void setContactPersonRealEstateAddress(String contactPersonRealEstateAddress) {

		this.contactPersonRealEstateAddress = contactPersonRealEstateAddress;
	}

	public String getContactPersonRealEstatePostalAddress() {

		return contactPersonRealEstatePostalAddress;
	}

	public void setContactPersonRealEstatePostalAddress(String contactPersonRealEstatePostalAddress) {

		this.contactPersonRealEstatePostalAddress = contactPersonRealEstatePostalAddress;
	}

	public String getContactPersonRealEstateZIPCode() {

		return contactPersonRealEstateZIPCode;
	}

	public void setContactPersonRealEstateZIPCode(String contactPersonRealEstateZIPCode) {

		this.contactPersonRealEstateZIPCode = contactPersonRealEstateZIPCode;
	}

	public boolean isAppellantEnabled() {

		return appellantEnabled;
	}

	public void setAppellantEnabled(boolean appellantEnabled) {

		this.appellantEnabled = appellantEnabled;
	}

	public String getAppellantNumber() {

		return appellantNumber;
	}

	public void setAppellantNumber(String appellantNumber) {

		this.appellantNumber = appellantNumber;
	}

	public String getAppellantName() {

		return appellantName;
	}

	public void setAppellantName(String appellantName) {

		this.appellantName = appellantName;
	}

	public String getAppellantCareOf() {

		return appellantCareOf;
	}

	public void setAppellantCareOf(String appellantCareOf) {

		this.appellantCareOf = appellantCareOf;
	}

	public String getAppellantAddress() {

		return appellantAddress;
	}

	public void setAppellantAddress(String appellantAddress) {

		this.appellantAddress = appellantAddress;
	}

	public String getAppellantZIPCode() {

		return appellantZIPCode;
	}

	public void setAppellantZIPCode(String appellantZIPCode) {

		this.appellantZIPCode = appellantZIPCode;
	}

	public String getAppellantPostalAddress() {

		return appellantPostalAddress;
	}

	public void setAppellantPostalAddress(String appellantPostalAddress) {

		this.appellantPostalAddress = appellantPostalAddress;
	}

	public String getAppellantPhone() {

		return appellantPhone;
	}

	public void setAppellantPhone(String appellantPhone) {

		this.appellantPhone = appellantPhone;
	}

	public String getAppellantMobilePhone() {

		return appellantMobilePhone;
	}

	public void setAppellantMobilePhone(String appellantMobilePhone) {

		this.appellantMobilePhone = appellantMobilePhone;
	}

	public String getAppellantEmail() {

		return appellantEmail;
	}

	public void setAppellantEmail(String appellantEmail) {

		this.appellantEmail = appellantEmail;
	}

	public String getAppellantRealEstateName() {

		return appellantRealEstateName;
	}

	public void setAppellantRealEstateName(String appellantRealEstateName) {

		this.appellantRealEstateName = appellantRealEstateName;
	}

	public String getAppellantRealEstateNumber() {

		return appellantRealEstateNumber;
	}

	public void setAppellantRealEstateNumber(String appellantRealEstateNumber) {

		this.appellantRealEstateNumber = appellantRealEstateNumber;
	}

	public String getAppellantRealEstateAddress() {

		return appellantRealEstateAddress;
	}

	public void setAppellantRealEstateAddress(String appellantRealEstateAddress) {

		this.appellantRealEstateAddress = appellantRealEstateAddress;
	}

	public String getAppellantRealEstatePostalAddress() {

		return appellantRealEstatePostalAddress;
	}

	public void setAppellantRealEstatePostalAddress(String appellantRealEstatePostalAddress) {

		this.appellantRealEstatePostalAddress = appellantRealEstatePostalAddress;
	}

	public String getAppellantRealEstateZIPCode() {

		return appellantRealEstateZIPCode;
	}

	public void setAppellantRealEstateZIPCode(String appellantRealEstateZIPCode) {

		this.appellantRealEstateZIPCode = appellantRealEstateZIPCode;
	}

	public boolean isCoApplicantEnabled() {

		return coApplicantEnabled;
	}

	public void setCoApplicantEnabled(boolean coApplicantEnabled) {

		this.coApplicantEnabled = coApplicantEnabled;
	}

	public String getCoApplicantNumber() {

		return coApplicantNumber;
	}

	public void setCoApplicantNumber(String coApplicantNumber) {

		this.coApplicantNumber = coApplicantNumber;
	}

	public String getCoApplicantName() {

		return coApplicantName;
	}

	public void setCoApplicantName(String coApplicantName) {

		this.coApplicantName = coApplicantName;
	}

	public String getCoApplicantCareOf() {

		return coApplicantCareOf;
	}

	public void setCoApplicantCareOf(String coApplicantCareOf) {

		this.coApplicantCareOf = coApplicantCareOf;
	}

	public String getCoApplicantAddress() {

		return coApplicantAddress;
	}

	public void setCoApplicantAddress(String coApplicantAddress) {

		this.coApplicantAddress = coApplicantAddress;
	}

	public String getCoApplicantZIPCode() {

		return coApplicantZIPCode;
	}

	public void setCoApplicantZIPCode(String coApplicantZIPCode) {

		this.coApplicantZIPCode = coApplicantZIPCode;
	}

	public String getCoApplicantPostalAddress() {

		return coApplicantPostalAddress;
	}

	public void setCoApplicantPostalAddress(String coApplicantPostalAddress) {

		this.coApplicantPostalAddress = coApplicantPostalAddress;
	}

	public String getCoApplicantPhone() {

		return coApplicantPhone;
	}

	public void setCoApplicantPhone(String coApplicantPhone) {

		this.coApplicantPhone = coApplicantPhone;
	}

	public String getCoApplicantMobilePhone() {

		return coApplicantMobilePhone;
	}

	public void setCoApplicantMobilePhone(String coApplicantMobilePhone) {

		this.coApplicantMobilePhone = coApplicantMobilePhone;
	}

	public String getCoApplicantEmail() {

		return coApplicantEmail;
	}

	public void setCoApplicantEmail(String coApplicantEmail) {

		this.coApplicantEmail = coApplicantEmail;
	}

	public String getCoApplicantRealEstateName() {

		return coApplicantRealEstateName;
	}

	public void setCoApplicantRealEstateName(String coApplicantRealEstateName) {

		this.coApplicantRealEstateName = coApplicantRealEstateName;
	}

	public String getCoApplicantRealEstateNumber() {

		return coApplicantRealEstateNumber;
	}

	public void setCoApplicantRealEstateNumber(String coApplicantRealEstateNumber) {

		this.coApplicantRealEstateNumber = coApplicantRealEstateNumber;
	}

	public String getCoApplicantRealEstateAddress() {

		return coApplicantRealEstateAddress;
	}

	public void setCoApplicantRealEstateAddress(String coApplicantRealEstateAddress) {

		this.coApplicantRealEstateAddress = coApplicantRealEstateAddress;
	}

	public String getCoApplicantRealEstatePostalAddress() {

		return coApplicantRealEstatePostalAddress;
	}

	public void setCoApplicantRealEstatePostalAddress(String coApplicantRealEstatePostalAddress) {

		this.coApplicantRealEstatePostalAddress = coApplicantRealEstatePostalAddress;
	}

	public String getCoApplicantRealEstateZIPCode() {

		return coApplicantRealEstateZIPCode;
	}

	public void setCoApplicantRealEstateZIPCode(String coApplicantRealEstateZIPCode) {

		this.coApplicantRealEstateZIPCode = coApplicantRealEstateZIPCode;
	}

	public boolean isConstructionDeveloperEnabled() {

		return constructionDeveloperEnabled;
	}

	public void setConstructionDeveloperEnabled(boolean constructionDeveloperEnabled) {

		this.constructionDeveloperEnabled = constructionDeveloperEnabled;
	}

	public String getConstructionDeveloperNumber() {

		return constructionDeveloperNumber;
	}

	public void setConstructionDeveloperNumber(String constructionDeveloperNumber) {

		this.constructionDeveloperNumber = constructionDeveloperNumber;
	}

	public String getConstructionDeveloperName() {

		return constructionDeveloperName;
	}

	public void setConstructionDeveloperName(String constructionDeveloperName) {

		this.constructionDeveloperName = constructionDeveloperName;
	}

	public String getConstructionDeveloperCareOf() {

		return constructionDeveloperCareOf;
	}

	public void setConstructionDeveloperCareOf(String constructionDeveloperCareOf) {

		this.constructionDeveloperCareOf = constructionDeveloperCareOf;
	}

	public String getConstructionDeveloperAddress() {

		return constructionDeveloperAddress;
	}

	public void setConstructionDeveloperAddress(String constructionDeveloperAddress) {

		this.constructionDeveloperAddress = constructionDeveloperAddress;
	}

	public String getConstructionDeveloperZIPCode() {

		return constructionDeveloperZIPCode;
	}

	public void setConstructionDeveloperZIPCode(String constructionDeveloperZIPCode) {

		this.constructionDeveloperZIPCode = constructionDeveloperZIPCode;
	}

	public String getConstructionDeveloperPostalAddress() {

		return constructionDeveloperPostalAddress;
	}

	public void setConstructionDeveloperPostalAddress(String constructionDeveloperPostalAddress) {

		this.constructionDeveloperPostalAddress = constructionDeveloperPostalAddress;
	}

	public String getConstructionDeveloperPhone() {

		return constructionDeveloperPhone;
	}

	public void setConstructionDeveloperPhone(String constructionDeveloperPhone) {

		this.constructionDeveloperPhone = constructionDeveloperPhone;
	}

	public String getConstructionDeveloperMobilePhone() {

		return constructionDeveloperMobilePhone;
	}

	public void setConstructionDeveloperMobilePhone(String constructionDeveloperMobilePhone) {

		this.constructionDeveloperMobilePhone = constructionDeveloperMobilePhone;
	}

	public String getConstructionDeveloperEmail() {

		return constructionDeveloperEmail;
	}

	public void setConstructionDeveloperEmail(String constructionDeveloperEmail) {

		this.constructionDeveloperEmail = constructionDeveloperEmail;
	}

	public String getConstructionDeveloperRealEstateName() {

		return constructionDeveloperRealEstateName;
	}

	public void setConstructionDeveloperRealEstateName(String constructionDeveloperRealEstateName) {

		this.constructionDeveloperRealEstateName = constructionDeveloperRealEstateName;
	}

	public String getConstructionDeveloperRealEstateNumber() {

		return constructionDeveloperRealEstateNumber;
	}

	public void setConstructionDeveloperRealEstateNumber(String constructionDeveloperRealEstateNumber) {

		this.constructionDeveloperRealEstateNumber = constructionDeveloperRealEstateNumber;
	}

	public String getConstructionDeveloperRealEstateAddress() {

		return constructionDeveloperRealEstateAddress;
	}

	public void setConstructionDeveloperRealEstateAddress(String constructionDeveloperRealEstateAddress) {

		this.constructionDeveloperRealEstateAddress = constructionDeveloperRealEstateAddress;
	}

	public String getConstructionDeveloperRealEstatePostalAddress() {

		return constructionDeveloperRealEstatePostalAddress;
	}

	public void setConstructionDeveloperRealEstatePostalAddress(String constructionDeveloperRealEstatePostalAddress) {

		this.constructionDeveloperRealEstatePostalAddress = constructionDeveloperRealEstatePostalAddress;
	}

	public String getConstructionDeveloperRealEstateZIPCode() {

		return constructionDeveloperRealEstateZIPCode;
	}

	public void setConstructionDeveloperRealEstateZIPCode(String constructionDeveloperRealEstateZIPCode) {

		this.constructionDeveloperRealEstateZIPCode = constructionDeveloperRealEstateZIPCode;
	}

	public IntegrationEndpoint getEndpoint() {

		return endpoint;
	}

	public void setEndpoint(IntegrationEndpoint endpoint) {

		this.endpoint = endpoint;
	}

	public boolean isSendErrorEmail() {

		return sendErrorEmail;
	}

	public void setSendErrorEmail(boolean sendErrorEmail) {

		this.sendErrorEmail = sendErrorEmail;
	}

	public List<String> getErrorEmailAddresses() {

		return errorEmailAddresses;
	}

	public void setErrorEmailAddresses(List<String> errorEmailAddresses) {

		this.errorEmailAddresses = errorEmailAddresses;
	}

	public boolean isSendConfigurationErrorEmail() {

		return sendConfigurationErrorEmail;
	}

	public void setSendConfigurationErrorEmail(boolean sendConfigurationErrorEmail) {

		this.sendConfigurationErrorEmail = sendConfigurationErrorEmail;
	}

	public List<String> getConfigurationErrorEmailAddresses() {

		return configurationErrorEmailAddresses;
	}

	public void setConfigurationErrorEmailAddresses(List<String> configurationErrorEmailAddresses) {

		this.configurationErrorEmailAddresses = configurationErrorEmailAddresses;
	}

	public boolean isSendInvalidCaseIDErrorEmail() {

		return sendInvalidCaseIDErrorEmail;
	}

	public void setSendInvalidCaseIDErrorEmail(boolean sendInvalidCaseIDErrorEmail) {

		this.sendInvalidCaseIDErrorEmail = sendInvalidCaseIDErrorEmail;
	}

	public List<String> getInvalidCaseIDErrorEmailAddresses() {

		return invalidCaseIDErrorEmailAddresses;
	}

	public void setInvalidCaseIDErrorEmailAddresses(List<String> invalidCaseIDErrorEmailAddresses) {

		this.invalidCaseIDErrorEmailAddresses = invalidCaseIDErrorEmailAddresses;
	}

	public boolean isAddAttachmentsSeparately() {

		return addAttachmentsSeparately;
	}

	public void setAddAttachmentsSeparately(boolean addAttachmentsSeparately) {

		this.addAttachmentsSeparately = addAttachmentsSeparately;
	}

	public List<AttachmentTypeMapping> getAttachmentTypeMappings() {

		return attachmentTypeMappings;
	}

	public void setAttachmentTypeMappings(List<AttachmentTypeMapping> attachmentTypeMappings) {

		this.attachmentTypeMappings = attachmentTypeMappings;
	}

	public Integer getDefaultAttachmentTypeID() {

		return defaultAttachmentTypeID;
	}

	public void setDefaultAttachmentTypeID(Integer defaultAttachmentTypeID) {

		this.defaultAttachmentTypeID = defaultAttachmentTypeID;
	}

	public boolean isCreateCaseOnSpecificStatus() {

		return createCaseOnSpecificStatus;
	}

	public void setCreateCaseOnSpecificStatus(boolean createCaseOnSpecificStatus) {

		this.createCaseOnSpecificStatus = createCaseOnSpecificStatus;
	}

	public String getCaseStatusName() {

		return caseStatusName;
	}

	public void setCaseStatusName(String caseStatusName) {

		this.caseStatusName = caseStatusName;
	}

}
