$(function() {
	
	if ($('.accept-modal-errors').children().length) {
		
		acceptOwnershipChange();
	}
});

var Action = {
	ACCEPT: "accept",
	DECLINE: "decline"
}

function acceptOwnershipChange(button, event) {
	
	handleOwnershipChange(Action.ACCEPT, event);
}

function declineOwnershipChange(button, event) {
	
	handleOwnershipChange(Action.DECLINE, event);
}

function handleOwnershipChange(action, event) {
	
	if (event) {
		
		event.preventDefault();
		event.stopPropagation();
	}
	
	var form = $('#changeOwnerForm');
	var modal = form.find("." + action + "-modal");
	var classSelector = "." + action + "-field";
	
	form.find(".accept-field").attr("disabled", action === Action.DECLINE);
	form.find(".decline-field").attr("disabled", action === Action.ACCEPT);
	
	if (!modal.find(classSelector).length) {
		
		form.trigger("submit");
		return;
	}
	
	var config = {
			
		otherClose: '.close',
		
		afterContent: function(){
			var feather = this;
			feather.$content.removeClass("no-sections");
			
			var $inputFields = feather.$content.find(classSelector);
			var $submitButton = feather.$content.find('input.submit');
			
			function submit() {
				
				$inputFields.each(function(){
					
					form.find(classSelector + '[name="' + this.name + '"]').val(this.value);
				});
				
				form.trigger("submit");
			}
			
			$submitButton.on("click", function(){
				
				submit();
			})
			
			$inputFields.on("keypress", function(e){
				
				if (e.which === 13) {
					
					submit();
				}
			});
			
			$inputFields.first().trigger("focus");
		},
	};
	
	$.featherlight(modal, config);
}