package com.nordicpeak.flowengine.queries.childinfoquery;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.queries.basequery.BaseQueryCRUD;
import com.nordicpeak.flowengine.queries.childinfoquery.beans.ChildInfoQuery;

public class ChildInfoQueryCRUD extends BaseQueryCRUD<ChildInfoQuery, ChildInfoQueryProviderModule> {

	protected AnnotatedDAOWrapper<ChildInfoQuery, Integer> queryDAO;

	public ChildInfoQueryCRUD(AnnotatedDAOWrapper<ChildInfoQuery, Integer> queryDAO, BeanRequestPopulator<ChildInfoQuery> populator, String typeElementName, String typeLogName, String listMethodAlias, ChildInfoQueryProviderModule callback) {

		super(ChildInfoQuery.class, queryDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);

		this.queryDAO = queryDAO;
	}

	@Override
	protected ChildInfoQuery populateFromUpdateRequest(ChildInfoQuery bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {

		ChildInfoQuery query = super.populateFromUpdateRequest(bean, req, user, uriParser);

		List<ValidationError> validationErrors = new ArrayList<ValidationError>();

		this.populateQueryDescriptor((QueryDescriptor) query.getQueryDescriptor(), req, validationErrors);

		if (!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}

		return query;
	}

}
