package com.nordicpeak.flowengine.coloredtag.beans;

import java.io.Serializable;
import java.lang.reflect.Field;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flowengine_colored_tag_mapping")
@XMLElement(name = "Mapping")
public class ColoredTagMapping extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -5166683291745202612L;

	public static final Field FIELD_FLOW_INSTANCE_ID = ReflectionUtils.getField(ColoredTagMapping.class, "flowInstanceID");
	public static final Field FIELD_TAG = ReflectionUtils.getField(ColoredTagMapping.class, "tag");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer mappingID;

	@DAOManaged
	@XMLElement
	private Integer flowInstanceID;

	@DAOManaged(columnName = "tagID")
	@ManyToOne
	@XMLElement(fixCase = true)
	private ColoredTag tag;

	@Override
	public String toString() {

		return "(mappingID=" + mappingID + ", flowInstanceID=" + flowInstanceID;
	}

	public Integer getMappingID() {

		return mappingID;
	}

	public void setMappingID(Integer mappingID) {

		this.mappingID = mappingID;
	}

	public Integer getFlowInstanceID() {

		return flowInstanceID;
	}

	public void setFlowInstanceID(Integer flowInstanceID) {

		this.flowInstanceID = flowInstanceID;
	}

	public ColoredTag getTag() {

		return tag;
	}

	public void setTag(ColoredTag tag) {

		this.tag = tag;
	}

}
