package com.nordicpeak.flowengine.coloredtag.daos;

import java.lang.reflect.Field;
import java.sql.SQLException;

import javax.sql.DataSource;

import se.unlogic.standardutils.dao.AnnotatedDAO;
import se.unlogic.standardutils.dao.AnnotatedDAOFactory;
import se.unlogic.standardutils.dao.HighLevelQuery;
import se.unlogic.standardutils.dao.QueryParameterFactory;

import com.nordicpeak.flowengine.coloredtag.beans.ColoredTag;

public class ColoredTagDAO extends AnnotatedDAO<ColoredTag> {

	private final QueryParameterFactory<ColoredTag, Integer> tagIDParamFactory;

	public ColoredTagDAO(DataSource dataSource, Class<ColoredTag> beanClass, AnnotatedDAOFactory daoFactory) {

		super(dataSource, beanClass, daoFactory);

		tagIDParamFactory = this.getParamFactory(ColoredTag.FIELD_TAG_ID, Integer.class);
	}

	public ColoredTag get(Integer tagID, Field... relations) throws SQLException {

		HighLevelQuery<ColoredTag> query = new HighLevelQuery<>();

		query.addParameter(tagIDParamFactory.getParameter(tagID));

		if (relations != null) {

			query.addRelations(relations);
		}

		return this.get(query);
	}

}
