package com.nordicpeak.flowengine.queries.constructionpermit.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "construction_permit_models")
@XMLElement
public class Model extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 3453656108469555916L;

	public static final Field ROOT_NODES_RELATION = ReflectionUtils.getField(Model.class, "rootNodes");
	
	@DAOManaged
	@Key
	@XMLElement
	private String modelID;

	@DAOManaged
	@OrderBy
	@XMLElement
	private String name;

	@DAOManaged
	@OneToMany
	@XMLElement(fixCase = true)
	private List<PermitNode> rootNodes;

	@DAOManaged
	@OneToMany
	private List<ConstructionPermitQuery> queries;

	public String getModelID() {

		return modelID;
	}

	public void setModelID(String modelID) {

		this.modelID = modelID;
	}

	public String getName() {

		return name;
	}

	public void setName(String name) {

		this.name = name;
	}

	public List<ConstructionPermitQuery> getQueries() {

		return queries;
	}

	public void setQueries(List<ConstructionPermitQuery> queries) {

		this.queries = queries;
	}

	public List<PermitNode> getRootNodes() {

		return rootNodes;
	}

	public void setRootNodes(List<PermitNode> rootNodes) {

		this.rootNodes = rootNodes;
	}
}
