package com.nordicpeak.flowengine.queries.constructionpermit.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

@Table(name = "construction_permit_nodes")
@XMLElement
public class PermitNode extends GeneratedElementable implements Serializable, ImmutableAlternative {

	public static final Field CHILD_NODES_RELATION = ReflectionUtils.getField(PermitNode.class, "childNodes");

	private static final long serialVersionUID = 3453656108469555916L;

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer permitNodeID;

	@DAOManaged
	@OrderBy(priority = 1)
	@XMLElement
	private String title;

	@DAOManaged
	@OrderBy(priority = 0)
	private Integer sortIndex;

	@DAOManaged
	@XMLElement
	private boolean titleNode;

	@DAOManaged
	@XMLElement
	private String longTitle;

	@DAOManaged
	@XMLElement
	private boolean requiresDescription;

	@DAOManaged
	@XMLElement
	private boolean requiresCount;

	@DAOManaged
	@XMLElement
	private boolean requiresFromToDescription;

	@DAOManaged
	@XMLElement
	private String registerTitle;
	
	@DAOManaged
	@XMLElement
	private Integer weight;

	@DAOManaged(columnName = "modelID")
	@ManyToOne
	@XMLElement
	private Model model;

	@DAOManaged(columnName = "parentNodeID")
	@ManyToOne
	@XMLElement(fixCase = true)
	private PermitNode parentNode;

	@DAOManaged
	@OneToMany
	@XMLElement(fixCase = true)
	private List<PermitNode> childNodes;

	@DAOManaged
	@OneToMany
	@XMLElement(fixCase = true)
	private List<PermitNodeValue> values;

	public Integer getPermitNodeID() {

		return permitNodeID;
	}

	public void setPermitNodeID(Integer nodeID) {

		this.permitNodeID = nodeID;
	}

	public String getTitle() {

		return title;
	}

	public void setTitle(String name) {

		this.title = name;
	}

	public Integer getSortIndex() {

		return sortIndex;
	}

	public void setSortIndex(Integer sortIndex) {

		this.sortIndex = sortIndex;
	}

	public boolean isTitleNode() {

		return titleNode;
	}

	public void setTitleNode(boolean title) {

		this.titleNode = title;
	}

	public boolean requiresDescription() {

		return requiresDescription;
	}

	public void setRequiresDescription(boolean requiresDescription) {

		this.requiresDescription = requiresDescription;
	}

	public boolean requiresCount() {

		return requiresCount;
	}

	public void setRequiresCount(boolean requiresCount) {

		this.requiresCount = requiresCount;
	}

	public boolean requiresFromToDescription() {

		return requiresFromToDescription;
	}

	public void setRequiresFromToDescription(boolean requiresFromToDescription) {

		this.requiresFromToDescription = requiresFromToDescription;
	}

	public Model getModel() {

		return model;
	}

	public void setModel(Model model) {

		this.model = model;
	}

	public PermitNode getParentNode() {

		return parentNode;
	}

	public void setParentNode(PermitNode parentNode) {

		this.parentNode = parentNode;
	}

	public List<PermitNodeValue> getValues() {

		return values;
	}

	public void setValues(List<PermitNodeValue> values) {

		this.values = values;
	}

	public List<PermitNode> getChildNodes() {

		return childNodes;
	}

	public void setChildNodes(List<PermitNode> childNodes) {

		this.childNodes = childNodes;
	}

	@Override
	public Integer getAlternativeID() {

		return permitNodeID;
	}

	@Override
	public String getExportXMLValue() {

		if (longTitle != null) {

			return longTitle;

		} else {

			return title;
		}
	}

	@Override
	public String getName() {

		return getExportXMLValue();
	}

	@Override
	public String toString() {

		return StringUtils.toLogFormat(title, 30) + " (permitNodeID: " + permitNodeID + ")";
	}

	public String getRegisterTitle() {

		return registerTitle;
	}

	public void setRegisterTitle(String registerTitle) {

		this.registerTitle = registerTitle;
	}

	public Integer getWeight() {
	
		return weight;
	}

	public void setWeight(Integer weight) {
	
		this.weight = weight;
	}

	@Override
	public String getAttributeValue() {
		
		return null;
	}
}
