package com.nordicpeak.flowengine.contactdetailsverification;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.backgroundmodules.AnnotatedBackgroundModule;
import se.unlogic.hierarchy.core.beans.SimpleBackgroundModuleResponse;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.BackgroundModuleResponse;
import se.unlogic.hierarchy.core.interfaces.modules.descriptors.BackgroundModuleDescriptor;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.URIParser;

public class ContactDetailsVerificationBackgroundModule extends AnnotatedBackgroundModule {
	
	private ContactDetailsVerificationModule parentModule;

	@Override
	protected BackgroundModuleResponse processBackgroundRequest(HttpServletRequest req, User user, URIParser uriParser) throws Exception {

		if (user != null && !parentModule.isVerified(user, req) && req.getAttribute("inVerificationProcess") == null) {
			Document doc = XMLUtils.createDomDocument();
			Element documentElement = doc.createElement("Document");
			doc.appendChild(documentElement);
			
			XMLUtils.appendNewElement(doc, documentElement, "WarningText", parentModule.getVerificationWarningText());
			XMLUtils.appendNewElement(doc, documentElement, "ConnectorURL", parentModule.getModuleURL(req));
			
			return new SimpleBackgroundModuleResponse(doc);
		}
		
		return null;
	}
	
	public void setParentModule(ContactDetailsVerificationModule parentModule) {

		this.parentModule = parentModule;
	}
	
	public BackgroundModuleDescriptor getDescriptor() {
		
		return moduleDescriptor;
	}
}