package com.nordicpeak.flowengine.culling.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flowengine_deleted_flow_instances_comments")
@XMLElement
public class CullingComment extends GeneratedElementable implements Serializable {
	
	private static final long serialVersionUID = 7254423204610179162L;
	public static final Field DELETED_FLOW_INSTANCES = ReflectionUtils.getField(CullingComment.class, "deletedFlowInstances");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer commentID;

	@DAOManaged
	@XMLElement
	private String comment;
	
	@DAOManaged
	@OneToMany
	private List<DeletedFlowInstance> deletedFlowInstances;
	
	public CullingComment() {

		super();
	}

	public CullingComment(String comment) {

		super();
		this.comment = comment;
	}


	public Integer getCullingCommentID() {
	
		return commentID;
	}

	
	public void setCullingCommentID(Integer cullingCommentID) {
	
		this.commentID = cullingCommentID;
	}

	
	public String getComment() {
	
		return comment;
	}
	
	public void setComment(String comment) {
	
		this.comment = comment;
	}
	
	public List<DeletedFlowInstance> getDeletedFlowInstances() {
	
		return deletedFlowInstances;
	}
	
	public void setDeletedFlowInstances(List<DeletedFlowInstance> deletedFlowInstances) {
	
		this.deletedFlowInstances = deletedFlowInstances;
	}
	
	
}
