package com.nordicpeak.flowengine.culling.listeners;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.xml.ElementableListener;
import se.unlogic.standardutils.xml.XMLUtils;

import com.nordicpeak.flowengine.culling.beans.DeletedFlowInstance;

public class DeletedFlowInstanceTimestampMillisecondElementableListener implements ElementableListener<DeletedFlowInstance> {

	@Override
	public void elementGenerated(Document doc, Element element, DeletedFlowInstance deletedFlowInstance) {

		if (deletedFlowInstance.getAdded() != null) {

			XMLUtils.appendNewElement(doc, element, "addedInMilliseconds", deletedFlowInstance.getAdded().getTime());
		}

		if (deletedFlowInstance.getFirstSubmitted() != null) {

			XMLUtils.appendNewElement(doc, element, "firstSubmittedInMilliseconds", deletedFlowInstance.getFirstSubmitted().getTime());
		}

		if (deletedFlowInstance.getDeleted() != null) {

			XMLUtils.appendNewElement(doc, element, "deletedInMilliseconds", deletedFlowInstance.getDeleted().getTime());
		}
	}

}
