package com.nordicpeak.flowengine.documentsigner.listeners;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.xml.ElementableListener;
import se.unlogic.standardutils.xml.XMLUtils;

import com.nordicpeak.flowengine.documentsigner.beans.DocumentSigner;

public class DocumentSignerUserTitleElementableListener implements ElementableListener<DocumentSigner> {

	private final String titleAttribute;

	public DocumentSignerUserTitleElementableListener(String titleAttribute) {
		super();
		
		this.titleAttribute = titleAttribute;
	}

	@Override
	public void elementGenerated(Document doc, Element element, DocumentSigner signer) {
		
		User user = signer.getUser();
		
		if (user != null && user.getAttributeHandler() != null && titleAttribute != null) {
			
			XMLUtils.appendNewElement(doc, element, "title", user.getAttributeHandler().getString(titleAttribute));
		}
	}

}
