<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="DynamicTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{DynamicTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<xsl:if test="not(DynamicTableQueryInstance/DynamicTableQuery/hideTitle = 'true')">
				<h2>
					<xsl:value-of select="DynamicTableQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
				</h2>	
			</xsl:if>		
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<table class="full bigmarginbottom">
				
					<thead>
					
						<xsl:apply-templates select="DynamicTableQueryInstance/DynamicTableQuery/Columns/Column" mode="thead-show" />
						
					</thead>
					
					<tbody>
					
						<xsl:apply-templates select="DynamicTableQueryInstance/Rows/Row" mode="tbody-show" />
						
					</tbody>
					
					<tfoot>
					
						<xsl:if test="DynamicTableQueryInstance/DynamicTableQuery/Columns/Column[summarise = 'true']">
							<tr>
							
								<xsl:for-each select="DynamicTableQueryInstance/DynamicTableQuery/Columns/Column">
								
									<xsl:variable name="columnIndex"><xsl:number/></xsl:variable>
									
									<xsl:choose>
										<xsl:when test="$columnIndex = 1 and not(summarise = 'true')">
										
											<td class="padding">
												<strong class="floatleft"><xsl:value-of select="$i18n.Summary"/></strong>
											</td>
										
										</xsl:when>
										<xsl:when test="$columnIndex = 1 and summarise = 'true'">
										
											<td class="padding">
												<strong class="floatleft"><xsl:value-of select="$i18n.Summary"/></strong>
												
												<xsl:if test="summarise = 'true'">
													<span class="floatright paddingright">
														<xsl:value-of select="sum"/>
													</span>
												</xsl:if>
											</td>
										
										</xsl:when>
										<xsl:otherwise>
										
											<td class="padding">
												<xsl:if test="summarise = 'true'">
													<span class="floatright paddingright">
														<xsl:value-of select="sum"/>
													</span>
												</xsl:if>
											</td>
											
										</xsl:otherwise>
									</xsl:choose>
									
								</xsl:for-each>
								
							</tr>
						</xsl:if>
					
					</tfoot>
					
				</table>
				
		</div>
		
	</xsl:template>
	
	<xsl:template match="Row" mode="tbody-show">
		<xsl:param name="columns" select="../../DynamicTableQuery/Columns"/>
		
		<tr>
			
			<xsl:apply-templates select="$columns/Column" mode="tbody-show" >
				<xsl:with-param name="rowID" select="rowID"/>
			</xsl:apply-templates>
			
		</tr>
	
	</xsl:template>

</xsl:stylesheet>