package com.nordicpeak.flowengine.easitgetitemsalternativelist;

import java.io.Serializable;
import java.util.List;

import com.nordicpeak.flowengine.alternativelist.beans.AlternativeListDescriptor;
import com.nordicpeak.flowengine.alternativelist.interfaces.AlternativeListInstance;

import se.unlogic.hierarchy.core.interfaces.attributes.AttributeHandler;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

public class EasitGetItemsAlternativeListInstance extends GeneratedElementable implements AlternativeListInstance, Serializable {

	private static final long serialVersionUID = -2907579471281781085L;

	@XMLElement
	private final AlternativeListDescriptor descriptor;

	private final List<ExternalAlternative> alternatives;

	private final ListSource listSource;

	private final long retrivedTime;

	public EasitGetItemsAlternativeListInstance(AlternativeListDescriptor descriptor, List<ExternalAlternative> alternatives, long retrivedTime, ListSource listSource) {

		super();

		this.descriptor = descriptor;
		this.alternatives = alternatives;
		this.retrivedTime = retrivedTime;
		this.listSource = listSource;
	}

	public ListSource getListSource() {

		return listSource;
	}

	@Override
	public AlternativeListDescriptor getDescriptor() {

		return descriptor;
	}

	@Override
	public List<ExternalAlternative> getAlternatives() {

		return alternatives;
	}

	public long getRetrivedTime() {

		return retrivedTime;
	}

	@Override
	public boolean requiresReload(AttributeHandler attributeHandler) {

		return false;
	}

}
