package com.nordicpeak.flowengine.externalalternativelist;

import java.io.Serializable;

import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

@XMLElement(name = "Alternative")
class ExternalAlternative extends GeneratedElementable implements ImmutableAlternative, Serializable {
	
	private static final long serialVersionUID = -5630567666409641568L;
	
	@XMLElement
	private Integer alternativeID;
	
	@XMLElement
	private String name;
	
	protected ExternalAlternative() {}
	
	public ExternalAlternative(Integer alternativeID, String name) {
		super();
		
		this.alternativeID = alternativeID;
		this.name = name;
	}
	
	public ExternalAlternative(String alternativeID, String name) {
		super();
		
		setKey(alternativeID);
		this.name = name;
	}
	
	@Override
	public Integer getAlternativeID() {
		return alternativeID;
	}
	
	@Override
	public String getName() {
		return name;
	}
	
	// Used in JSON
	public void setKey(String string) {
		
		alternativeID = Integer.parseInt(string);
	}
	
	// Used in JSON
	public void setValue(String value) {
		
		if (value != null) {
			value = StringUtils.substring(value, 255);
		}
		
		name = value;
	}
	
	@Override
	public String toString() {
		
		return name + " (ID:" + alternativeID + ")";
	}

	@Override
	public String getExportXMLValue() {
		return null;
	}

	@Override
	public String getAttributeValue() {
		return null;
	}
}
