package com.nordicpeak.flowengine.externalmessageoffer.views;

import java.sql.SQLException;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.ViewFragment;
import se.unlogic.standardutils.dao.TransactionHandler;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.beans.ExternalMessage;
import com.nordicpeak.flowengine.beans.Status;
import com.nordicpeak.flowengine.externalmessageoffer.ExternalMessageOfferProviderModule;
import com.nordicpeak.flowengine.externalmessageoffer.beans.ExternalMessageOffer;
import com.nordicpeak.flowengine.externalmessageoffer.beans.ExternalMessageOfferSettings;
import com.nordicpeak.flowengine.externalmessageoffer.enums.ExternalMessageOfferStatus;
import com.nordicpeak.flowengine.interfaces.FlowInstanceUpdateStatusFormExtensionProvider;

public class ExternalMessageOfferFormProvider implements FlowInstanceUpdateStatusFormExtensionProvider {

	private static final Logger log = Logger.getLogger(ExternalMessageOfferFormProvider.class);

	private final ExternalMessageOfferProviderModule callback;

	public ExternalMessageOfferFormProvider(ExternalMessageOfferProviderModule callback) {

		this.callback = callback;
	}

	@Override
	public ViewFragment getViewFragment(Status status, ExternalMessage message, HttpServletRequest req, User user, URIParser uriParser) {

		//TODO 

		//		Document doc = callback.createDocument(req, uriParser, user);
		//		Element showElement = XMLUtils.appendNewElement(doc, doc.getDocumentElement(), "ShowOffer");
		//
		//		ExternalMessageOffer offer = callback.getOfferDAO().getByMessageID(message.getMessageID());
		//
		//		XMLUtils.append(doc, showElement, offer);
		//
		//		return callback.getViewFragmentTransformer().createViewFragment(doc);

		return null;
	}

	@Override
	public void processRequest(Status status, ExternalMessage message, User user, TransactionHandler transactionHandler) throws SQLException {

		if (status == null || message == null) {

			return;
		}

		ExternalMessageOfferSettings settings = callback.getSettingsDAO().getByStatusID(status.getStatusID());

		if (settings != null && settings.isEnabled()) {

			ExternalMessageOffer offer = new ExternalMessageOffer();

			offer.setMessageID(message.getMessageID());
			offer.setFlowInstanceID(message.getFlowInstance().getFlowInstanceID());
			offer.setSettings(settings);
			offer.setCreated(message.getFlowInstance().getLastStatusChange());
			offer.setStatus(ExternalMessageOfferStatus.ACTIVE);

			log.info("User " + user + " adding offer " + offer + " to flow instance " + message.getFlowInstance());

			callback.getOfferDAO().add(offer, transactionHandler, null);
		}
	}

	@Override
	public void processCommittedRequest(Status status, ExternalMessage message, User user) throws SQLException {

		if (status == null || message == null) {

			return;
		}

		ExternalMessageOfferSettings settings = callback.getSettingsDAO().getByStatusID(status.getStatusID());

		if (settings != null && settings.isEnabled()) {
			
			callback.addToMessageIDCache(message.getMessageID());
		}
	}

}
