package com.nordicpeak.flowengine.queries.fixedtablequery;

import java.lang.reflect.Field;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.basetablequery.BaseTableQueryInstance;

@Table(name = "fixed_table_query_instances")
@XMLElement
public class FixedTableQueryInstance extends BaseTableQueryInstance<DropDownAlternative, FixedTableRow, FixedTableColumn, FixedTableQuery, FixedTableCellValue> {

	private static final long serialVersionUID = -8794537859820177303L;

	public static final Field VALUES_RELATION = ReflectionUtils.getField(FixedTableQueryInstance.class, "values");
	public static final Field QUERY_RELATION = ReflectionUtils.getField(FixedTableQueryInstance.class, "query");

	@DAOManaged(columnName = "queryID")
	@ManyToOne
	@XMLElement
	private FixedTableQuery query;

	@DAOManaged
	@OneToMany
	@XMLElement(fixCase = true)
	private List<FixedTableCellValue> values;

	@Override
	public FixedTableQuery getQuery() {

		return query;
	}

	@Override
	public void setQuery(FixedTableQuery query) {

		this.query = query;
	}

	@Override
	public List<FixedTableCellValue> getValues() {

		return values;
	}

	@Override
	public void setValues(List<FixedTableCellValue> values) {

		this.values = values;
	}

	@Override
	public void setValue(FixedTableCellValue cellValue) {

		values = setValue(values, cellValue);
	}

	@Override
	public String getValue(String rowIdentifier, Integer columnID) {

		return getValue(values, rowIdentifier, columnID);
	}

	@Override
	public FixedTableCellValue getCellValue(String rowIdentifier, Integer columnID) {

		return getCellValue(values, rowIdentifier, columnID);
	}

	@Override
	public List<FixedTableRow> getRows() {

		return query.getRows();
	}

}
