
$(function() {
	
	var table = $("#flowversionlist");
	
	if (table.length > 0) {
		$("#select-page").change(function(){
			var checkbox = $(this);
			
			table.find("input[type='checkbox']").prop("checked", checkbox.prop("checked"));
		});
	}
	
	$("#emailMessageHandler").on("change", function() {
			setTemplateMessage($("#emailMessage"), $(this).val());
		});
	$("#smsMessageHandler").on("change", function() {
			setTemplateMessage($("#smsMessage"), $(this).val());
		});
	$("#externalMessageHandler").on("change", function() {
			setTemplateMessage($("#externalMessage"), $(this).val());
		});
	
});

function setTemplateMessage(object, value){
	if (value != "") {
		object.val(value);
	}
}
 

$(document).on("initTable", function(event, initData) {
	
	var panel = initData.panel;
	var tableElement = initData.tableElement;
	var table = initData.table;
	
	var sendMessagesButton = panel.find(".send-messages");
	
	var isValidSendMessagesSelection = function() {
		var validSelection = true;
		
		var rows = table.rows({ selected: true });
		
		if (rows.any()) {
			
			var rowsArray = rows.toArray()[0];
		
			{
				var familyCells = table.cells(rowsArray, "familyID:name");
				var data = familyCells.data();
				var uniqueData = data.unique();
				
				if (uniqueData.count() > 1) {
					validSelection = false;
				}
			}
			
			if (validSelection && !table.isInternalSelection(rows)) {
				validSelection = false;
			}
		}
		
		return validSelection;
	};
	
	var updateSendMessagesButton = function() {
		
		if (isValidSendMessagesSelection()) {
		
			sendMessagesButton.removeClass("disabled");
		
		} else {
		
			sendMessagesButton.addClass("disabled");
		}
	}
	
	table.on('select.dt', function() {
		updateSendMessagesButton();
	});
	
	table.on('deselect.dt', function() {
		updateSendMessagesButton();
	});
	
	table.on('search.dt', function() {
		sendMessagesButton.removeClass("disabled");
	});
	
	sendMessagesButton.on("click", function() {
		
		var rows = table.rows({ selected: true });
		
		if (!rows.any()) {

			window.location = sendMessagesButton.data("baseurl");
		
		} else if (FlowInstanceAdmin2.adminFlowInstanceProviders && !table.isInternalSelection()) {
			
			alert(FlowInstanceAdmin2.i18n.requiresInternalSelection);
		
		} else if (!isValidSendMessagesSelection()) {
				
			alert(FlowInstanceAdmin2.i18n.multipleFlowFamiliesSelected);
			
		} else {
		
			var cells = table.cells(rows.toArray()[0], "instanceID:name");
			var selectedIDs = cells.data().toArray();
			
			submitSelection(selectedIDs, sendMessagesButton.data("url"));
		}
	});
});

