package com.nordicpeak.flowengine.list;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Writer;
import java.lang.reflect.Field;
import java.net.SocketException;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.zip.ZipOutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import javax.sql.rowset.serial.SerialBlob;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUploadBase.SizeLimitExceededException;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.io.FilenameUtils;
import org.apache.log4j.Level;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.emailutils.framework.Attachment;
import se.unlogic.emailutils.framework.EmailUtils;
import se.unlogic.emailutils.framework.SimpleEmail;
import se.unlogic.emailutils.populators.EmailPopulator;
import se.unlogic.fileuploadutils.MultipartRequest;
import se.unlogic.hierarchy.core.annotations.CheckboxSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.GroupMultiListSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.InstanceManagerDependency;
import se.unlogic.hierarchy.core.annotations.ModuleSetting;
import se.unlogic.hierarchy.core.annotations.TextFieldSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.WebPublic;
import se.unlogic.hierarchy.core.annotations.XSLVariable;
import se.unlogic.hierarchy.core.beans.LinkTag;
import se.unlogic.hierarchy.core.beans.ScriptTag;
import se.unlogic.hierarchy.core.beans.SimpleAccessInterface;
import se.unlogic.hierarchy.core.beans.SimpleForegroundModuleResponse;
import se.unlogic.hierarchy.core.beans.SimpleSMS;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.enums.CRUDAction;
import se.unlogic.hierarchy.core.enums.EventTarget;
import se.unlogic.hierarchy.core.events.CRUDEvent;
import se.unlogic.hierarchy.core.exceptions.AccessDeniedException;
import se.unlogic.hierarchy.core.exceptions.ModuleConfigurationException;
import se.unlogic.hierarchy.core.exceptions.URINotFoundException;
import se.unlogic.hierarchy.core.interfaces.AccessInterface;
import se.unlogic.hierarchy.core.interfaces.ForegroundModuleResponse;
import se.unlogic.hierarchy.core.interfaces.SectionInterface;
import se.unlogic.hierarchy.core.interfaces.attributes.AttributeHandler;
import se.unlogic.hierarchy.core.interfaces.modules.descriptors.ForegroundModuleDescriptor;
import se.unlogic.hierarchy.core.interfaces.sms.SMSSender;
import se.unlogic.hierarchy.core.utils.AccessUtils;
import se.unlogic.hierarchy.core.utils.FileItemAttachment;
import se.unlogic.hierarchy.core.utils.ModuleUtils;
import se.unlogic.hierarchy.core.utils.ModuleViewFragmentTransformer;
import se.unlogic.hierarchy.core.utils.ViewFragmentModule;
import se.unlogic.hierarchy.core.utils.extensionlinks.ExtensionLink;
import se.unlogic.hierarchy.core.utils.extensionlinks.ExtensionLinkProvider;
import se.unlogic.hierarchy.core.validationerrors.FileSizeLimitExceededValidationError;
import se.unlogic.hierarchy.core.validationerrors.RequestSizeLimitExceededValidationError;
import se.unlogic.hierarchy.foregroundmodules.AnnotatedForegroundModule;
import se.unlogic.hierarchy.foregroundmodules.staticcontent.StaticContentModule;
import se.unlogic.hierarchy.foregroundmodules.usersessionadmin.UserNameComparator;
import se.unlogic.openhierarchy.foregroundmodules.siteprofile.interfaces.SiteProfile;
import se.unlogic.openhierarchy.foregroundmodules.siteprofile.interfaces.SiteProfileHandler;
import se.unlogic.standardutils.arrays.ArrayUtils;
import se.unlogic.standardutils.collections.CollectionUtils;
import se.unlogic.standardutils.dao.AnnotatedDAO;
import se.unlogic.standardutils.dao.HighLevelQuery;
import se.unlogic.standardutils.dao.LowLevelQuery;
import se.unlogic.standardutils.dao.QueryParameterFactory;
import se.unlogic.standardutils.dao.RelationQuery;
import se.unlogic.standardutils.dao.querys.ArrayListQuery;
import se.unlogic.standardutils.dao.querys.ObjectQuery;
import se.unlogic.standardutils.date.DateUtils;
import se.unlogic.standardutils.db.DBUtils;
import se.unlogic.standardutils.db.tableversionhandler.TableVersionHandler;
import se.unlogic.standardutils.db.tableversionhandler.UpgradeResult;
import se.unlogic.standardutils.db.tableversionhandler.XMLDBScriptProvider;
import se.unlogic.standardutils.enums.EnumUtils;
import se.unlogic.standardutils.io.BinarySizeFormater;
import se.unlogic.standardutils.io.BinarySizes;
import se.unlogic.standardutils.io.CloseUtils;
import se.unlogic.standardutils.io.FileUtils;
import se.unlogic.standardutils.json.JsonArray;
import se.unlogic.standardutils.json.JsonUtils;
import se.unlogic.standardutils.mime.MimeUtils;
import se.unlogic.standardutils.numbers.NumberUtils;
import se.unlogic.standardutils.populators.IntegerPopulator;
import se.unlogic.standardutils.streams.StreamUtils;
import se.unlogic.standardutils.string.AnnotatedBeanTagSourceFactory;
import se.unlogic.standardutils.string.SingleTagSource;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.string.TagReplacer;
import se.unlogic.standardutils.time.TimeUtils;
import se.unlogic.standardutils.validation.PositiveStringIntegerValidator;
import se.unlogic.standardutils.validation.SwedishPhoneNumberValidator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationErrorType;
import se.unlogic.standardutils.xml.XMLGeneratorDocument;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.standardutils.zip.ZipUtils;
import se.unlogic.webutils.http.HTTPUtils;
import se.unlogic.webutils.http.RequestUtils;
import se.unlogic.webutils.http.ResponseUtils;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.validation.ValidationUtils;

import com.nordicpeak.flowengine.BaseFlowModule;
import com.nordicpeak.flowengine.FlowAdminModule;
import com.nordicpeak.flowengine.FlowInstanceAdminModule;
import com.nordicpeak.flowengine.UserFlowInstanceModule;
import com.nordicpeak.flowengine.beans.Contact;
import com.nordicpeak.flowengine.beans.DefaultInstanceMetadata;
import com.nordicpeak.flowengine.beans.ExternalMessage;
import com.nordicpeak.flowengine.beans.ExternalMessageAttachment;
import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.beans.FlowFamily;
import com.nordicpeak.flowengine.beans.FlowInstance;
import com.nordicpeak.flowengine.beans.FlowInstanceEvent;
import com.nordicpeak.flowengine.beans.FlowType;
import com.nordicpeak.flowengine.beans.InternalMessage;
import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.beans.QueryInstanceDescriptor;
import com.nordicpeak.flowengine.beans.SigningParty;
import com.nordicpeak.flowengine.beans.Status;
import com.nordicpeak.flowengine.beans.Step;
import com.nordicpeak.flowengine.dao.FlowEngineDAOFactory;
import com.nordicpeak.flowengine.enums.ContentType;
import com.nordicpeak.flowengine.enums.EventType;
import com.nordicpeak.flowengine.enums.SenderType;
import com.nordicpeak.flowengine.events.ExternalMessageAddedEvent;
import com.nordicpeak.flowengine.events.ManagersChangedEvent;
import com.nordicpeak.flowengine.events.StatusChangedByManagerEvent;
import com.nordicpeak.flowengine.interfaces.ImmutableFlow;
import com.nordicpeak.flowengine.interfaces.ImmutableFlowInstanceEvent;
import com.nordicpeak.flowengine.interfaces.MultiSigningHandler;
import com.nordicpeak.flowengine.interfaces.PDFExportFilter;
import com.nordicpeak.flowengine.interfaces.PDFProvider;
import com.nordicpeak.flowengine.interfaces.QueryHandler;
import com.nordicpeak.flowengine.managers.ImmutableFlowInstanceManager;
import com.nordicpeak.flowengine.notifications.StandardFlowNotificationHandler;
import com.nordicpeak.flowengine.utils.ExternalMessageUtils;
import com.nordicpeak.flowengine.utils.FlowFamilyUtils;
import com.nordicpeak.flowengine.utils.FlowInstanceEventGenerator;
import com.nordicpeak.flowengine.utils.FlowInstanceUtils;
import com.nordicpeak.flowengine.utils.MultiSignUtils;
import com.nordicpeak.flowengine.utils.SigningUtils;

public class FlowInstanceListModule extends AnnotatedForegroundModule implements ExtensionLinkProvider, ViewFragmentModule<ForegroundModuleDescriptor> {
	
	private static final String CITIZEN_IDENTIFIER = "citizenIdentifier";
	private static final String ORGANIZATION_NUMBER = "organizationNumber";

	protected static final List<Field> LIST_FLOW_FAMILIES_IGNORED_FIELDS = Arrays.asList(FlowType.ALLOWED_ADMIN_GROUPS_RELATION, FlowType.ALLOWED_QUERIES_RELATION, FlowType.ALLOWED_ADMIN_USERS_RELATION, FlowType.CATEGORIES_RELATION, Flow.STATUSES_RELATION, Flow.DEFAULT_FLOW_STATE_MAPPINGS_RELATION, Flow.STEPS_RELATION, Flow.TAGS_RELATION, FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION);
	protected static final List<Field> LIST_FLOW_VERSIONS_IGNORED_FIELDS = Arrays.asList(FlowType.ALLOWED_ADMIN_GROUPS_RELATION, FlowType.ALLOWED_QUERIES_RELATION, FlowType.ALLOWED_ADMIN_USERS_RELATION, FlowType.CATEGORIES_RELATION, Flow.STATUSES_RELATION, Flow.DEFAULT_FLOW_STATE_MAPPINGS_RELATION, Flow.TAGS_RELATION, FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION, Flow.FLOW_TYPE_RELATION);
	protected static final List<Field> LIST_FLOW_INSTANCES_IGNORED_FIELDS = Arrays.asList(FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION);

	protected static final Field[] FLOW_INSTANCE_RELATIONS_FOR_EVENTS = { FlowInstance.FLOW_RELATION, Flow.FLOW_FAMILY_RELATION, FlowInstance.OWNERS_RELATION, FlowInstance.STATUS_RELATION };
	protected static final Field[] FLOW_INSTANCE_CACHED_RELATIONS_FOR_EVENTS = { FlowInstance.FLOW_RELATION, Flow.FLOW_FAMILY_RELATION, FlowInstance.STATUS_RELATION };

	protected static final List<ContentType> ALLOWED_CONTENT_TYPES = Arrays.asList(new ContentType[] { ContentType.NEW, ContentType.WAITING_FOR_MULTISIGN, ContentType.WAITING_FOR_PAYMENT, ContentType.SUBMITTED, ContentType.WAITING_FOR_COMPLETION, ContentType.IN_PROGRESS, ContentType.ARCHIVED });

	protected static final ValidationError FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR = new ValidationError("FlowFamilyNotFound");
	protected static final ValidationError FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR = new ValidationError("FlowFamilyAccessDenied");
	protected static final ValidationError NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR = new ValidationError("NoFlowVersionsSelected");
	protected static final ValidationError NO_RECIPIENTS_VALIDATION_ERROR = new ValidationError("NoRecipients");
	protected static final ValidationError NO_CONTENT_TYPES_VALIDATION_ERROR = new ValidationError("NoContentTypesSelected");
	protected static final ValidationError NO_MULTISIGN_TYPES_VALIDATION_ERROR = new ValidationError("NoMultiSignTypesSelected");
	protected static final ValidationError NO_MESSAGE_PATH_VALIDATION_ERROR = new ValidationError("NoMessagePathSelected");
	protected static final ValidationError ONE_OR_MORE_SELECTED_MANAGER_USERS_NOT_FOUND_VALIDATION_ERROR = new ValidationError("OneOrMoreSelectedManagerUsersNotFoundError");
	protected static final ValidationError NO_MANAGERS_SELECTED_VALIDATION_ERROR = new ValidationError("NoManagersSelected");
	protected static final ValidationError SIZE_LIMIT_EXCEEDED_VALIDATION_ERROR = new ValidationError("SizeLimitExceeded");
	protected static final ValidationError UNABLE_TO_PARSE_REQUEST_VALIDATION_ERROR = new ValidationError("UnableToParseRequest");

	private static final AnnotatedBeanTagSourceFactory<Flow> FLOW_TAG_SOURCE_FACTORY = new AnnotatedBeanTagSourceFactory<Flow>(Flow.class, "$flow.");
	private static final AnnotatedBeanTagSourceFactory<FlowInstance> FLOWINSTANCE_TAG_SOURCE_FACTORY = new AnnotatedBeanTagSourceFactory<FlowInstance>(FlowInstance.class, "$flowInstance.");
	private static final AnnotatedBeanTagSourceFactory<Contact> CONTACT_TAG_SOURCE_FACTORY = new AnnotatedBeanTagSourceFactory<Contact>(Contact.class, "$contact.");

	private static final EmailPopulator EMAIL_POPULATOR = new EmailPopulator();

	@XSLVariable(prefix = "java.")
	private String anonymousSubmitter = "Anonymous Submitter";

	@XSLVariable(prefix = "java.")
	private String extensionViewTitle = "unset";
	
	@ModuleSetting(allowsNull = true)
	@GroupMultiListSettingDescriptor(name = "Global access groups", description = "Groups with access to export all flows")
	protected List<Integer> globalAccessGroups;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Default instance list page size", description = "", formatValidator = PositiveStringIntegerValidator.class, required = true)
	protected Integer defaultPageSize = 15;

	@ModuleSetting(allowsNull = true)
	@TextFieldSettingDescriptor(name = "Temp dir", description = "Directory for temporary files. Should be on the same filesystem as the file store for best performance. If not set system default temp directory will be used")
	protected String tempDir;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Max request size", description = "Maxmium allowed request size in megabytes", required = true, formatValidator = PositiveStringIntegerValidator.class)
	protected Integer maxRequestSize = 1000;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "RAM threshold", description = "Maximum size of files in KB to be buffered in RAM during file uploads. Files exceeding the threshold are written to disk instead.", required = true, formatValidator = PositiveStringIntegerValidator.class)
	protected Integer ramThreshold = 500;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Max e-mail file size", description = "Maxmium allowed file size in megabytes for e-mail attachments", required = true, formatValidator = PositiveStringIntegerValidator.class)
	protected Integer maxEmailFileSize = 50;

	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Max external message file size", description = "Maxmium allowed file size in megabytes for external message attachments", required = true, formatValidator = PositiveStringIntegerValidator.class)
	protected Integer maxExternalMessageFileSize = 50;

	@ModuleSetting
	@CheckboxSettingDescriptor(name = "Use default sender address from notification handler", description = "Controls if default sender adress from notification handler should be used when sending emails from this module.")
	protected boolean useDefaultEmailSenderAddress;
	
	@ModuleSetting
	@TextFieldSettingDescriptor(name="Provider priority", description="The priority of this provider", required=true)
	private Integer priority = 0;
	
	@ModuleSetting
	@CheckboxSettingDescriptor(name = "Enable fragment XML debug", description = "Enables debugging of fragment XML")
	private boolean debugFragmententXML;
	
	@InstanceManagerDependency
	protected UserFlowInstanceModule userFlowInstanceModule;

	@InstanceManagerDependency(required = true)
	protected QueryHandler queryHandler;

	@InstanceManagerDependency(required = true)
	protected FlowAdminModule flowAdminModule;

	@InstanceManagerDependency
	protected SiteProfileHandler siteProfileHandler;

	@InstanceManagerDependency(required = true)
	protected StandardFlowNotificationHandler flowNotificationHandler;

	@InstanceManagerDependency
	protected SMSSender smsSender;

	@InstanceManagerDependency
	protected PDFProvider pdfProvider;

	@InstanceManagerDependency
	protected MultiSigningHandler multiSigningHandler;

	protected FlowInstanceAdminModule flowInstanceAdminModule;

	protected StaticContentModule staticContentModule;

	protected AccessInterface globalAccess;

	private AnnotatedDAO<FlowInstance> flowInstanceDAO;
	protected FlowEngineDAOFactory daoFactory;

	private QueryParameterFactory<Status, Integer> statusIDParamFactory;
	private QueryParameterFactory<Status, Flow> statusFlowParamFactory;
	protected QueryParameterFactory<FlowInstance, Integer> flowInstanceIDParamFactory;
	protected QueryParameterFactory<FlowFamily, Integer> flowFlowFamilyIDParamFactory;
	protected QueryParameterFactory<FlowInstance, Timestamp> flowInstanceFirstSubmittedParamFactory;
	protected QueryParameterFactory<FlowInstance, Flow> flowInstanceFlowParamFactory;
	protected QueryParameterFactory<QueryInstanceDescriptor, Integer> queryInstanceDescriptorFlowInstanceIDParamFactory;
	protected QueryParameterFactory<QueryInstanceDescriptor, QueryDescriptor> queryInstanceDescriptorQueryDescriptorParamFactory;

	protected FlowInstanceEventGenerator flowInstanceEventGenerator;

	protected ExtensionLink overviewExtensionLink;
	
	protected CopyOnWriteArrayList<PDFExportFilter> pdfExportFilters = new CopyOnWriteArrayList<PDFExportFilter>();

	private ModuleViewFragmentTransformer<ForegroundModuleDescriptor> viewFragmentTransformer;
	
	@Override
	protected void createDAOs(DataSource dataSource) throws Exception {
		
		//Automatic table version handling
		UpgradeResult upgradeResult = TableVersionHandler.upgradeDBTables(dataSource, FlowInstanceListModule.class.getName(), new XMLDBScriptProvider(FlowInstanceListModule.class.getResourceAsStream("DB script.xml")));

		if (upgradeResult.isUpgrade()) {

			log.info(upgradeResult.toString());
		}

		daoFactory = new FlowEngineDAOFactory(dataSource, systemInterface.getUserHandler(), systemInterface.getGroupHandler());

		flowInstanceDAO = daoFactory.getFlowInstanceDAO();
		flowInstanceIDParamFactory = flowInstanceDAO.getParamFactory("flowInstanceID", Integer.class);
		flowInstanceFirstSubmittedParamFactory = flowInstanceDAO.getParamFactory("firstSubmitted", Timestamp.class);
		flowInstanceFlowParamFactory = flowInstanceDAO.getParamFactory("flow", Flow.class);
		
		statusIDParamFactory = daoFactory.getStatusDAO().getParamFactory("statusID", Integer.class);
		statusFlowParamFactory = daoFactory.getStatusDAO().getParamFactory("flow", Flow.class);

		queryInstanceDescriptorFlowInstanceIDParamFactory = daoFactory.getQueryInstanceDescriptorDAO().getParamFactory("flowInstanceID", Integer.class);
		queryInstanceDescriptorQueryDescriptorParamFactory = daoFactory.getQueryInstanceDescriptorDAO().getParamFactory("queryDescriptor", QueryDescriptor.class);

		flowInstanceEventGenerator = new FlowInstanceEventGenerator(daoFactory);
	}

	@Override
	protected void moduleConfigured() throws Exception {

		this.globalAccess = new SimpleAccessInterface(globalAccessGroups, null);

		if (ModuleUtils.checkRequiredModuleSettings(moduleDescriptor, this, systemInterface, Level.ERROR)) {

			generateOverviewExtensionLink(staticContentModule);
		}
		
		this.viewFragmentTransformer = new ModuleViewFragmentTransformer<ForegroundModuleDescriptor>(sectionInterface.getForegroundModuleXSLTCache(), this, systemInterface.getEncoding());

		this.viewFragmentTransformer.setDebugXML(debugFragmententXML);

	}

	@Override
	public void init(ForegroundModuleDescriptor moduleDescriptor, SectionInterface sectionInterface, DataSource dataSource) throws Exception {

		super.init(moduleDescriptor, sectionInterface, dataSource);

		if (!systemInterface.getInstanceHandler().addInstance(FlowInstanceListModule.class, this)) {

			throw new RuntimeException("Unable to register module in global instance handler using key " + FlowInstanceListModule.class.getSimpleName() + ", another instance is already registered using this key.");
		}
	}
	
	@Override
	public void unload() throws Exception {

		if (flowInstanceAdminModule != null) {

			flowInstanceAdminModule.removeOverviewExtensionLinkProvider(this);
		}
		
		systemInterface.getInstanceHandler().removeInstance(FlowInstanceListModule.class, this);

		super.unload();
	}

	@Override
	public ForegroundModuleResponse defaultMethod(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		return listFlowFamilies(req, res, user, uriParser, null);
	}

	public ForegroundModuleResponse listFlowFamilies(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, ValidationError validationError) throws ModuleConfigurationException, SQLException {

		log.info("User " + user + " listing families");

		Document doc = this.createDocument(req, uriParser, user);

		Element listFamiliesElement = doc.createElement("ListFamilies");
		doc.getDocumentElement().appendChild(listFamiliesElement);

		XMLGeneratorDocument generatorDocument = new XMLGeneratorDocument(doc);
		generatorDocument.setIgnoredFields(LIST_FLOW_FAMILIES_IGNORED_FIELDS);

		Collection<Flow> flows = flowAdminModule.getCachedFlows();

		if (!AccessUtils.checkAccess(user, globalAccess)) {

			//Check access and append flows
			for (Flow flow : flows) {

				if (flow.isInternal() && hasAccess(user, flow.getFlowFamily()) && flow.isLatestVersion()) {

					Element flowElement = flow.toXML(generatorDocument);

					flowAdminModule.appendFamilyInformation(doc, flowElement, flow, flows);

					listFamiliesElement.appendChild(flowElement);
				}
			}

		} else {

			for (Flow flow : flows) {

				if (flow.isLatestVersion() && flow.isInternal()) {
					Element flowElement = flow.toXML(generatorDocument);

					flowAdminModule.appendFamilyInformation(doc, flowElement, flow, flows);

					listFamiliesElement.appendChild(flowElement);
				}
			}
		}

		if (validationError != null) {

			XMLUtils.append(doc, listFamiliesElement, validationError);
		}

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	@WebPublic(alias = "family")
	public ForegroundModuleResponse listFlowVersions(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		return listFlowVersions(req, res, user, uriParser, null);
	}

	public ForegroundModuleResponse listFlowVersions(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, List<ValidationError> validationErrors) throws Throwable {

		Integer flowFamilyID = uriParser.getInt(2);

		FlowFamily flowFamily;

		if (flowFamilyID == null || (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) == null) {

			return listFlowFamilies(req, res, user, uriParser, FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR);

		} else if (!hasAccess(user, flowFamily)) {

			return listFlowFamilies(req, res, user, uriParser, FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR);
		}

		log.info("User " + user + " listing flow versions in flow family " + flowFamily);

		XMLGeneratorDocument doc = new XMLGeneratorDocument(createDocument(req, uriParser, user));
		doc.setIgnoredFields(LIST_FLOW_VERSIONS_IGNORED_FIELDS);

		Element listVersionsElement = doc.createElement("ListFlowVersions");

		doc.getDocumentElement().appendChild(listVersionsElement);

		listVersionsElement.appendChild(flowFamily.toXML(doc));

		List<Flow> flowVersions = flowAdminModule.getFlowVersions(flowFamily);

		XMLUtils.append(doc, listVersionsElement, flowVersions);

		if (validationErrors != null) {

			XMLUtils.append(doc, listVersionsElement, validationErrors);
			listVersionsElement.appendChild(RequestUtils.getRequestParameters(req, doc, "flowID"));
		}

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	@WebPublic(alias = "instances")
	public ForegroundModuleResponse listFlowInstances(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		FlowSelection flowSelection = getFlowSelection(req, res, user, uriParser, true);

		if (flowSelection.getErrorResponse() != null) {

			return flowSelection.getErrorResponse();
		}

		log.info("User " + user + " listing flow instances in flow selection" + flowSelection);

		XMLGeneratorDocument doc = new XMLGeneratorDocument(createDocument(req, uriParser, user));
		doc.setIgnoredFields(LIST_FLOW_INSTANCES_IGNORED_FIELDS);

		Element listInstancesElement = doc.createElement("ListFlowInstances");
		doc.getDocumentElement().appendChild(listInstancesElement);

		XMLUtils.appendNewElement(doc, listInstancesElement, "PageSize", defaultPageSize);

		if (flowInstanceAdminModule != null) {
			XMLUtils.appendNewElement(doc, listInstancesElement, "ServerURL", RequestUtils.getServerURL(req));
			XMLUtils.appendNewElement(doc, listInstancesElement, "FlowInstanceAdminFullAlias", flowInstanceAdminModule.getFullAlias());
		}

		listInstancesElement.appendChild(flowSelection.toXML(doc));

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	@WebPublic(alias = "instancedata")
	public ForegroundModuleResponse getFlowInstanceData(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		FlowSelection flowSelection = getFlowSelection(req, res, user, uriParser, true);

		log.info("Sending flow instances in flow selection " + flowSelection + " to User " + user);

		res.setCharacterEncoding(systemInterface.getEncoding());
		res.setContentType(JsonUtils.getContentType());

		Writer writer = ResponseUtils.getCompressedRequestWriter(req, res);

		try {
			if (flowSelection.getErrorResponse() != null) {

				writer.append("{\"error\": true");
				return null;
			}

			List<Flow> flowVersions;

			if (flowSelection.getFlows() != null) {

				flowVersions = flowSelection.getFlows();

			} else {

				flowVersions = flowAdminModule.getFlowVersions(flowSelection.getFlowFamily());
			}

			writer.append("{\"rows\":[");
			
			if (!CollectionUtils.isEmpty(flowVersions)) {

				boolean appendCommaIfAnotherRow = false;

				for (Flow flow : flowVersions) {

					List<FlowInstance> flowInstances = getFlowInstances(flow, flowSelection.getFromDate(), flowSelection.getToDate(), null, user, false, FlowInstance.STATUS_RELATION, FlowInstance.ATTRIBUTES_RELATION, FlowInstance.INTERNAL_MESSAGES_RELATION, FlowInstance.EXTERNAL_MESSAGES_RELATION);

					if (!CollectionUtils.isEmpty(flowInstances)) {

						if (appendCommaIfAnotherRow) {
							writer.append(",");

							appendCommaIfAnotherRow = false;
						}

						JsonArray row = new JsonArray(8);

						for (Iterator<FlowInstance> instanceIterator = flowInstances.iterator(); instanceIterator.hasNext();) {

							FlowInstance flowInstance = instanceIterator.next();

							row.addNode("");
							row.addNode(flowInstance.getFlowInstanceID());
							row.addNode(FlowInstanceUtils.getSubmitterName(flowInstance, anonymousSubmitter));
							row.addNode(flowInstance.getStatus().getName());
							row.addNode(flowInstance.getFirstSubmitted() != null ? DateUtils.DATE_TIME_FORMATTER.format(flowInstance.getFirstSubmitted()) : "");
							row.addNode(flow.getName());
							row.addNode(flow.getVersion());

							StringBuilder searchExtraBuilder = new StringBuilder();

							AttributeHandler attributeHandler = flowInstance.getAttributeHandler();

							String citizenIdentifier = attributeHandler.getString(CITIZEN_IDENTIFIER);

							if (citizenIdentifier == null && flowInstance.getPoster() != null) {

								citizenIdentifier = flowInstance.getPoster().getAttributeHandler().getString(CITIZEN_IDENTIFIER);
							}

							if (citizenIdentifier != null) {

								searchExtraBuilder.append(citizenIdentifier);
								searchExtraBuilder.append(" ");
							}

							if (flowInstance.getOwners() != null) {

								for (User owner : flowInstance.getOwners()) {

									if (owner.getAttributeHandler().isSet(CITIZEN_IDENTIFIER)) {

										searchExtraBuilder.append(owner.getAttributeHandler().getString(CITIZEN_IDENTIFIER));
										searchExtraBuilder.append(" ");
									}
								}
							}

							String organizationNumber = attributeHandler.getString(ORGANIZATION_NUMBER);

							if (organizationNumber != null) {

								searchExtraBuilder.append(organizationNumber);
								searchExtraBuilder.append(" ");
							}

							if (flowInstance.getInternalMessages() != null) {

								for (InternalMessage message : flowInstance.getInternalMessages()) {

									searchExtraBuilder.append(message.getMessage());
									searchExtraBuilder.append(" ");
								}
							}

							if (flowInstance.getExternalMessages() != null) {

								for (ExternalMessage message : flowInstance.getExternalMessages()) {

									searchExtraBuilder.append(message.getMessage());
									searchExtraBuilder.append(" ");
								}
							}

							row.addNode(searchExtraBuilder.toString());

							writer.append(row.toJson());

							row.clearNodes();

							if (instanceIterator.hasNext()) {

								writer.append(",");

							} else {

								appendCommaIfAnotherRow = true;
							}
						}
					}
				}
			}

			writer.append("]}");
			
		} catch (IOException e) {
			
			log.warn("Error sending flow instance data to " + user, e);
			
		} catch (Exception e) {
			
			log.error("Error sending flow instance data to " + user, e);
			writer.append("{\"rows\": [], \"error\": \"Internal error\"}");
			
		} finally {
			try {
				writer.close();
			} catch (IOException e) {}
		}
		
		return null;
	}

	@WebPublic
	public ForegroundModuleResponse sendMessages(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		Document doc = createDocument(req, uriParser, user);
		Element sendMessageElement = XMLUtils.appendNewElement(doc, doc.getDocumentElement(), "SendMessageForm");

		XMLUtils.appendNewElement(doc, sendMessageElement, "FormatedMaxEmailFileSize", BinarySizeFormater.getFormatedSize(maxEmailFileSize * BinarySizes.MegaByte));
		XMLUtils.appendNewElement(doc, sendMessageElement, "FormatedMaxExternalMessageFileSize", BinarySizeFormater.getFormatedSize(maxExternalMessageFileSize * BinarySizes.MegaByte));

		FlowSelection flowSelection = null;
		SiteProfile siteProfile = null;
		List<ValidationError> validationErrors = new ArrayList<ValidationError>();

		try {

			if (MultipartRequest.isMultipartRequest(req)) {

				req = MultipartRequest.getMultipartRequest(this.ramThreshold * BinarySizes.KiloByte, this.maxRequestSize * BinarySizes.MegaByte, tempDir, req);
			}

		} catch (SizeLimitExceededException e) {

			validationErrors.add(new RequestSizeLimitExceededValidationError(e.getActualSize(), e.getPermittedSize()));

		} catch (FileUploadException e) {

			validationErrors.add(new ValidationError("UnableToParseRequest"));
		}

		flowSelection = getFlowSelection(req, res, user, uriParser);

		if (flowSelection.getErrorResponse() != null) {

			return flowSelection.getErrorResponse();
		}

		siteProfile = getCurrentSiteProfile(req, user, uriParser);

		boolean hasRecipients = false;

		for (Flow flow : flowSelection.getFlows()) {

			int flowInstances = getFlowInstanceCount(flow, flowSelection.getFromDate(), flowSelection.getToDate(), ALLOWED_CONTENT_TYPES, user);

			if (flowInstances > 0) {
				hasRecipients = true;
				break;
			}
		}

		if (!hasRecipients) {
			validationErrors.add(NO_RECIPIENTS_VALIDATION_ERROR);
		}

		if (req.getMethod().equals("POST")) {

			boolean sendEmail = !StringUtils.isEmpty(req.getParameter("send-email"));
			boolean sendSMS = !StringUtils.isEmpty(req.getParameter("send-sms"));
			boolean sendExternalMessage = !StringUtils.isEmpty(req.getParameter("send-external-message"));

			if (!sendEmail && !sendSMS && !sendExternalMessage) {
				validationErrors.add(NO_MESSAGE_PATH_VALIDATION_ERROR);
			}

			String emailSenderName = ValidationUtils.validateParameter("emailSenderName", req, sendEmail, 1, 255, validationErrors);

			String emailSenderAddress = null;

			if (useDefaultEmailSenderAddress) {
				emailSenderAddress = flowNotificationHandler.getEmailSenderAddress();
			} else {
				emailSenderAddress = ValidationUtils.validateParameter("emailSenderAddress", req, sendEmail, EMAIL_POPULATOR, validationErrors);
			}

			String emailSubject = ValidationUtils.validateParameter("emailSubject", req, sendEmail, 1, 255, validationErrors);
			String emailMessage = ValidationUtils.validateParameter("emailMessage", req, sendEmail, 1, 65535, validationErrors);

			String smsMessage = ValidationUtils.validateParameter("smsMessage", req, sendSMS, 1, null, validationErrors);

			String externalMessage = ValidationUtils.validateParameter("externalMessage", req, sendExternalMessage, 1, null, validationErrors);

			boolean multiSignOwnerSigned = !StringUtils.isEmpty(req.getParameter("multisign_owner_signed"));
			boolean multiSignNotSigned = !StringUtils.isEmpty(req.getParameter("multisign_user_not_signed"));

			List<ContentType> selectedContentTypes = null;

			String[] contentTypes = req.getParameterValues("contentType");

			if (!ArrayUtils.isEmpty(contentTypes)) {
				selectedContentTypes = EnumUtils.toEnum(ContentType.class, contentTypes);
			}

			if (CollectionUtils.isEmpty(selectedContentTypes)) {

				validationErrors.add(NO_CONTENT_TYPES_VALIDATION_ERROR);

			} else if (selectedContentTypes.contains(ContentType.WAITING_FOR_MULTISIGN) && !multiSignOwnerSigned && !multiSignNotSigned) { // && !multiSignOtherSigned

				validationErrors.add(NO_MULTISIGN_TYPES_VALIDATION_ERROR);
			}

			Collection<FileItem> attachedFileItemsEmail = null;
			Collection<FileItem> attachedFileItemsExternalMessage = null;

			if (req instanceof MultipartRequest && ((MultipartRequest) req).getFileCount() > 0) {

				try {

					attachedFileItemsEmail = ((MultipartRequest) req).getFiles("email-attachments");
					attachedFileItemsExternalMessage = ((MultipartRequest) req).getFiles("external-message-attachments");

					Iterator<FileItem> fileIteratorEmail = attachedFileItemsEmail.iterator();

					while (fileIteratorEmail.hasNext()) {

						FileItem fileItem = fileIteratorEmail.next();

						if (StringUtils.isEmpty(fileItem.getName()) || fileItem.getSize() == 0) {

							fileIteratorEmail.remove();
							continue;
						}

						if (fileItem.getSize() > (this.maxEmailFileSize * BinarySizes.MegaByte)) {

							validationErrors.add(new FileSizeLimitExceededValidationError(FilenameUtils.getName(fileItem.getName()), fileItem.getSize(), this.maxEmailFileSize * BinarySizes.MegaByte));

							continue;
						}
					}

					Iterator<FileItem> fileIteratorExternalMessage = attachedFileItemsExternalMessage.iterator();

					while (fileIteratorExternalMessage.hasNext()) {

						FileItem fileItem = fileIteratorExternalMessage.next();

						if (StringUtils.isEmpty(fileItem.getName()) || fileItem.getSize() == 0) {

							fileIteratorExternalMessage.remove();
							continue;
						}

						if (fileItem.getSize() > (this.maxExternalMessageFileSize * BinarySizes.MegaByte)) {

							validationErrors.add(new FileSizeLimitExceededValidationError(FilenameUtils.getName(fileItem.getName()), fileItem.getSize(), this.maxExternalMessageFileSize * BinarySizes.MegaByte));

							continue;
						}
					}

					if (validationErrors.isEmpty()) {

						List<Attachment> attachmentsEmail = new ArrayList<Attachment>(CollectionUtils.getSize(attachedFileItemsEmail));
						List<ExternalMessageAttachment> attachmentsExternalMessage = new ArrayList<ExternalMessageAttachment>(CollectionUtils.getSize(attachedFileItemsExternalMessage));

						if (sendEmail && attachedFileItemsEmail != null) {

							for (FileItem file : attachedFileItemsEmail) {

								FileItemAttachment attachment = new FileItemAttachment(file);

								attachmentsEmail.add(attachment);
							}
						}

						if (sendExternalMessage && attachedFileItemsExternalMessage != null) {

							for (FileItem file : attachedFileItemsExternalMessage) {

								ExternalMessageAttachment attachmentExternalMessage = new ExternalMessageAttachment();

								String fileName = FilenameUtils.getName(file.getName());

								attachmentExternalMessage.setFilename(fileName);
								attachmentExternalMessage.setSize(file.getSize());
								attachmentExternalMessage.setData(new SerialBlob(file.get()));

								attachmentsExternalMessage.add(attachmentExternalMessage);
							}
						}

						int sentEmails = 0;
						int sentSMSs = 0;
						int sentExternalMessages = 0;
						int flowInstanceCount = 0;

						for (Flow flow : flowSelection.getFlows()) {

							List<FlowInstance> flowInstances = getFlowInstances(flow, flowSelection.getFromDate(), flowSelection.getToDate(), selectedContentTypes, user, true, FlowInstance.STATUS_RELATION, FlowInstance.FLOW_RELATION, FlowInstance.OWNERS_RELATION, FlowInstance.EVENTS_RELATION, FlowInstanceEvent.ATTRIBUTES_RELATION);

							if (!CollectionUtils.isEmpty(flowInstances)) {

								for (FlowInstance flowInstance : flowInstances) {

									flowInstanceCount++;

									List<Contact> contacts = flowNotificationHandler.getContactsFromDB(flowInstance);
									HashMap<String, SigningParty> signingPartiesMap = null;

									if (flowInstance.getStatus().getContentType() == ContentType.WAITING_FOR_MULTISIGN) {

										signingPartiesMap = new HashMap<String, SigningParty>();

										//TODO get signing parties from new signing module
										ImmutableFlowInstanceManager instanceManager = new ImmutableFlowInstanceManager(getFlowInstanceForManager(flowInstance.getFlowInstanceID()), queryHandler, req, new DefaultInstanceMetadata(siteProfile), null);

										Set<SigningParty> signingParties = MultiSignUtils.getSigningParties(instanceManager);

										for (SigningParty signingParty : signingParties) {

											Contact contact = new Contact();

											contact.setFirstname(signingParty.getFirstname());
											contact.setLastname(signingParty.getLastname());
											contact.setEmail(signingParty.getEmail());
											contact.setMobilePhone(signingParty.getMobilePhone());
											contact.setCitizenIdentifier(signingParty.getSocialSecurityNumber());

											contact.setContactBySMS(true);
											contact.setContactByEmail(true);

											FlowInstanceUtils.addUniqueContact(contacts, contact);

											signingPartiesMap.put(signingParty.getSocialSecurityNumber(), signingParty);
										}
									}

									SingleTagSource urlTag;

									if (userFlowInstanceModule != null) {

										urlTag = new SingleTagSource("$flowInstance.url", RequestUtils.getFullContextPathURL(req) + userFlowInstanceModule.getFullAlias() + "/overview/" + flow.getFlowID() + "/" + flowInstance.getFlowInstanceID());

									} else {

										urlTag = null;
									}

									if (contacts != null) {

										contactLoop: for (Contact contact : contacts) {

											if (flowInstance.getStatus().getContentType() == ContentType.WAITING_FOR_MULTISIGN && !StringUtils.isEmpty(contact.getCitizenIdentifier())) {

												ImmutableFlowInstanceEvent lastSigningEvent = SigningUtils.getLastPosterSignEvent(flowInstance);
												
												SigningParty signingParty = signingPartiesMap.get(contact.getCitizenIdentifier());

												if (signingParty == null) {

													if (!CollectionUtils.isEmpty(flowInstance.getOwners())) {

														for (User owner : flowInstance.getOwners()) {

															if (contact.getCitizenIdentifier().equals(owner.getAttributeHandler().getString("citizenIdentifier"))) {

																if (!multiSignOwnerSigned) {

																	continue contactLoop;
																}

																break;
															}
														}
													}

												} else if (multiSigningHandler.partyHasSigned(flowInstance.getFlowInstanceID(), signingParty, lastSigningEvent.getAdded())) {

													if (!multiSignOwnerSigned) {

														continue;
													}

												} else if (!multiSignNotSigned) {

													continue;
												}
											}

											if (sendExternalMessage && flowInstance.getOwners() != null && flowInstance.getFirstSubmitted() != null) {

												TagReplacer tagReplacer = new TagReplacer(FLOWINSTANCE_TAG_SOURCE_FACTORY.getTagSource(flowInstance), FLOW_TAG_SOURCE_FACTORY.getTagSource(flow));

												if (urlTag != null) {
													tagReplacer.addTagSource(urlTag);
												}

												ExternalMessage message = new ExternalMessage();
												message.setAdded(TimeUtils.getCurrentTimestamp());
												message.setFlowInstance(flowInstance);
												message.setMessage(tagReplacer.replace(externalMessage));
												message.setPostedByManager(true);
												message.setPoster(user);

												if (!CollectionUtils.isEmpty(attachmentsExternalMessage)) {

													List<ExternalMessageAttachment> attachementCopy = new ArrayList<ExternalMessageAttachment>(attachmentsExternalMessage.size());
													
													for(ExternalMessageAttachment attachement : attachmentsExternalMessage) {
														
														attachementCopy.add(new ExternalMessageAttachment(attachement));
													}
													
													message.setAttachments(attachementCopy);
												}

												daoFactory.getExternalMessageDAO().add(message);

												FlowInstanceEvent flowInstanceEvent = flowInstanceEventGenerator.addFlowInstanceEvent(flowInstance, EventType.MANAGER_MESSAGE_SENT, null, user, null, ExternalMessageUtils.getFlowInstanceEventAttributes(message));

												systemInterface.getEventHandler().sendEvent(FlowInstance.class, new ExternalMessageAddedEvent(flowInstance, flowInstanceEvent, getSiteProfile(flowInstance), message, SenderType.MANAGER), EventTarget.ALL);

												systemInterface.getEventHandler().sendEvent(ExternalMessage.class, new CRUDEvent<ExternalMessage>(CRUDAction.ADD, message), EventTarget.ALL);

												sentExternalMessages++;
											}
											
											if (sendEmail && !StringUtils.isEmpty(contact.getEmail()) && EmailUtils.isValidEmailAddress(contact.getEmail())) {

												TagReplacer tagReplacer = new TagReplacer(FLOWINSTANCE_TAG_SOURCE_FACTORY.getTagSource(flowInstance), FLOW_TAG_SOURCE_FACTORY.getTagSource(flow), CONTACT_TAG_SOURCE_FACTORY.getTagSource(contact));

												if (urlTag != null) {
													tagReplacer.addTagSource(urlTag);
												}

												String message = tagReplacer.replace(emailMessage);
												String subject = tagReplacer.replace(emailSubject);

												try {
													SimpleEmail email = new SimpleEmail(systemInterface.getEncoding());

													email.setMessageContentType(SimpleEmail.HTML);
													email.setSenderAddress(emailSenderAddress);
													email.setSenderName(emailSenderName);
													email.setSubject(subject);
													email.setMessage(message);
													email.addRecipient(contact.getEmail());

													if (!CollectionUtils.isEmpty(attachmentsEmail)) {

														for (Attachment attachment : attachmentsEmail) {

															email.add(attachment);
														}
													}

													log.info("User " + user + " sending email " + email + " regarding flow instance " + flowInstance);

													systemInterface.getEmailHandler().send(email);
													sentEmails++;

												} catch (Exception e) {

													log.error("Error sending email regarding flow instance " + flowInstance, e);
												}
											}

											if (sendSMS && smsSender != null && !StringUtils.isEmpty(contact.getMobilePhone()) && SwedishPhoneNumberValidator.getValidator().validateFormat(contact.getMobilePhone())) {

												TagReplacer tagReplacer = new TagReplacer(FLOWINSTANCE_TAG_SOURCE_FACTORY.getTagSource(flowInstance), FLOW_TAG_SOURCE_FACTORY.getTagSource(flow), CONTACT_TAG_SOURCE_FACTORY.getTagSource(contact));

												if (urlTag != null) {
													tagReplacer.addTagSource(urlTag);
												}

												String message = tagReplacer.replace(smsMessage);

												SimpleSMS sms = new SimpleSMS();

												sms.setSenderName(flowNotificationHandler.getSMSSenderName(flowInstance));
												sms.setMessage(message);
												sms.setRecipients(Collections.singletonList(contact.getMobilePhone()));

												log.info("User " + user + " sending sms " + sms + " regarding flow instance " + flowInstance);

												if (smsSender.send(sms)) {

													sentSMSs++;

												} else {

													log.warn("Error sending sms message to " + contact.getMobilePhone());
												}
											}
										}
									}
								}
							}
						}

						if (sendEmail) {
							XMLUtils.appendNewElement(doc, sendMessageElement, "SentEmails", sentEmails);
						}

						if (sendSMS) {
							XMLUtils.appendNewElement(doc, sendMessageElement, "SentSMSs", sentSMSs);
						}

						if (sendExternalMessage) {
							XMLUtils.appendNewElement(doc, sendMessageElement, "SentExternalMessages", sentExternalMessages);
						}

						XMLUtils.appendNewElement(doc, sendMessageElement, "FlowInstanceCount", flowInstanceCount);
					}

				} finally {

					((MultipartRequest) req).deleteFiles();
				}
			}

		}

		if (!validationErrors.isEmpty()) {
			XMLUtils.append(doc, sendMessageElement, "ValidationErrors", validationErrors);
		}

		sendMessageElement.appendChild(flowSelection.toXML(doc));

		XMLUtils.appendNewElement(doc, sendMessageElement, "FlowFamilyName", flowSelection.getFlows().get(0).getName());

		if (useDefaultEmailSenderAddress) {
			XMLUtils.appendNewElement(doc, sendMessageElement, "DefaultEmailSenderAddress", flowNotificationHandler.getEmailSenderAddress());
		}

		{
			Element flowInstanceCounts = XMLUtils.appendNewElement(doc, sendMessageElement, "FlowInstanceCounts");

			int instancesNew = 0;
			int instancesWaitingForMultisign = 0;
			int instancesWaitingForMultisignNotSigned = 0;
			int instancesWaitingForMultisignOwnerSigned = 0;
			//			int instancesWaitingForMultisignOtherSigned = 0;
			int instancesWaitingForPayment = 0;
			int instancesSubmitted = 0;
			int instancesWaitingForCompletion = 0;
			int instancesInProgress = 0;
			int instancesArchived = 0;

			for (Flow flow : flowSelection.getFlows()) {

				instancesNew += getFlowInstanceCount(flow, flowSelection.getFromDate(), flowSelection.getToDate(), Collections.singletonList(ContentType.NEW), user);
				instancesWaitingForMultisign += getFlowInstanceCount(flow, flowSelection.getFromDate(), flowSelection.getToDate(), Collections.singletonList(ContentType.WAITING_FOR_MULTISIGN), user);
				instancesWaitingForPayment += getFlowInstanceCount(flow, flowSelection.getFromDate(), flowSelection.getToDate(), Collections.singletonList(ContentType.WAITING_FOR_PAYMENT), user);
				instancesSubmitted += getFlowInstanceCount(flow, flowSelection.getFromDate(), flowSelection.getToDate(), Collections.singletonList(ContentType.SUBMITTED), user);
				instancesWaitingForCompletion += getFlowInstanceCount(flow, flowSelection.getToDate(), flowSelection.getToDate(), Collections.singletonList(ContentType.WAITING_FOR_COMPLETION), user);
				instancesInProgress += getFlowInstanceCount(flow, flowSelection.getFromDate(), flowSelection.getToDate(), Collections.singletonList(ContentType.IN_PROGRESS), user);
				instancesArchived += getFlowInstanceCount(flow, flowSelection.getFromDate(), flowSelection.getToDate(), Collections.singletonList(ContentType.ARCHIVED), user);
			}

			if (multiSigningHandler != null) {

				if (instancesWaitingForMultisign > 0) {

					for (Flow flow : flowSelection.getFlows()) {

						List<Integer> flowInstanceIDs = getFlowInstanceIDs(flow, flowSelection.getFromDate(), flowSelection.getToDate(), Collections.singletonList(ContentType.WAITING_FOR_MULTISIGN), user, true);

						if (!CollectionUtils.isEmpty(flowInstanceIDs)) {

							for (Integer flowInstanceID : flowInstanceIDs) {

								instancesWaitingForMultisignOwnerSigned++; // Poster has always signed when in this status

								//TODO get signing parties from new signing module
								ImmutableFlowInstanceManager instanceManager = new ImmutableFlowInstanceManager(getFlowInstanceForManager(flowInstanceID), queryHandler, req, new DefaultInstanceMetadata(siteProfile), null);

								Set<SigningParty> signingParties = MultiSignUtils.getSigningParties(instanceManager);

								if (!CollectionUtils.isEmpty(signingParties)) {

									ImmutableFlowInstanceEvent lastSigningEvent = SigningUtils.getLastPosterSignEvent(instanceManager.getFlowInstance());
									
									for (SigningParty signingParty : signingParties) {
										
										if (multiSigningHandler.partyHasSigned(flowInstanceID, signingParty, lastSigningEvent.getAdded())) {

											instancesWaitingForMultisignOwnerSigned++;

										} else {

											instancesWaitingForMultisignNotSigned++;
										}
									}
								}
							}
						}
					}
				}
			}

			XMLUtils.appendNewElement(doc, flowInstanceCounts, "NEW", instancesNew);
			XMLUtils.appendNewElement(doc, flowInstanceCounts, "WAITING_FOR_MULTISIGN", instancesWaitingForMultisign);
			XMLUtils.appendNewElement(doc, flowInstanceCounts, "WAITING_FOR_PAYMENT", instancesWaitingForPayment);
			XMLUtils.appendNewElement(doc, flowInstanceCounts, "SUBMITTED", instancesSubmitted);
			XMLUtils.appendNewElement(doc, flowInstanceCounts, "WAITING_FOR_COMPLETION", instancesWaitingForCompletion);
			XMLUtils.appendNewElement(doc, flowInstanceCounts, "IN_PROGRESS", instancesInProgress);
			XMLUtils.appendNewElement(doc, flowInstanceCounts, "ARCHIVED", instancesArchived);

			if (multiSigningHandler != null) {

				XMLUtils.appendNewElement(doc, sendMessageElement, "MultiSigningHandler");
				XMLUtils.appendNewElement(doc, flowInstanceCounts, "WAITING_FOR_MULTISIGN_NotSigned", instancesWaitingForMultisignNotSigned);
				XMLUtils.appendNewElement(doc, flowInstanceCounts, "WAITING_FOR_MULTISIGN_OwnerSigned", instancesWaitingForMultisignOwnerSigned);
				//				XMLUtils.appendNewElement(doc, flowInstanceCounts, "WAITING_FOR_MULTISIGN_OtherSigned", instancesWaitingForMultisignOtherSigned);
			}
		}

		sendMessageElement.appendChild(RequestUtils.getRequestParameters(req, doc));

		log.info("User " + user + " requesting send email form");

		return new SimpleForegroundModuleResponse(doc, moduleDescriptor.getName(), getDefaultBreadcrumb());
	}

	@WebPublic(alias = "exportpdf")
	public ForegroundModuleResponse exportFlowVersionsAsPDF(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		FlowSelection flowSelection = getFlowSelection(req, res, user, uriParser);

		if (flowSelection.getErrorResponse() != null) {

			return flowSelection.getErrorResponse();
		}

		log.info("User " + user + " exporting flow instances as zipped PDFs for flows: " + flowSelection.getFlows());

		String filename = flowSelection.getFlows().get(flowSelection.getFlows().size() - 1).getName() + " " + DateUtils.DATE_FORMATTER.format(new Date());

		res.setHeader("Content-Disposition", "attachment; filename=\"" + FileUtils.toValidHttpFilename(filename) + ".zip\"");
		res.setHeader("Cache-Control", "no-store, no-cache, must-revalidate, proxy-revalidate");
		res.setContentType("application/zip");

		ZipOutputStream zipOutputStream = null;

		try {
			zipOutputStream = new ZipOutputStream(res.getOutputStream());

			for (Flow flow : flowSelection.getFlows()) {

				List<FlowInstance> flowInstances = getFlowInstances(flow, flowSelection.getFromDate(), flowSelection.getToDate(), null, user, false, FlowInstance.EVENTS_RELATION, FlowInstanceEvent.ATTRIBUTES_RELATION, FlowInstance.STATUS_RELATION, FlowInstance.FLOW_RELATION, Flow.FLOW_FAMILY_RELATION);

				if (!CollectionUtils.isEmpty(flowInstances)) {

					String directoryName = flow.getName() + " (ver. " + flow.getVersion() + ")/";

					for (FlowInstance flowInstance : flowInstances) {

						if (CollectionUtils.isEmpty(flowInstance.getEvents())) {

							log.debug("Found no events in " + flowInstance);

							continue;
						}

						FlowInstanceEvent event = FlowInstanceUtils.getLatestPDFEvent(flowInstance);

						if (event != null) {

							File pdfFile = pdfProvider.getPDF(flowInstance.getFlowInstanceID(), event.getEventID());

							if (pdfFile != null) {

								String pdfName = flow.getName() + " - " + flowInstance.getFlowInstanceID() + ".pdf";

								ZipUtils.addEntry(directoryName + pdfName, new BufferedInputStream(new FileInputStream(pdfFile)), zipOutputStream, event.getAdded().getTime());

								for (PDFExportFilter filter : pdfExportFilters) {
									
									try {

										filter.processPDFExport(zipOutputStream, directoryName, pdfName, flowInstance);
										
									} catch (Exception e) {

										log.error("Error while running PDF export filter " + filter, e);
									}
								}
								
							} else {

								log.warn("PDF file not found for " + flowInstance);
							}

						} else {

							log.debug("Found no events with a pdf in" + flowInstance);
						}
					}

				} else {

					log.debug("Found no flowinstances in " + flow);
				}

			}

		} catch (SocketException e) {

			log.info("Error sending flow instance PDFs in ZIP format to user " + user + ", " + e);

		} catch (IOException e) {

			log.info("Error sending flow instance PDFs in ZIP format to user " + user + ", " + e);

		} finally {

			CloseUtils.close(zipOutputStream);
		}

		return null;
	}

	private List<Flow> getFlows(FlowFamily flowFamily) {

		List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);

		Iterator<Flow> iterator = flows.iterator();

		while (iterator.hasNext()) {

			Flow flow = iterator.next();

			if (!flow.isEnabled()) {

				iterator.remove();
			}
		}

		return flows;
	}

	private List<Flow> getFlowVersions(FlowFamily flowFamily, List<Integer> flowIDs) {

		List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);

		Iterator<Flow> iterator = flows.iterator();

		while (iterator.hasNext()) {

			Flow flow = iterator.next();

			if (!flow.isEnabled() || !flowIDs.contains(flow.getFlowID())) {

				iterator.remove();
			}
		}

		return flows;
	}

	protected SiteProfile getCurrentSiteProfile(HttpServletRequest req, User user, URIParser uriParser) {

		if (this.siteProfileHandler != null) {

			return siteProfileHandler.getCurrentProfile(user, req, uriParser);
		}

		return null;
	}

	protected SiteProfile getSiteProfile(FlowInstance flowInstance) {

		if (this.siteProfileHandler != null) {

			return siteProfileHandler.getProfile(flowInstance.getProfileID());
		}

		return null;
	}

	public Document createDocument(HttpServletRequest req, URIParser uriParser, User user) {

		Document doc = XMLUtils.createDomDocument();
		Element documentElement = doc.createElement("Document");
		documentElement.appendChild(RequestUtils.getRequestInfoAsXML(doc, req, uriParser));
		documentElement.appendChild(this.moduleDescriptor.toXML(doc));

		XMLUtils.appendNewElement(doc, documentElement, "fullAlias", getFullAlias());

		doc.appendChild(documentElement);
		return doc;
	}

	private List<FlowInstance> getFlowInstances(List<Flow> flows, List<Integer> flowInstanceIDs) throws SQLException {

		HighLevelQuery<FlowInstance> query = new HighLevelQuery<FlowInstance>(FlowInstance.MANAGERS_RELATION, FlowInstance.MANAGER_GROUPS_RELATION, FlowInstance.STATUS_RELATION, FlowInstance.FLOW_RELATION);

		query.addRelations(FLOW_INSTANCE_RELATIONS_FOR_EVENTS);
		query.addCachedRelations(FLOW_INSTANCE_CACHED_RELATIONS_FOR_EVENTS);

		query.addParameter(flowInstanceFirstSubmittedParamFactory.getIsNotNullParameter());
		query.addParameter(flowInstanceIDParamFactory.getWhereInParameter(flowInstanceIDs));
		query.addParameter(flowInstanceFlowParamFactory.getWhereInParameter(flows));
		
		return flowInstanceDAO.getAll(query);
	}

	private List<FlowInstance> getFlowInstances(Flow flow, Timestamp fromDate, Timestamp toDate, List<ContentType> selectedContentTypes, User user, boolean includeUnsubmitted, Field... relations) throws SQLException {
		
		if (selectedContentTypes == null) {
			
			selectedContentTypes = Arrays.asList(new ContentType[] { ContentType.SUBMITTED, ContentType.WAITING_FOR_COMPLETION, ContentType.IN_PROGRESS, ContentType.ARCHIVED, ContentType.WAITING_FOR_PAYMENT, ContentType.WAITING_FOR_MULTISIGN });
		}
		
		if (selectedContentTypes.isEmpty()) {
			
			throw new NullPointerException("Use either a filled list or null. Not empty.");
		}
		
		LowLevelQuery<FlowInstance> query = new LowLevelQuery<FlowInstance>(getFlowInstancesSQL(fromDate, toDate, selectedContentTypes, flow, user, includeUnsubmitted));
		
		query.addParameter(flow.getFlowID());
		
		for (ContentType contentType : selectedContentTypes) {
			query.addParameter(contentType.name());
		}
		
		if (fromDate != null) {
			
			query.addParameter(fromDate);
			
			if (includeUnsubmitted) {
				
				query.addParameter(fromDate);
			}
		}
		
		if (toDate != null) {
			
			query.addParameter(toDate);
			
			if (includeUnsubmitted) {
				
				query.addParameter(toDate);
			}
		}
		
		if (relations != null) {
			
			query.addRelations(relations);
			
			query.addCachedRelations(FlowInstance.STATUS_RELATION, FlowInstance.FLOW_RELATION, Flow.FLOW_FAMILY_RELATION, Flow.FLOW_TYPE_RELATION);
		}
		
		return daoFactory.getFlowInstanceDAO().getAll(query);
	}

	private List<Integer> getFlowInstanceIDs(Flow flow, Timestamp fromDate, Timestamp toDate, List<ContentType> selectedContentTypes, User user, boolean includeUnsubmitted) throws SQLException {

		if (selectedContentTypes == null) {

			selectedContentTypes = Arrays.asList(new ContentType[] { ContentType.SUBMITTED, ContentType.WAITING_FOR_COMPLETION, ContentType.IN_PROGRESS, ContentType.ARCHIVED });
		}

		if (selectedContentTypes.isEmpty()) {

			throw new NullPointerException("Use either a filled list or null. Not empty.");
		}

		ArrayListQuery<Integer> query = new ArrayListQuery<Integer>(daoFactory.getFlowInstanceDAO().getDataSource(), getFlowInstancesSQL(fromDate, toDate, selectedContentTypes, flow, user, includeUnsubmitted), IntegerPopulator.getPopulator());

		int paramIndex = 1;

		query.setInt(paramIndex++, flow.getFlowID());

		for (ContentType contentType : selectedContentTypes) {
			query.setString(paramIndex++, contentType.name());
		}

		if (fromDate != null) {

			query.setTimestamp(paramIndex++, fromDate);
			query.setTimestamp(paramIndex++, fromDate);
		}

		if (toDate != null) {

			query.setTimestamp(paramIndex++, toDate);
			query.setTimestamp(paramIndex++, toDate);
		}

		return query.executeQuery();
	}

	private String getFlowInstancesSQL(Timestamp fromDate, Timestamp toDate, List<ContentType> selectedContentTypes, Flow flow, User user, boolean includeUnsubmitted) {

		StringBuilder builder = new StringBuilder(getFlowInstancesSQL(flow, user, includeUnsubmitted));

		builder.append(" AND s.contentType IN (" + DBUtils.getPreparedStatementQuestionMarks(selectedContentTypes) + ")");

		if (fromDate != null) {

			if(includeUnsubmitted) {
				
				builder.append(" AND ((i.firstSubmitted >= ? AND s.contentType != 'NEW') OR (i.added >= ? AND (s.contentType IN ('NEW', 'WAITING_FOR_PAYMENT','WAITING_FOR_MULTISIGN'))))");
				
			} else {
				
				builder.append(" AND (i.firstSubmitted >= ?)");
			}
		}

		if (toDate != null) {

			if(includeUnsubmitted) {
				
				builder.append(" AND ((i.firstSubmitted <= ? AND s.contentType != 'NEW') OR (i.added <= ? AND (s.contentType IN ('NEW', 'WAITING_FOR_PAYMENT','WAITING_FOR_MULTISIGN'))))");
				
			} else {
				
				builder.append(" AND (i.firstSubmitted <= ?)");
			}
		}
		
		builder.append(" ORDER BY i.flowInstanceID ASC");

		return builder.toString();
	}

	protected String getFlowInstancesSQL(Flow flow, User user, boolean includeUnsubmitted) {

		String sql = "SELECT i.* FROM flowengine_flow_instances i INNER JOIN flowengine_flow_statuses s ON i.statusID = s.statusID WHERE i.flowID = ?";
		
		if(!includeUnsubmitted) {
			
			sql += " AND i.firstSubmitted IS NOT NULL";
		}
		
		return sql;
	}

	private int getFlowInstanceCount(Flow flow, Timestamp fromDate, Timestamp toDate, List<ContentType> selectedContentTypes, User user) throws SQLException {

		if (CollectionUtils.isEmpty(selectedContentTypes)) {

			selectedContentTypes = Arrays.asList(new ContentType[] { ContentType.SUBMITTED, ContentType.WAITING_FOR_COMPLETION, ContentType.IN_PROGRESS, ContentType.ARCHIVED });
		}

		StringBuilder builder = new StringBuilder(getFlowInstanceCountSQL(flow, user));

		builder.append(" AND s.contentType IN (" + DBUtils.getPreparedStatementQuestionMarks(selectedContentTypes) + ")");

		if (fromDate != null) {

			builder.append(" AND (i.firstSubmitted >= ? OR (i.firstSubmitted IS NULL AND i.added >= ?))");
		}

		if (toDate != null) {

			builder.append(" AND (i.firstSubmitted <= ? OR (i.firstSubmitted IS NULL AND i.added <= ?))");
		}

		ObjectQuery<Integer> query = new ObjectQuery<Integer>(dataSource, builder.toString(), IntegerPopulator.getPopulator());

		int paramIndex = 1;

		query.setInt(paramIndex++, flow.getFlowID());

		for (ContentType contentType : selectedContentTypes) {
			query.setString(paramIndex++, contentType.name());
		}

		if (fromDate != null) {

			query.setTimestamp(paramIndex++, fromDate);
			query.setTimestamp(paramIndex++, fromDate);
		}

		if (toDate != null) {

			query.setTimestamp(paramIndex++, toDate);
			query.setTimestamp(paramIndex++, toDate);
		}

		return query.executeQuery();
	}

	protected String getFlowInstanceCountSQL(Flow flow, User user) {

		return "SELECT COUNT(i.flowInstanceID) FROM flowengine_flow_instances i INNER JOIN flowengine_flow_statuses s ON i.statusID = s.statusID WHERE i.flowID = ?";
	}

	public FlowInstance getFlowInstanceForManager(int flowInstanceID) throws SQLException {

		HighLevelQuery<FlowInstance> query = new HighLevelQuery<FlowInstance>(FlowInstance.OWNERS_RELATION, FlowInstance.FLOW_RELATION, FlowInstance.STATUS_RELATION, Flow.STEPS_RELATION, Flow.FLOW_FAMILY_RELATION, Step.QUERY_DESCRIPTORS_RELATION, QueryDescriptor.QUERY_INSTANCE_DESCRIPTORS_RELATION, FlowInstance.ATTRIBUTES_RELATION, FlowInstance.EVENTS_RELATION, FlowInstanceEvent.ATTRIBUTES_RELATION);

		query.addParameter(flowInstanceIDParamFactory.getParameter(flowInstanceID));
		query.addRelationParameter(QueryInstanceDescriptor.class, queryInstanceDescriptorFlowInstanceIDParamFactory.getParameter(flowInstanceID));

		return daoFactory.getFlowInstanceDAO().get(query);
	}

	@WebPublic(alias = "icon")
	public ForegroundModuleResponse getFlowIcon(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws URINotFoundException, AccessDeniedException, ModuleConfigurationException, SQLException, IOException {

		Integer flowID = null;

		if (uriParser.size() == 3 && (flowID = NumberUtils.toInt(uriParser.get(2))) != null) {

			ImmutableFlow flow = flowAdminModule.getFlow(flowID);

			if (flow != null) {

				InputStream in = null;
				OutputStream out = null;

				try {
					if (flow.getIcon() != null) {

						HTTPUtils.setContentLength(flow.getIcon().length(), res);

						res.setContentType(MimeUtils.getMimeType(flow.getIconFileName()));
						res.setHeader("Content-Disposition", "inline; filename=\"" + FileUtils.toValidHttpFilename(flow.getIconFileName()) + "\"");

						in = flow.getIcon().getBinaryStream();

					} else {

						in = BaseFlowModule.class.getResourceAsStream("staticcontent/pics/flow_default.png");
						res.setContentType(MimeUtils.getMimeType("flow_default.png"));
						res.setHeader("Content-Disposition", "inline; filename=\"flow_default.png\"");
					}

					out = res.getOutputStream();

					StreamUtils.transfer(in, out);

				} catch (RuntimeException e) {

					log.debug("Caught exception " + e + " while sending image " + flow.getIconFileName() + " to " + user);

				} catch (IOException e) {

					log.debug("Caught exception " + e + " while sending image " + flow.getIconFileName() + " to " + user);

				} finally {

					CloseUtils.close(in);
					CloseUtils.close(out);
				}

				return null;
			}
		}

		throw new URINotFoundException(uriParser);
	}

	@InstanceManagerDependency
	public void setFlowInstanceAdminModule(FlowInstanceAdminModule flowInstanceAdminModule) {

		if (flowInstanceAdminModule != null) {

			flowInstanceAdminModule.addOverviewExtensionLinkProvider(this);

		} else if (this.flowInstanceAdminModule != null) {

			this.flowInstanceAdminModule.removeOverviewExtensionLinkProvider(this);
		}

		this.flowInstanceAdminModule = flowInstanceAdminModule;
	}

	private void generateOverviewExtensionLink(StaticContentModule staticContentModule) {

		if (staticContentModule != null) {

			overviewExtensionLink = new ExtensionLink(moduleDescriptor.getName(), systemInterface.getContextPath() + this.getFullAlias(), staticContentModule.getModuleContentURL(moduleDescriptor) + "/pics/page_text.png", "top-right");

		} else {

			overviewExtensionLink = null;
		}
	}

	@InstanceManagerDependency(required = true)
	public void setStaticContentModule(StaticContentModule staticContentModule) {

		generateOverviewExtensionLink(staticContentModule);

		this.staticContentModule = staticContentModule;
	}

	@Override
	public AccessInterface getAccessInterface() {

		return moduleDescriptor;
	}

	@Override
	public ExtensionLink getExtensionLink(User user) {

		if (hasRequiredDependencies) {

			return overviewExtensionLink;
		}

		return null;
	}

	private FlowSelection getFlowSelection(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		return getFlowSelection(req, res, user, uriParser, false);
	}

	private FlowSelection getFlowSelection(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, boolean allowEmptySelection) throws Throwable {

		FlowSelection flowSelection = new FlowSelection();

		Integer flowFamilyID = uriParser.getInt(2);
		FlowFamily flowFamily = null;

		if (flowFamilyID == null || (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) == null) {

			flowSelection.setErrorResponse(listFlowFamilies(req, res, user, uriParser, FLOW_FAMILY_NOT_FOUND_VALIDATION_ERROR));

			return flowSelection;

		}

		flowSelection.setFlowFamily(flowFamily);

		if (!hasAccess(user, flowSelection.getFlowFamily())) {

			flowSelection.setErrorResponse(listFlowFamilies(req, res, user, uriParser, FLOW_FAMILY_ACCESS_DENIED_VALIDATION_ERROR));

			return flowSelection;
		}

		List<Integer> flowIDs = NumberUtils.toInt(req.getParameterValues("flowID"));

		List<Flow> flows;

		List<ValidationError> validationErrors = new ArrayList<ValidationError>(4);

		if (flowIDs == null) {

			if (!allowEmptySelection) {

				validationErrors.add(NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR);

			} else {

				flowSelection.setFlows(getFlows(flowFamily), true);
			}

		} else {

			flows = getFlowVersions(flowSelection.getFlowFamily(), flowIDs);

			if (CollectionUtils.isEmpty(flows)) {

				validationErrors.add(NO_FLOW_VERSIONS_SELECTED_VALIDATION_ERROR);

			} else {

				flowSelection.setFlows(flows, false);
			}
		}

		if (!StringUtils.isEmpty(req.getParameter("fromDate"))) {

			Date fromDate = DateUtils.getDate(DateUtils.DATE_FORMATTER, req.getParameter("fromDate"));

			if (fromDate == null) {

				validationErrors.add(new ValidationError("fromDate", ValidationErrorType.InvalidFormat));

			} else {

				fromDate = DateUtils.setTimeToMidnight(fromDate);
				flowSelection.setFromDate(new Timestamp(fromDate.getTime()));
			}
		}

		if (!StringUtils.isEmpty(req.getParameter("toDate"))) {

			Date toDate = DateUtils.getDate(DateUtils.DATE_FORMATTER, req.getParameter("toDate"));

			if (toDate == null) {

				validationErrors.add(new ValidationError("toDate", ValidationErrorType.InvalidFormat));

			} else {

				toDate = DateUtils.setTimeToMaximum(toDate);
				flowSelection.setToDate(new Timestamp(toDate.getTime()));
			}
		}

		if (!validationErrors.isEmpty()) {

			flowSelection.setErrorResponse(this.listFlowVersions(req, res, user, uriParser, validationErrors));
		}

		return flowSelection;
	}

	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse updateStatuses(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		FlowSelection flowSelection = getFlowSelection(req, res, user, uriParser, true);

		if (flowSelection.getErrorResponse() != null) {

			return flowSelection.getErrorResponse();
		}

		List<Integer> flowInstanceIDs = NumberUtils.toInt(req.getParameterValues("flowInstanceID"));

		if (flowInstanceIDs == null) {

			redirectToMethod(req, res, "/instances/" + flowSelection.getFlowFamily().getFlowFamilyID() + "?" + flowSelection.toURLParameters());
			return null;
		}

		List<FlowInstance> flowInstances = getFlowInstances(flowSelection.getFlows(), flowInstanceIDs);
		
		if (flowInstances == null) {
			
			redirectToMethod(req, res, "/instances/" + flowSelection.getFlowFamily().getFlowFamilyID() + "?" + flowSelection.toURLParameters());
			return null;
		}

		List<ValidationError> validationErrors = new ArrayList<ValidationError>();
		
		Integer uniqueFlowID = null;

		for (FlowInstance flowInstance : flowInstances) {

			if (uniqueFlowID == null) {

				uniqueFlowID = flowInstance.getFlow().getFlowID();

			} else if (!uniqueFlowID.equals(flowInstance.getFlow().getFlowID())) {

				validationErrors.add(new ValidationError("MultipleFlowsSelected"));
			}
		}

		Flow flow = flowInstances.get(0).getFlow();

		if (req.getMethod().equalsIgnoreCase("POST") && req.getParameter("directFromInstanceList") == null && validationErrors.isEmpty()) {

			if (validationErrors.isEmpty()) {

				Integer statusID = NumberUtils.toInt(req.getParameter("statusID"));

				Status status;

				if (statusID == null || (status = getStatus(flow, statusID)) == null) {

					validationErrors.add(FlowInstanceAdminModule.STATUS_NOT_FOUND_VALIDATION_ERROR);

				} else if (status.getContentType() == ContentType.NEW || status.getContentType() == ContentType.WAITING_FOR_MULTISIGN || status.getContentType() == ContentType.WAITING_FOR_PAYMENT || (status.isUseAccessCheck() && !AccessUtils.checkAccess(user, status)) || status.isRequireSigning()) {

					validationErrors.add(FlowInstanceAdminModule.INVALID_STATUS_VALIDATION_ERROR);

				} else {

					for (FlowInstance flowInstance : flowInstances) {

						Status previousStatus = flowInstance.getStatus();

						if (!previousStatus.equals(status)) {

							if (status.isRequireSigning()) {
								
								//TODO implement
//								redirectToMethod(req, res, "/signstatus/" + flowInstance.getFlowInstanceID() + "/" + status.getStatusID());
//								return null;
							}
							
							log.info("User " + user + " changing status of instance " + flowInstance + " from " + previousStatus + " to " + status);

							flowInstance.setStatus(status);
							flowInstance.setLastStatusChange(TimeUtils.getCurrentTimestamp());
							daoFactory.getFlowInstanceDAO().update(flowInstance);

							FlowInstanceEvent flowInstanceEvent = flowAdminModule.getFlowInstanceEventGenerator().addFlowInstanceEvent(flowInstance, EventType.STATUS_UPDATED, null, user);

							systemInterface.getEventHandler().sendEvent(FlowInstance.class, new CRUDEvent<FlowInstance>(CRUDAction.UPDATE, flowInstance), EventTarget.ALL);
							systemInterface.getEventHandler().sendEvent(FlowInstance.class, new StatusChangedByManagerEvent(flowInstance, flowInstanceEvent, getSiteProfile(flowInstance), previousStatus, user), EventTarget.ALL);
						}
					}

					redirectToMethod(req, res, "/instances/" + flowSelection.getFlowFamily().getFlowFamilyID() + "?" + flowSelection.toURLParameters());
					return null;
				}
			}
		}

		log.info("User " + user + " requested form for mass changing flow instance statues");

		Document doc = createDocument(req, uriParser, user);

		Element updateFlowInstanceStatusesElement = doc.createElement("UpdateFlowInstanceStatuses");
		doc.getDocumentElement().appendChild(updateFlowInstanceStatusesElement);

		updateFlowInstanceStatusesElement.appendChild(flowSelection.toXML(doc));
		XMLUtils.append(doc, updateFlowInstanceStatusesElement, "FlowInstances", "flowInstanceID", flowInstanceIDs);

		XMLUtils.appendNewElement(doc, updateFlowInstanceStatusesElement, "FlowName", flow.getName());
		
		List<Status> statuses = getStatuses(flow);

		if (statuses != null) {
			
			Iterator<Status> it = statuses.iterator();
			while (it.hasNext()) {
				Status status = it.next();

				if (status.isRequireSigning() || (status.isUseAccessCheck() && !AccessUtils.checkAccess(user, status))) {
					it.remove();
				}
			}
		}

		XMLUtils.append(doc, updateFlowInstanceStatusesElement, "Statuses", statuses);

		if (!CollectionUtils.isEmpty(validationErrors)) {

			XMLUtils.append(doc, updateFlowInstanceStatusesElement, "ValidationErrors", validationErrors);
			updateFlowInstanceStatusesElement.appendChild(RequestUtils.getRequestParameters(req, doc));
		}

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse addManagers(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		FlowSelection flowSelection = getFlowSelection(req, res, user, uriParser, true);

		if (flowSelection.getErrorResponse() != null) {

			return flowSelection.getErrorResponse();
		}

		List<Integer> flowInstanceIDs = NumberUtils.toInt(req.getParameterValues("flowInstanceID"));

		if (flowInstanceIDs == null) {

			redirectToMethod(req, res, "/instances/" + flowSelection.getFlowFamily().getFlowFamilyID() + "?" + flowSelection.toURLParameters());
			return null;
		}

		List<User> availableManagers = FlowFamilyUtils.getAllowedManagerUsers(flowSelection.getFlowFamily(), systemInterface.getUserHandler());

		List<ValidationError> validationErrors = null;

		if (req.getMethod().equalsIgnoreCase("POST") && req.getParameter("directFromInstanceList") == null) {

			validationErrors = new ArrayList<ValidationError>();

			List<FlowInstance> flowInstances = getFlowInstances(flowSelection.getFlows(), flowInstanceIDs);
			
			if (flowInstances == null) {
				
				redirectToMethod(req, res, "/instances/" + flowSelection.getFlowFamily().getFlowFamilyID() + "?" + flowSelection.toURLParameters());
				return null;
			}

			//New managers
			List<Integer> userIDs = NumberUtils.toInt(req.getParameterValues("managerID"));

			if (userIDs != null) {

				List<User> selectedManagers = new ArrayList<User>();

				for (User manager : availableManagers) {
					for (Integer userID : userIDs) {
						
						if (manager.getUserID().equals(userID)) {
							
							selectedManagers.add(manager);
							break;
						}
					}
				}

				if (CollectionUtils.getSize(selectedManagers) < userIDs.size()) {

					validationErrors.add(ONE_OR_MORE_SELECTED_MANAGER_USERS_NOT_FOUND_VALIDATION_ERROR);

				} else {

					if (validationErrors.isEmpty()) {

						Collections.sort(selectedManagers, new UserNameComparator());

						String newManagersString = FlowInstanceUtils.getManagersString(selectedManagers, null);

						for (FlowInstance flowInstance : flowInstances) {

							if (flowInstance.getManagers() == null || !flowInstance.getManagers().containsAll(selectedManagers)) {

								log.info("User " + user + " adding " + selectedManagers.size() + " managers to instance " + flowInstance + ". New managers: " + newManagersString);

								List<User> combinedManagers = new ArrayList<User>(selectedManagers);
								List<User> previousManagers = flowInstance.getManagers();

								if (!CollectionUtils.isEmpty(previousManagers)) {

									for (User previousManager : previousManagers) {

										if (!combinedManagers.contains(previousManager)) {
											combinedManagers.add(previousManager);
										}
									}

									Collections.sort(combinedManagers, new UserNameComparator());
								}

								flowInstance.setManagers(combinedManagers);

								String detailString = FlowInstanceUtils.getManagersString(flowInstance.getManagers(), flowInstance.getManagerGroups());

								RelationQuery relationQuery = new RelationQuery(FlowInstance.MANAGERS_RELATION);
								daoFactory.getFlowInstanceDAO().update(flowInstance, relationQuery);

								FlowInstanceEvent flowInstanceEvent = flowAdminModule.getFlowInstanceEventGenerator().addFlowInstanceEvent(flowInstance, EventType.MANAGERS_UPDATED, detailString, user);

								systemInterface.getEventHandler().sendEvent(FlowInstance.class, new CRUDEvent<FlowInstance>(CRUDAction.UPDATE, flowInstance), EventTarget.ALL);
								systemInterface.getEventHandler().sendEvent(FlowInstance.class, new ManagersChangedEvent(flowInstance, flowInstanceEvent, getSiteProfile(flowInstance), previousManagers, flowInstance.getManagerGroups(), user), EventTarget.ALL);
							}
						}

						redirectToMethod(req, res, "/instances/" + flowSelection.getFlowFamily().getFlowFamilyID() + "?" + flowSelection.toURLParameters());
						return null;
					}
				}

			} else {

				validationErrors.add(new ValidationError("managerID", ValidationErrorType.RequiredField));
			}
		}

		log.info("User " + user + " requested form for mass adding flow instance managers");

		Document doc = createDocument(req, uriParser, user);

		Element addFlowInstanceManagersElement = doc.createElement("AddFlowInstanceManagers");
		doc.getDocumentElement().appendChild(addFlowInstanceManagersElement);

		addFlowInstanceManagersElement.appendChild(flowSelection.toXML(doc));
		XMLUtils.appendNewElement(doc, addFlowInstanceManagersElement, "FlowName", flowSelection.getFlows().get(0).getName());
		XMLUtils.append(doc, addFlowInstanceManagersElement, "FlowInstances", "flowInstanceID", flowInstanceIDs);

		if(availableManagers != null) {
			
			Collections.sort(availableManagers, new UserNameComparator());
			XMLUtils.append(doc, addFlowInstanceManagersElement, "Managers", availableManagers);
		}

		if (!CollectionUtils.isEmpty(validationErrors)) {

			XMLUtils.append(doc, addFlowInstanceManagersElement, "ValidationErrors", validationErrors);
			addFlowInstanceManagersElement.appendChild(RequestUtils.getRequestParameters(req, doc));
		}

		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}

	private Status getStatus(Flow flow, Integer statusID) throws SQLException {

		HighLevelQuery<Status> query = new HighLevelQuery<Status>();

		query.addParameter(statusIDParamFactory.getParameter(statusID));
		query.addParameter(statusFlowParamFactory.getParameter(flow));

		return daoFactory.getStatusDAO().get(query);
	}

	private List<Status> getStatuses(Flow flow) throws SQLException {

		HighLevelQuery<Status> query = new HighLevelQuery<Status>();

		query.addParameter(statusFlowParamFactory.getParameter(flow));

		return daoFactory.getStatusDAO().getAll(query);
	}

	protected boolean hasAccess(User user, FlowFamily flowFamily) {

		return AccessUtils.checkAccess(user, globalAccess) || flowFamily.checkManagerFullAccess(user);
	}
	
	
	public void addPDFExportFilter(PDFExportFilter filter) {

		if (filter == null) {
			throw new NullPointerException();
		}

		pdfExportFilters.add(filter);
	}

	public void removePDFExportFilter(PDFExportFilter filter) {

		pdfExportFilters.remove(filter);
	}

	@Override
	public ForegroundModuleDescriptor getModuleDescriptor() {
		
		return moduleDescriptor;
	}
	
	@Override
	public List<LinkTag> getLinkTags() {
		
		return links;
	}
	
	@Override
	public List<ScriptTag> getScriptTags() {
		
		return scripts;
	}

}
