package com.nordicpeak.flowengine.evaluators.geometrycontainsaddressquerystateevaluator;

import java.sql.SQLException;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class GeometryContainsAddressQueryStateEvaluatorCRUD extends BaseEvaluatorCRUD<GeometryContainsAddressQueryStateEvaluator, GeometryContainsAddressQueryStateEvaluationProviderModule> {

	private static final BeanRequestPopulator<GeometryContainsAddressQueryStateEvaluator> POPULATOR = new AnnotatedRequestPopulator<GeometryContainsAddressQueryStateEvaluator>(GeometryContainsAddressQueryStateEvaluator.class);

	public GeometryContainsAddressQueryStateEvaluatorCRUD(Class<GeometryContainsAddressQueryStateEvaluator> beanClass, AnnotatedDAOWrapper<GeometryContainsAddressQueryStateEvaluator, Integer> evaluatorDAO, GeometryContainsAddressQueryStateEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "GeometryContainsAddressQueryStateEvaluator", "address geometry intersection query state evaluator", null, callback);
	}

	@Override
	protected void validateUpdatePopulation(GeometryContainsAddressQueryStateEvaluator evaluator, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, SQLException, Exception {

		super.validateUpdatePopulation(evaluator, req, user, uriParser);

		evaluator.setParsedGeometry(callback.getGeometry(evaluator));
	}

}
