package com.nordicpeak.flowengine.integration.http;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "http_integration_parameters")
@XMLElement
public class IntegrationParameter extends GeneratedElementable {

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer parameterID;

	@DAOManaged
	@OrderBy
	@XMLElement
	private String name;

	@DAOManaged
	@XMLElement
	private String value;
	
	@DAOManaged(columnName="flowFamilyID")
	@ManyToOne
	private FlowFamilyIntegrationSettings settings;

	public Integer getParameterID() {

		return parameterID;
	}

	public void setParameterID(Integer parameterID) {

		this.parameterID = parameterID;
	}

	public String getName() {

		return name;
	}

	public void setName(String name) {

		this.name = name;
	}

	public String getValue() {

		return value;
	}

	public void setValue(String value) {

		this.value = value;
	}
}
