package com.nordicpeak.flowengine.queries.iconmapquery.beans;

import java.io.Serializable;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "icon_map_query_instance_reservations")
@XMLElement(name = "Reservation")
public class IconMapQueryInstanceReservation extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 5458298068910044209L;

	@DAOManaged(columnName = "queryInstanceID")
	@Key
	@ManyToOne
	private IconMapQueryInstance queryInstance;

	@DAOManaged
	@Key
	@XMLElement
	private String objectID;

	@DAOManaged
	@XMLElement
	private String reservationID;

	public IconMapQueryInstanceReservation() {}

	public IconMapQueryInstanceReservation(String objectID, String reservationID) {

		this.objectID = objectID;
		this.reservationID = reservationID;
	}

	@Override
	public String toString() {

		return "(objectID=" + objectID + ", reservationID=" + reservationID + ")";
	}

	public IconMapQueryInstance getQueryInstance() {

		return queryInstance;
	}

	public void setQueryInstance(IconMapQueryInstance queryInstance) {

		this.queryInstance = queryInstance;
	}

	public String getObjectID() {

		return objectID;
	}

	public void setObjectID(String objectID) {

		this.objectID = objectID;
	}

	public String getReservationID() {

		return reservationID;
	}

	public void setReservationID(String reservationID) {

		this.reservationID = reservationID;
	}

}
