var iconMapQueryAdminLanguage = {
	"CONFIRM_DELETE_ICON": "confirm delete icon"
};

$(function() {

	$(".map-icon-preview .map-icon img[src]").parent().parent().addClass("selected");

	if ($(".mapicons").children().length == 0) {
		addMapIcon();
	}

	initMapIconEvents($(".mapicon-container .mapicons").children());

	$("#requirePUD").on("change", function(e) {

		var $this = $(this);

		if ($this.is(":checked")) {
			$("#mainPropertyUnitDesignationAttribute").show();
		} else {
			$("#mainPropertyUnitDesignationAttribute").hide();
		}

	}).trigger("change");

	$("#useDetailedIconInfo").on("change", function(e) {

		var $this = $(this);

		if ($this.is(":checked")) {
			$("#showIconPUDInfo").removeAttr("disabled").parent().show();
		} else {
			$("#showIconPUDInfo").attr("disabled", "disabled").parent().hide();
		}

		$("#showIconPUDInfo").trigger("change");

	}).trigger("change");

	$("#showIconPUDInfo").on("change", function(e) {

		var $this = $(this);

		if ($this.is(":checked") && $("#useDetailedIconInfo").is(":checked")) {
			$("#propertyUnitDesignationAttribute").show();
		} else {
			$("#propertyUnitDesignationAttribute").hide();
		}

	}).trigger("change");

	$("#geometryEndpointName").on("change", function(e) {

		var $this = $(this);

		if ($this.val() != "") {
			$("#remoteGeometryEndpointSettings").show();
			$("#useSelectableGeometries").trigger("change");
		} else {
			$("#remoteGeometryEndpointSettings").hide();
			$("#iconDrawingSettings").show().find(".settings input").removeAttr("disabled");
		}

	}).trigger("change");

	$("#useSelectableGeometries").on("change", function(e) {

		var $this = $(this);

		if ($this.is(":visible:checked")) {
			$("#selectableGeometriesSettings").show();
			$("#iconDrawingSettings").hide().find(".settings input").attr("disabled", "disabled");
		} else {
			$("#selectableGeometriesSettings").hide();
			$("#iconDrawingSettings").show().find(".settings input").removeAttr("disabled");
		}

	}).trigger("change");

	$("#selectableGeometryReservationEnabled").on("change", function(e) {

		var shouldShowReservationSettings = $(this).is(":visible:checked");

		$("#selectableGeometryReservationSettings").toggle(shouldShowReservationSettings);

	}).trigger("change");

	$("#reservedGeometryColor").minicolors();

	$("#setAsAttribute").on("change", function() {

		$("#attributeNameContainer").toggle(this.checked);

	}).trigger("change");

});

function addMapIcon(event) {

	if (event) {
		event.preventDefault();
		event.stopPropagation();
	}

	var uuid = generateUUID();
	var $container = $(".mapicon-container");
	var $mapIcons = $container.find(".mapicons");
	var $template = $container.find(".mapicon-template").children().first().clone();

	$template.find("input[id]").prop("disabled", false).each(function() {

		var $input = $(this);

		$input.attr("id", $input.attr("id") + uuid);

		if ($input.attr("name") == "mapIconID") {

			$input.val(uuid);

		} else {

			$input.attr("name", $input.attr("name") + uuid);
		}

	});

	initMapIconEvents($template);

	$template.find("input.sortorder").val($mapIcons.children().length);

	$mapIcons.append($template);

}

function initMapIconEvents($mapIcon) {

	$mapIcon.find("input[type='file']").on("change", function() {

		var $fileInput = $(this);

		if (typeof FileReader !== "undefined") {

			if (this.files && this.files[0]) {

				var reader = new FileReader();

				reader.onload = function(e) {
					$fileInput.closest(".map-icon-preview").addClass("selected").find(".map-icon img").attr("src", e.target.result);
				}

				reader.readAsDataURL(this.files[0]);
			}

		} else {

			// fallback
		}

	});

}

function deleteMapIcon(button, event) {

	event.preventDefault();
	event.stopPropagation();

	if (confirm(iconMapQueryAdminLanguage.CONFIRM_DELETE_ICON)) {

		var $mapIcons = $(button).closest(".mapicons");
		$(button).closest(".mapicon-form").remove();
		updateSortOrder($mapIcons.children());

	}
}

function updateSortOrder($mapIcons) {

	$mapIcons.each(function(i) {
		var $mapIcon = $(this);
		$mapIcon.find("input.sortorder").val(i);
	});
}

function generateUUID() {

	var chars = '0123456789abcdef'.split('');
	var uuid = [],
		rnd = Math.random;
	var r;

	uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
	uuid[14] = '4';

	for (var i = 0; i < 36; i++) {
		if (!uuid[i]) {
			r = 0 | rnd() * 16;
			uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r & 0xf];
		}
	}

	return uuid.join('');
}