package com.nordicpeak.flowengine.queries.infoquery;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.queries.basequery.BaseQueryCRUD;

public class InfoQueryCRUD extends BaseQueryCRUD<InfoQuery, InfoQueryProviderModule> {

	public InfoQueryCRUD(AnnotatedDAOWrapper<InfoQuery, Integer> queryDAO, BeanRequestPopulator<InfoQuery> populator, String typeElementName, String typeLogName, String listMethodAlias, InfoQueryProviderModule callback) {
		
		super(InfoQuery.class, queryDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);
	}

	@Override
	protected InfoQuery populateFromUpdateRequest(InfoQuery oldQuery, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {
		
		InfoQuery query = super.populateFromUpdateRequest(oldQuery, req, user, uriParser);
		
		List<ValidationError> validationErrors = new ArrayList<ValidationError>();

		this.populateQueryDescriptor((QueryDescriptor) query.getQueryDescriptor(), req, validationErrors);
		
		if(query.isHideTitle() && query.getDescription() == null) {
			
			throw new ValidationException(new ValidationError("DescriptionRequiredWhenTitleHidden"));
		}
		
		if(!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}

		return query;
	}

}
