package com.nordicpeak.flowengine.internalalternativelist.beans;

import java.lang.reflect.Field;
import java.sql.Timestamp;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.alternativelist.provider.BaseAlternativeListEvent;

@Table(name = "internal_alternative_list_events")
@XMLElement(name = "AlternativeListEvent")
public class InternalAlternativeListEvent extends BaseAlternativeListEvent<InternalAlternativeList, InternalAlternativeListEvent> {
	
	public static final Field LIST_RELATION = ReflectionUtils.getField(InternalAlternativeListEvent.class, "list");
	
	@DAOManaged(columnName = "listID")
	@ManyToOne
	@XMLElement
	private InternalAlternativeList list;
	
	public InternalAlternativeListEvent() {
		super();
	}
	
	public InternalAlternativeListEvent(InternalAlternativeList list, Timestamp added, User poster, String message) {
		super(list, added, poster, message);
	}
	
	@Override
	public InternalAlternativeList getList() {
		return list;
	}
	
	@Override
	public void setList(InternalAlternativeList list) {
		this.list = list;
	}
	
}
