package com.nordicpeak.flowengine.internalalternativelist.beans;

import java.io.Serializable;
import java.util.List;

import se.unlogic.hierarchy.core.interfaces.attributes.AttributeHandler;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.alternativelist.beans.AlternativeListDescriptor;
import com.nordicpeak.flowengine.alternativelist.interfaces.AlternativeListInstance;

public class InternalCombinedListInstance extends GeneratedElementable implements AlternativeListInstance, Serializable {

	private static final long serialVersionUID = -2907579471281781085L;

	@XMLElement
	private final AlternativeListDescriptor descriptor;

	private final List<InternalAlternative> alternatives;

	public InternalCombinedListInstance(AlternativeListDescriptor descriptor, List<InternalAlternative> alternatives) {
		super();

		this.descriptor = descriptor;
		this.alternatives = alternatives;
	}

	@Override
	public AlternativeListDescriptor getDescriptor() {

		return descriptor;
	}

	@Override
	public List<InternalAlternative> getAlternatives() {

		return alternatives;
	}

	@Override
	public boolean requiresReload(AttributeHandler attributeHandler) {

		return false;
	}

}
