$(function() {
	
	$("#lists-list").each(function(j){
		var list = $(this);
		var prefix = "lists";
		var url = list.data("url");
		 
		var searchInput = $( "#" + prefix + "-search");
		 
		searchInput.autocomplete({
			source: function(request, response) {
				return searchLists(request, response, url, searchInput);
			},
			select: function( event, ui ) {
				
				addEntry(ui.item, list, prefix);
				
				searchInput.val("");
				
				return false;
			},
			focus: function(event, ui) {
		        event.preventDefault();
		    }
		});
		 
		var template = getTemplate(prefix);
		template.find("input").prop("disabled", true);
	});
	
	var useDateLimits = $("#useDateLimits");
	
	if (useDateLimits.length > 0) {
		
		var showHideDates = function() {
		
			var datesVisible = useDateLimits.prop("checked");
			$(".datelimits").toggle(datesVisible).filter("input").attr("disabled", !datesVisible);
			
			if (datesVisible) {
				$(".alternatives input.name").css("width", "calc(60% - 73px)");
				
			} else {
				$(".alternatives input.name").css("width", "calc(100% - 73px)");
			}
		};
		
		showHideDates();
		useDateLimits.on("change", showHideDates);
		
		// Override existing function
		var oldAddAlternative = window.addAlternative;
		
		window.addAlternative = function addAlternative(button, event) {
			
			oldAddAlternative(button, event);
			
			var datesVisible = useDateLimits.prop("checked");
			var newRow = $(".alternatives .alternative").last();
			
			if (!Modernizr.inputtypes.date) {
				
				newRow.find("input[type='date']").datepicker({
					changeMonth: true,
					changeYear: true,
					showWeek: true,
					dayNamesShort: true,
					onSelect: function() {
						$(this).trigger("blur");
					}
				});
			}
			
			if (!datesVisible) {
				$(".alternatives input.name").css("width", "calc(100% - 73px)");
			}
		}
	}
	
	if (!Modernizr.inputtypes.date) {
		
		$(".alternatives input[type='date']").datepicker({
			changeMonth: true,
			changeYear: true,
			showWeek: true,
			dayNamesShort: true,
			onSelect: function() {
				$(this).trigger("blur");
			}
		});
	}
	
	$('#adminAccessControlEnabled').on("change", function(){
		
		$('#adminContainer').toggle(this.checked);
		
	}).trigger("change");
	
});

function searchLists(request, response, searchURL, searchInput) {
	
	searchInput.addClass("ui-autocomplete-loading");
	
	$.ajax({
		url : searchURL,
		dataType : "json",
		contentType: "application/x-www-form-urlencoded;charset=UTF-8",
		data : {
			q : encodeURIComponent(request.term)
		},
		success : function(data) {
			
			if (data.hits != undefined && data.hits.length > 0) {
				
				response($.map(data.hits, function(item) {
					
					return {
						label : item.name,
						value : item.id,
					}
				}));
			} else {
				response(null);
			}
			
			searchInput.removeClass("ui-autocomplete-loading");
			
		},
		error : function() {
			
			searchInput.removeClass("ui-autocomplete-loading");
		}
	});
}

function getTemplate(prefix) {
	return $("#" + prefix + "-template");
}

function addEntry(item, list, prefix) {
	
	var exists = false;
	
	$("input[name='listID']").each(function(){
		if($(this).val() == item.value){
			exists = true;
			return false;
		}
	});
	
	if (exists) {
		return;
	}
	
	var clone = getTemplate(prefix).children().clone();
	
	clone.find("h3").text(item.label);
	clone.find("input").prop("disabled", false);
	clone.find("input[name='listID']").val(item.value);
	clone.find("input[name='listName-']").val(item.label).attr("name", 'listName-' + item.value);
	clone.find("input[name='sortorder-']").attr("name", 'sortorder-' + item.value);

	list.append(clone);
	clone.show();
}
