package com.nordicpeak.lmsearch.beans;

import com.vividsolutions.jts.geom.Geometry;

import se.unlogic.standardutils.json.JsonNode;
import se.unlogic.standardutils.json.JsonObject;

public class RegisterUnit extends BaseLMResponse {

	private final String name;
	private final String estateID;
	private final String registerDesignationID;
	private final Geometry geometry;

	public RegisterUnit(String name, String estateID, String registerDesignationID, Geometry geometry) {
		this.name = name;
		this.estateID = estateID;
		this.geometry = geometry;
		this.registerDesignationID = registerDesignationID;
	}

	public String getName() {

		return name;
	}

	public String getEstateID() {

		return estateID;
	}

	public Geometry getGeometry() {

		return geometry;
	}

	public String getRegisterDesignationID() {

		return registerDesignationID;
	};

	@Override
	public JsonNode toJson() {

		JsonObject jsonNode = new JsonObject();

		jsonNode.putField("geometry", getJSONForGeometry(getGeometry()));

		JsonObject propertiesNode = new JsonObject();

		if (getName() != null) {
			propertiesNode.putField("name", getName());
		}

		if (getRegisterDesignationID() != null) {
			propertiesNode.putField("objid", getRegisterDesignationID());
		}

		if (getEstateID() != null) {
			propertiesNode.putField("fnr", getEstateID());
		}

		jsonNode.putField("properties", propertiesNode);
		jsonNode.putField("type", "Feature");

		return jsonNode;
	}

}
