package com.nordicpeak.lmsearch.beans;

import se.unlogic.standardutils.json.JsonNode;
import se.unlogic.standardutils.json.JsonObject;

import com.vividsolutions.jts.geom.Geometry;

public class UnitArea extends BaseLMResponse {

	private final String designation;
	private final String estateID;
	private final String deprecatedEstateID;
	private final Geometry geometry;

	public UnitArea(String designation, String estateID, String deprecatedEstateID, Geometry geometry) {
		this.designation = designation;
		this.estateID = estateID;
		this.deprecatedEstateID = deprecatedEstateID;
		this.geometry = geometry;
	}
	
	public String getDesignation() {

		return designation;
	}

	public String getEstateID() {

		return estateID;
	}
	
	public String getDeprecatedEstateID() {
		
		return deprecatedEstateID;
	}

	public Geometry getGeometry() {

		return geometry;
	}
	
	@Override
	public JsonNode toJson() {

		JsonObject jsonNode = new JsonObject();

		jsonNode.putField("geometry", getJSONForGeometry(getGeometry()));

		JsonObject propertiesNode = new JsonObject();

		if(getEstateID() != null){
			propertiesNode.putField("fnr", getEstateID());
		}
		
		if(getDeprecatedEstateID() != null){
			propertiesNode.putField("deprecatedfnr", getDeprecatedEstateID());
		}
		
		if(getDesignation() != null){
			propertiesNode.putField("name", getDesignation());
		}

		jsonNode.putField("properties", propertiesNode);
		jsonNode.putField("type", "Feature");

		return jsonNode;
	}

}
