package com.nordicpeak.flowengine.managerflowtest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.exceptions.AccessDeniedException;
import se.unlogic.openhierarchy.foregroundmodules.siteprofile.interfaces.SiteProfile;

import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.interfaces.FlowInstanceAccessController;
import com.nordicpeak.flowengine.interfaces.ImmutableFlowInstance;


public class ManagerAccessController implements FlowInstanceAccessController {

	private final boolean mutable;
	
	public ManagerAccessController(boolean mutable) {

		super();
		this.mutable = mutable;
	}

	@Override
	public void checkNewFlowInstanceAccess(Flow flow, User user, SiteProfile profile) throws AccessDeniedException {

		if (flow.getFlowFamily().getManagerAccess(user) == null) {
			
			throw new AccessDeniedException("User is not manager of " + flow);
		}
	}

	@Override
	public void checkFlowInstanceAccess(ImmutableFlowInstance flowInstance, User user) throws AccessDeniedException {}

	@Override
	public boolean isMutable(ImmutableFlowInstance flowInstance, User user) {

		return mutable;
	}

}
