<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateManagerQueryStateEvaluator" />
		</div>

	</xsl:template>

	<xsl:template name="createCustomFormFields">
		
		<xsl:param name="queryStateEvaluator" />
		
		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'useInManagerAddFlowInstance'" />
					<xsl:with-param name="name" select="'useInManagerAddFlowInstance'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="$queryStateEvaluator" />
				</xsl:call-template>

				<label for="useInManagerAddFlowInstance">
					<xsl:value-of select="$i18n.UseInManagerAddFlowInstance" />
				</label>
			</div>
		</div>
			
		<div class="floatleft full">
	
			<label>
				<xsl:value-of select="$i18n.Inclusive.title" />
			</label>
			
			<br/>
			
			<xsl:value-of select="$i18n.Inclusive.description" />
		</div>
		
		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'inclusive'" />
					<xsl:with-param name="name" select="'inclusive'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="$queryStateEvaluator" />
				</xsl:call-template>

				<label for="inclusive">
					<xsl:value-of select="$i18n.Inclusive" />
				</label>
			</div>
		</div>

		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'not-inclusive'" />
					<xsl:with-param name="name" select="'inclusive'" />
					<xsl:with-param name="value" select="'false'" />
					<xsl:with-param name="element" select="$queryStateEvaluator" />
				</xsl:call-template>

				<label for="not-inclusive">
					<xsl:value-of select="$i18n.NotInclusive" />
				</label>
			</div>
		</div>
		
	</xsl:template>

	<xsl:template match="UpdateManagerQueryStateEvaluator">

		<xsl:call-template name="createQueryStateEvaluatorForm">
			<xsl:with-param name="queryStateEvaluator" select="ManagerQueryStateEvaluator" />
		</xsl:call-template>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'inclusive'">
				<xsl:value-of select="$i18n.Inclusive.title" />
			</xsl:when>
			<xsl:when test="$fieldName = 'queryState'">
				<xsl:value-of select="$i18n.queryState" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>