package com.nordicpeak.flowengine.evaluators.manager;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluator;

@Table(name = "manager_query_state_evaluators")
@XMLElement
public class ManagerQueryStateEvaluator extends BaseQueryStateEvaluator{

	private static final long serialVersionUID = 7582032280793947029L;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean inclusive;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean useInManagerAddFlowInstance;

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		super.populate(xmlParser);
		
		List<ValidationError> errors = new ArrayList<ValidationError>(1);
		
		inclusive = xmlParser.getPrimitiveBoolean("inclusive");
		useInManagerAddFlowInstance = xmlParser.getPrimitiveBoolean("useInManagerAddFlowInstance");
		
		if (!errors.isEmpty()) {
			
			throw new ValidationException(errors);
		}
	}
	
	public boolean isInclusive() {
		
		return inclusive;
	}
	
	public void setInclusive(boolean inclusive) {
		
		this.inclusive = inclusive;
	}
	
	@Override
	public boolean requiresInitialization() {
		
		return true;
	}
	
	public boolean isUseInManagerAddFlowInstance() {
		return useInManagerAddFlowInstance;
	}
	
	public void setUseInManagerAddFlowInstance(boolean useInManagerAddFlowInstance) {
		this.useInManagerAddFlowInstance = useInManagerAddFlowInstance;
	}
	
}
