<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />
	
	<xsl:variable name="imgPath"><xsl:value-of select="/Document/requestinfo/contextpath" />/static/f/<xsl:value-of select="/Document/module/sectionID" />/<xsl:value-of select="/Document/module/moduleID" />/pics</xsl:variable>
	
	<xsl:variable name="globalscripts">
		/jquery/jquery.js
	</xsl:variable>
	
	<xsl:template match="Document">

		<div class="contentitem">
			<xsl:apply-templates select="UpdateOfficialAddressQueryStateEvaluator" />
		</div>

	</xsl:template>

	<xsl:template name="createCustomFormFields">
		
		<xsl:param name="queryStateEvaluator" />
		
		<div class="floatleft full">
	
			<label>
				<xsl:value-of select="$i18n.Evaluator.Invert.title" />
			</label>
			
			<br/>
			
			<xsl:value-of select="$i18n.Evaluator.Invert.description" />
		</div>
		
		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'not-inverted'" />
					<xsl:with-param name="name" select="'invert'" />
					<xsl:with-param name="value" select="'false'" />
					<xsl:with-param name="element" select="$queryStateEvaluator" />
				</xsl:call-template>

				<label for="not-inverted">
					<xsl:value-of select="$i18n.Evaluator.NotInverted" />
				</label>
			</div>
		</div>
		
		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'invert'" />
					<xsl:with-param name="name" select="'invert'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="$queryStateEvaluator" />
				</xsl:call-template>

				<label for="invert">
					<xsl:value-of select="$i18n.Evaluator.Inverted" />
				</label>
			</div>
		</div>
		
	</xsl:template>
	
	<xsl:template match="UpdateOfficialAddressQueryStateEvaluator">

		<xsl:call-template name="createQueryStateEvaluatorForm">
			<xsl:with-param name="queryStateEvaluator" select="OfficialAddressQueryStateEvaluator" />
		</xsl:call-template>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'queryState'">
				<xsl:value-of select="$i18n.queryState" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>
	
</xsl:stylesheet>