package com.nordicpeak.flowengine.queries.pudquery;

import java.io.Serializable;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

@XMLElement
public class PUDAlternative extends GeneratedElementable implements ImmutableAlternative, Serializable {

	private static final long serialVersionUID = -6799049641623354471L;

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private final Integer alternativeID;

	@DAOManaged
	@WebPopulate(required = true, maxLength = 255)
	@XMLElement
	private String name;

	@DAOManaged
	@OrderBy
	@XMLElement
	private final Integer sortIndex;

	public PUDAlternative(String name, Integer alternativeID, Integer sortIndex) {

		this.alternativeID = alternativeID;
		this.name = name;
		this.sortIndex = sortIndex;
	}

	@Override
	public Integer getAlternativeID() {

		return alternativeID;
	}

	@Override
	public String getName() {

		return name;
	}

	public Integer getSortIndex() {

		return sortIndex;
	}

	@Override
	public String getExportXMLValue() {
		return null;
	}

	@Override
	public String getAttributeValue() {
		return null;
	}
}
