package com.nordicpeak.flowengine.paymentlog.beans;

import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
@Table(name = "payment_flow_family_settings")
public class FlowFamilyTransactionSettings extends GeneratedElementable {

	@DAOManaged
	@Key
	@XMLElement
	private Integer flowFamilyID;

	@DAOManaged(columnName = "accountID")
	@ManyToOne(autoGet = true)
	@XMLElement
	private Account account;

	@DAOManaged(columnName = "vatAccountID")
	@ManyToOne(autoGet = true)
	@XMLElement
	private Account vatAccount;

	@DAOManaged
	@XMLElement
	private boolean paymentProductSettingsEnabled;

	@DAOManaged
	@OneToMany(autoAdd = true, autoGet = true, autoUpdate = true)
	@XMLElement(fixCase = true)
	private List<PaymentProductTransactionSettings> paymentProductSettingsList;

	public Integer getFlowFamilyID() {

		return flowFamilyID;
	}

	public void setFlowFamilyID(Integer flowFamilyID) {

		this.flowFamilyID = flowFamilyID;
	}

	public Account getAccount() {

		return account;
	}

	public void setAccount(Account account) {

		this.account = account;
	}

	public Account getVatAccount() {

		return vatAccount;
	}

	public void setVatAccount(Account vatAccount) {

		this.vatAccount = vatAccount;
	}

	public boolean isPaymentProductSettingsEnabled() {

		return paymentProductSettingsEnabled;
	}

	public void setPaymentProductSettingsEnabled(boolean paymentProductSettingsEnabled) {

		this.paymentProductSettingsEnabled = paymentProductSettingsEnabled;
	}

	public List<PaymentProductTransactionSettings> getPaymentProductSettingsList() {

		return paymentProductSettingsList;
	}

	public void setPaymentProductSettingsList(List<PaymentProductTransactionSettings> paymentProductSettingsList) {

		this.paymentProductSettingsList = paymentProductSettingsList;
	}

}
