package com.nordicpeak.flowengine.queries.plotquery;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.queries.basequery.BaseQueryCRUD;
import com.nordicpeak.flowengine.queries.plotquery.beans.PlotQuery;

public class PlotQueryCRUD extends BaseQueryCRUD<PlotQuery, PlotQueryProviderModule> {

	public PlotQueryCRUD(AnnotatedDAOWrapper<PlotQuery, Integer> queryDAO, BeanRequestPopulator<PlotQuery> populator, String typeElementName, String typeLogName, String listMethodAlias, PlotQueryProviderModule callback) {

		super(PlotQuery.class, queryDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);
	}

	@Override
	protected PlotQuery populateFromUpdateRequest(PlotQuery oldQuery, HttpServletRequest req, User user, URIParser uriParser) throws Exception {

		PlotQuery query = super.populateFromUpdateRequest(oldQuery, req, user, uriParser);

		List<ValidationError> validationErrors = new ArrayList<>();

		this.populateQueryDescriptor((QueryDescriptor) query.getQueryDescriptor(), req, validationErrors);

		if (!validationErrors.isEmpty()) {

			throw new ValidationException(validationErrors);
		}

		return query;
	}

}
