<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/UserGroupList.js
		/js/predefineduserqueryadmin.js?v=1
	</xsl:variable>
	
	<xsl:variable name="links">
		/css/UserGroupList.css?v=1
	</xsl:variable>

	<xsl:template match="Document">

		<div id="PredefinedUserQueryProvider" class="contentitem">

			<xsl:apply-templates select="validationError" />
			<xsl:apply-templates select="UpdatePredefinedUserQuery" />

		</div>

	</xsl:template>

	<xsl:template match="UpdatePredefinedUserQuery">

		<h1>
			<xsl:value-of select="$i18n.UpdateQuery" />
			<xsl:text>:&#160;</xsl:text>
			<xsl:value-of select="PredefinedUserQuery/QueryDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form id="updatePredefinedUserQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="PredefinedUserQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">

				<label for="groupID">
					<xsl:value-of select="$i18n.Groups" />
				</label>
				
				<xsl:call-template name="GroupList">
					<xsl:with-param name="connectorURL">
						<xsl:value-of select="/Document/requestinfo/currentURI"/>
						<xsl:text>/</xsl:text>
						<xsl:value-of select="/Document/module/alias"/>
						<xsl:text>/groups</xsl:text>
					</xsl:with-param>
					<xsl:with-param name="name" select="'group'" />
					<xsl:with-param name="groups" select="Groups" />
				</xsl:call-template>
			
			</div>			
			
			<div class="floatleft full bigmarginbottom">

				<label for="userID">
					<xsl:value-of select="$i18n.Users" />
				</label>
				
				<xsl:call-template name="UserList">
					<xsl:with-param name="connectorURL">
						<xsl:value-of select="/Document/requestinfo/currentURI"/>
						<xsl:text>/</xsl:text>
						<xsl:value-of select="/Document/module/alias"/>
						<xsl:text>/users</xsl:text>
					</xsl:with-param>
					<xsl:with-param name="name" select="'user'" />
					<xsl:with-param name="users" select="Users" />
					<xsl:with-param name="showEmail" select="false()"/>
					<xsl:with-param name="showUsername" select="true()"/>
				</xsl:call-template>
			
			</div>
			
			<div class="floatleft full bigmarginbottom">

				<label for="preSelectedUserID">
					<xsl:value-of select="$i18n.PreSelectedUser" />
				</label>
				
				<xsl:call-template name="UserList">
					<xsl:with-param name="connectorURL">
						<xsl:value-of select="/Document/requestinfo/currentURI"/>
						<xsl:text>/</xsl:text>
						<xsl:value-of select="/Document/module/alias"/>
						<xsl:text>/users</xsl:text>
					</xsl:with-param>
					<xsl:with-param name="name" select="'preSelectedUserID'" />
					<xsl:with-param name="users" select="PreSelectedUsers" />
					<xsl:with-param name="showEmail" select="false()"/>
					<xsl:with-param name="showUsername" select="true()"/>
				</xsl:call-template>
			
			</div>
			
			<xsl:if test="ClosestManagerEnabled">
				
				<div class="floatleft full marginbottom">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'limitSelectionToMyEmployees'" />
						<xsl:with-param name="name" select="'limitSelectionToMyEmployees'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="PredefinedUserQuery" />
					</xsl:call-template>
					
					<label for="limitSelectionToMyEmployees"><xsl:value-of select="$i18n.Query.limitSelectionToMyEmployees" /></label>
				</div>
				
			</xsl:if>

			<div class="floatleft full marginbottom">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'excludeInactiveUsers'" />
					<xsl:with-param name="name" select="'excludeInactiveUsers'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="PredefinedUserQuery" />
				</xsl:call-template>
				
				<label for="excludeInactiveUsers"><xsl:value-of select="$i18n.Query.excludeInactiveUsers" /></label>
			</div>
			
			<div class="floatleft full bigmargintop">
				<h2><xsl:value-of select="$i18n.ShowForDropdown" /></h2>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showDropDownUsername'" />
					<xsl:with-param name="name" select="'showDropDownUsername'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="PredefinedUserQuery" />
				</xsl:call-template>
				
				<label for="showDropDownUsername">
					<xsl:value-of select="$i18n.Query.showUsername" />
				</label>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showDropDownCitizenIdentifier'" />
					<xsl:with-param name="name" select="'showDropDownCitizenIdentifier'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="PredefinedUserQuery" />
					<xsl:with-param name="class" select="'citizen-identifier'" />
				</xsl:call-template>
				
				<label for="showDropDownCitizenIdentifier">
					<xsl:value-of select="$i18n.Query.showCitizenID" />
				</label>
			</div>
			
			<xsl:for-each select="AvailiableAttributes/AttributeDescriptor">
			
				<div class="floatleft full marginbottom">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="concat('attribute-dropdown-', name)" />
						<xsl:with-param name="name" select="concat('attribute-dropdown-', name)" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="checked" >
							<xsl:if test="../../PredefinedUserQuery/SelectedDropDownAttributes/SelectedDropDownAttribute[name = current()/name]">true</xsl:if>
						</xsl:with-param>
						<xsl:with-param name="element" select="PredefinedUserQuery" />
						<xsl:with-param name="requestparameters" select="../../requestparameters" />
					</xsl:call-template>
					
					<label for="attribute-dropdown-{name}">
						<xsl:value-of select="$i18n.Query.show" />
						<xsl:text> </xsl:text>
						<xsl:value-of select="displayName" />
					</label>
				</div>
				
			</xsl:for-each>
			
			<div class="floatleft full bigmargintop">
				<h2><xsl:value-of select="$i18n.ShowForSelected" /></h2>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showName'" />
					<xsl:with-param name="name" select="'showName'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="PredefinedUserQuery" />
				</xsl:call-template>
				
				<label for="showName">
					<xsl:value-of select="$i18n.Query.showName" />
				</label>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showUsername'" />
					<xsl:with-param name="name" select="'showUsername'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="PredefinedUserQuery" />
				</xsl:call-template>
				
				<label for="showUsername">
					<xsl:value-of select="$i18n.Query.showUsername" />
				</label>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showCitizenIdentifier'" />
					<xsl:with-param name="name" select="'showCitizenIdentifier'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="PredefinedUserQuery" />
					<xsl:with-param name="class" select="'citizen-identifier'" />
				</xsl:call-template>
				
				<label for="showCitizenIdentifier">
					<xsl:value-of select="$i18n.Query.showCitizenID" />
				</label>
			</div>
			
			<div class="floatleft full marginbottom">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showEmail'" />
					<xsl:with-param name="name" select="'showEmail'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="PredefinedUserQuery" />
				</xsl:call-template>
				
				<label for="showEmail"><xsl:value-of select="$i18n.Query.showEmail" /></label>
			</div>
			
			<xsl:for-each select="AvailiableAttributes/AttributeDescriptor">
			
				<div class="floatleft full marginbottom">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="concat('attribute-', name)" />
						<xsl:with-param name="name" select="concat('attribute-', name)" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="checked" >
							<xsl:if test="../../PredefinedUserQuery/SelectedUserAttributes/SelectedUserAttribute[name = current()/name]">true</xsl:if>
						</xsl:with-param>
						<xsl:with-param name="element" select="PredefinedUserQuery" />
						<xsl:with-param name="requestparameters" select="../../requestparameters" />
					</xsl:call-template>
					
					<label for="attribute-{name}">
						<xsl:value-of select="$i18n.Query.show" />
						<xsl:text> </xsl:text>
						<xsl:value-of select="displayName" />
					</label>
				</div>
				
			</xsl:for-each>
			
			<div class="floatleft full bigmargintop">
				<h2><xsl:value-of select="$i18n.MultipartSigning" /></h2>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'useForMultipartSigning'" />
						<xsl:with-param name="name" select="'useForMultipartSigning'" />
						<xsl:with-param name="element" select="PredefinedUserQuery" /> 
					</xsl:call-template>
						
					<label for="useForMultipartSigning">
						<xsl:value-of select="$i18n.UseForMultipartSigning" />
					</label>
				</div>
			</div>
			
			<div id="multipart" class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setMultipartsAsOwners'" />
						<xsl:with-param name="name" select="'setMultipartsAsOwners'" />
						<xsl:with-param name="element" select="PredefinedUserQuery" /> 
					</xsl:call-template>
						
					<label for="setMultipartsAsOwners">
						<xsl:value-of select="$i18n.SetMultipartsAsOwners" />
					</label>
				</div>
			</div>
			
			<xsl:if test="ClosestManagerEnabled">
				
				<div class="floatleft full marginbottom">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'requireManagerSigning'" />
						<xsl:with-param name="name" select="'requireManagerSigning'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="PredefinedUserQuery" />
					</xsl:call-template>
					
					<label for="requireManagerSigning"><xsl:value-of select="$i18n.Query.requireManagerSigning" /></label>
				</div>
				
				<div class="floatleft full bigmargintop">
					<h2><xsl:value-of select="$i18n.ManagerSettings" /></h2>
				</div>
				
				<div class="floatleft full marginbottom">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'showManagerInfo'" />
						<xsl:with-param name="name" select="'showManagerInfo'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="PredefinedUserQuery" />
					</xsl:call-template>
					
					<label for="showManagerInfo"><xsl:value-of select="$i18n.Query.showManagerInfo" /></label>
				</div>
				
				<div id="managerinfo" style="display: none;">
					
					<div class="floatleft full marginbottom">
						<xsl:call-template name="createCheckbox">
							<xsl:with-param name="id" select="'showManagerName'" />
							<xsl:with-param name="name" select="'showManagerName'" />
							<xsl:with-param name="value" select="'true'" />
							<xsl:with-param name="element" select="PredefinedUserQuery" />
						</xsl:call-template>
						
						<label for="showManagerName"><xsl:value-of select="$i18n.Query.showName" /></label>
					</div>
					
					<div class="floatleft full marginbottom">
						<xsl:call-template name="createCheckbox">
							<xsl:with-param name="id" select="'showManagerUsername'" />
							<xsl:with-param name="name" select="'showManagerUsername'" />
							<xsl:with-param name="value" select="'true'" />
							<xsl:with-param name="element" select="PredefinedUserQuery" />
						</xsl:call-template>
						
						<label for="showManagerUsername"><xsl:value-of select="$i18n.Query.showUsername" /></label>
					</div>
					
					<div class="floatleft full marginbottom">
						<xsl:call-template name="createCheckbox">
							<xsl:with-param name="id" select="'showManagerEmail'" />
							<xsl:with-param name="name" select="'showManagerEmail'" />
							<xsl:with-param name="value" select="'true'" />
							<xsl:with-param name="element" select="PredefinedUserQuery" />
						</xsl:call-template>
						
						<label for="showManagerEmail"><xsl:value-of select="$i18n.Query.showEmail" /></label>
					</div>
					
					<xsl:for-each select="AvailiableAttributes/AttributeDescriptor">
					
						<div class="floatleft full marginbottom">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="concat('managerattribute-', name)" />
								<xsl:with-param name="name" select="concat('managerattribute-', name)" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="checked" >
									<xsl:if test="../../PredefinedUserQuery/SelectedManagerAttributes/SelectedManagerAttribute[name = current()/name]">true</xsl:if>
								</xsl:with-param>
								<xsl:with-param name="element" select="PredefinedUserQuery" />
								<xsl:with-param name="requestparameters" select="../../requestparameters" />
							</xsl:call-template>
							
							<label for="managerattribute-{name}">
								<xsl:value-of select="$i18n.Query.show" />
								<xsl:text> </xsl:text>
								<xsl:value-of select="displayName" />
							</label>
						</div>
						
					</xsl:for-each>
					
				</div>
				
			</xsl:if>
			
			<div class="floatleft full bigmarginbottom">
				<h2><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			</div>
			
			<div id="maskCitizenIDLastFourDigitsContainer" class="floatleft full">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'maskCitizenIDLastFourDigits'" />
						<xsl:with-param name="name" select="'maskCitizenIDLastFourDigits'" />
						<xsl:with-param name="element" select="PredefinedUserQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="maskCitizenIDLastFourDigits">
						<xsl:value-of select="$i18n.maskCitizenIDLastFourDigits" />
					</label>
					<div class="floatleft full">
						<p class="tiny"><xsl:value-of select="$i18n.Query.maskCitizenIDLastFourDigits.Info" /></p>
					</div>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'lockOnOwnershipTransfer'" />
						<xsl:with-param name="name" select="'lockOnOwnershipTransfer'" />
						<xsl:with-param name="element" select="PredefinedUserQuery" /> 
					</xsl:call-template>
					
					<label for="lockOnOwnershipTransfer">
						<xsl:value-of select="$i18n.lockOnOwnershipTransfer" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="PredefinedUserQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="PredefinedUserQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
				</div>
			</div>
			
			<p class="floatleft clearboth"><xsl:value-of select="$i18n.attributeDescription" /><br/><xsl:copy-of select="$i18n.attributeDescription2" /></p>
			
			<table id="attributes" class="floatleft clearboth border">
				<thead>
					<th><xsl:value-of select="$i18n.attributes.name" /></th>
					<th><xsl:value-of select="$i18n.attributes.value" /></th>
				</thead>
				<tbody>
					<tr>
						<td>prefix.firstname</td>
						<td><xsl:value-of select="$java.exportFirstName" /></td>
					</tr>
					<tr>
						<td>prefix.lastname</td>
						<td><xsl:value-of select="$java.exportLastName" /></td>
					</tr>
					<tr>
						<td>prefix.username</td>
						<td><xsl:value-of select="$java.exportUsername" /></td>
					</tr>
					<tr>
						<td>prefix.email</td>
						<td><xsl:value-of select="$java.exportEmail" /></td>
					</tr>
					<tr>
						<td>prefix.citizenIdentifier</td>
						<td><xsl:value-of select="$java.exportCitizenID" /></td>
					</tr>
					
					<xsl:for-each select="AvailiableAttributes/AttributeDescriptor">
						<tr>
							<td>
								<xsl:text>prefix.</xsl:text>
								<xsl:value-of select="name" />
							</td>
							<td><xsl:value-of select="displayName" />
							</td>
						</tr>
					</xsl:for-each>
					
					<xsl:if test="ClosestManagerEnabled">
					
						<tr class="manager">
							<td>prefix.managerFirstname</td>
							<td>
								<xsl:value-of select="$java.exportManager" />
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="$java.exportFirstName" />
							</td>
						</tr>
						<tr class="manager">
							<td>prefix.managerLastname</td>
							<td>
								<xsl:value-of select="$java.exportManager" />
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="$java.exportLastName" />
							</td>
						</tr>
						<tr class="manager">
							<td>prefix.managerUsername</td>
							<td>
								<xsl:value-of select="$java.exportManager" />
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="$java.exportUsername" />
							</td>
						</tr>
						<tr class="manager">
							<td>prefix.managerEmail</td>
							<td>
								<xsl:value-of select="$java.exportManager" />
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="$java.exportEmail" />
							</td>
						</tr>
						
						<xsl:for-each select="AvailiableAttributes/AttributeDescriptor">
							<tr class="manager">
								<td>
									<xsl:text>prefix.manager</xsl:text>
									<xsl:call-template name="toFirstLetterUppercase">
										<xsl:with-param name="text" select="name" />
									</xsl:call-template>
								</td>
								<td>
									<xsl:value-of select="$java.exportManager" />
									<xsl:text>&#160;</xsl:text>
									<xsl:value-of select="displayName" />
								</td>
							</tr>
						</xsl:for-each>
						
					</xsl:if>
					
				</tbody>
			</table>

			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>

		</form>

	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'InvalidPreSelectedUser']">

		<p class="error">
			<xsl:value-of select="$i18n.ValidationError.InvalidPreSelectedUser" />
		</p>

	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'UpdateFailedPredefinedUserQueryNotFound']">

		<p class="error">
			<xsl:value-of select="$i18n.PredefinedUserQueryNotFound" />
		</p>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.attributeName" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>