package com.nordicpeak.flowengine.queries.predefineduserquery.beans;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.queries.internaluserqueries.InternalUserQueriesAttributeDescriptor;
import com.nordicpeak.flowengine.queries.internaluserqueries.InternalUserQueriesSelectedAttribute;

@XMLElement
@Table(name = "predefined_user_query_user_attributes")
public class SelectedUserAttribute extends InternalUserQueriesSelectedAttribute {
	
	private static final long serialVersionUID = -5407922522706409574L;

	@DAOManaged(columnName = "queryID")
	@Key
	@ManyToOne
	private PredefinedUserQuery internalContactDetailQuery;
	
	public SelectedUserAttribute() {}
	
	public SelectedUserAttribute(String name, String displayName, Integer sortIndex) {
		
		super(name, displayName, sortIndex);
	}
	
	public SelectedUserAttribute(InternalUserQueriesAttributeDescriptor attributeDescriptor, Integer sortIndex) {
		
		this(attributeDescriptor.getName(), attributeDescriptor.getDisplayName(), sortIndex);
	}
	
}
