package com.nordicpeak.flowengine.queries.pricetablequery.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLUtils;

import com.nordicpeak.flowengine.queries.pricetablequery.PriceTableQueryProviderModule;

@Table(name = "price_table_query_instance_values")
@XMLElement(name = "RowValue")
public class PriceTableRowValue extends GeneratedElementable implements Serializable {
	
	
	private static final long serialVersionUID = 854568573886179411L;
	
	public static final Field QUERY_INSTANCE_RELATION = ReflectionUtils.getField(PriceTableRowValue.class, "instance");
	public static final Field ROW_RELATION = ReflectionUtils.getField(PriceTableRowValue.class, "row");
	
	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer valueID;
	
	@DAOManaged(columnName = "queryInstanceID")
	@ManyToOne
	private PriceTableQueryInstance instance;
	
	@DAOManaged(columnName = "rowID")
	@ManyToOne
	@XMLElement
	private PriceTableRow row;
	
	@DAOManaged
	private BigDecimal value;
	
	@DAOManaged
	@XMLElement
	private String comment;
	
	public PriceTableRowValue() {};
	
	public PriceTableRowValue(PriceTableRow row, BigDecimal value) {
		
		this.value = value;
		this.row = row;
	}
	
	public PriceTableQueryInstance getInstance() {
		
		return instance;
	}
	
	public void setInstance(PriceTableQueryInstance instance) {
		
		this.instance = instance;
	}
	
	public PriceTableRow getRow() {
		
		return row;
	}
	
	public void setRow(PriceTableRow tableRow) {
		
		this.row = tableRow;
	}
	
	public Integer getValueID() {
		return valueID;
	}
	
	public void setValueID(Integer cellValueID) {
		this.valueID = cellValueID;
	}
	
	public BigDecimal getValue() {
		return value;
	}
	
	public void setValue(BigDecimal value) {
		this.value = value;
	}
	
	public String getComment() {
		return comment;
	}
	
	public void setComment(String comment) {
		this.comment = comment;
	}
	
	@Override
	public Element toXML(Document doc) {
		
		Element element = super.toXML(doc);
		
		if (value != null) {
			XMLUtils.appendNewElement(doc, element, "formattedValue", PriceTableQueryProviderModule.formatBigDecimal(value, 0, row.getQuery().getDecimalSetting()));
		}
		
		return element;
	}
	
}
