package com.nordicpeak.flowengine.queue.beans;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.webutils.http.RequestUtils;

import com.nordicpeak.flowengine.queue.UserQueueSlotModule;
import com.nordicpeak.openhierarchy.payment.interfaces.PaymentCallback;

public class QueueSlotPaymentCallback implements PaymentCallback {

	private final UserQueueSlotModule userQueueSlotModule;
	private final String serverURL;
	private final int queueSlotID;
	private final String siteName;

	public QueueSlotPaymentCallback(UserQueueSlotModule userQueueSlotModule, QueueSlot queueSlot, String siteName, HttpServletRequest req) {

		super();

		this.userQueueSlotModule = userQueueSlotModule;
		queueSlotID = queueSlot.getQueueSlotID();
		serverURL = RequestUtils.getFullContextPathURL(req);
		this.siteName = siteName;
	}

	@Override
	public String getPaymentFormURL() {

		return serverURL + userQueueSlotModule.getFullAlias() + "/pay/" + queueSlotID;
	}

	@Override
	public String getProcessPaymentURL() {

		return serverURL + userQueueSlotModule.getFullAlias() + "/processPayment/" + queueSlotID;
	}

	@Override
	public boolean supportsDelayedPayments() {

		return true;
	}

	@Override
	public String getSiteName() {

		return siteName;
	}
}
