<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="QueueQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>			
			<a name="query{QueueQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>

			<xsl:if test="not(QueueQueryInstance/QueueQuery/hideTitle = 'true')">
				<h2>
					<xsl:value-of select="QueueQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
				</h2>
			</xsl:if>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<xsl:if test="QueueQueryInstance/QueueQuery/Queue/price > 0">
				<p class="tiny">
					<xsl:choose>
						<xsl:when test="QueueQueryInstance/QueueQuery/paymentRequiredText">
							<xsl:value-of select="QueueQueryInstance/QueueQuery/paymentRequiredText"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$i18n.PaymentRequired.DefaultText"/>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:text> </xsl:text>
					<xsl:value-of select="QueueQueryInstance/QueueQuery/Queue/price"/>
					<xsl:value-of select="$i18n.PaymentRequired.Suffix"/>
				</p>
			</xsl:if>
				
			<p>
				<xsl:if test="QueueQueryInstance/accepted = 'true'">
					<xsl:value-of select="QueueQueryInstance/QueueQuery/acceptText" />
				</xsl:if>
			
				<xsl:if test="QueueQueryInstance/comment">
					<div class="bigmargintop">
						<strong><xsl:value-of select="$i18n.Comment"/></strong>
						<br/>
						<xsl:call-template name="replaceLineBreak">
							<xsl:with-param name="string" select="QueueQueryInstance/comment"/>
						</xsl:call-template>
					</div>
				</xsl:if>
			</p>
			
		</div>
		
	</xsl:template>		

	<xsl:template match="CheckboxAlternative" mode="show">

		<xsl:value-of select="name" />		

		<xsl:if test="position() != last()"><br/></xsl:if>
	
	</xsl:template>

</xsl:stylesheet>