package com.nordicpeak.flowengine.randombookingnumber.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;
import java.util.Objects;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "random_booking_numbers")
@XMLElement
public class RandomBookingNumber extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -4151639499546880768L;

	public static final Field FIELD_INTERVAL = ReflectionUtils.getField(RandomBookingNumber.class, "interval");
	public static final Field FIELD_MAPPINGS = ReflectionUtils.getField(RandomBookingNumber.class, "mappings");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer numberID;

	@DAOManaged(columnName = "intervalID")
	@ManyToOne
	@XMLElement
	private RandomBookingInterval interval;

	@DAOManaged(columnName = "numberIndex")
	@OrderBy
	@XMLElement
	private Integer index;

	@DAOManaged
	@XMLElement
	private boolean enabled;

	@DAOManaged
	@XMLElement
	private String description;

	@DAOManaged
	@OneToMany
	private List<RandomBookingNumberMapping> mappings;

	public RandomBookingNumber() {}

	public RandomBookingNumber(Integer index, boolean enabled) {

		this.index = index;
		this.enabled = enabled;
	}

	@Override
	public String toString() {

		return "(numberID=" + numberID + ", index=" + index + ")";
	}

	public Integer getNumberID() {

		return numberID;
	}

	public void setNumberID(Integer numberID) {

		this.numberID = numberID;
	}

	public RandomBookingInterval getInterval() {

		return interval;
	}

	public void setInterval(RandomBookingInterval interval) {

		this.interval = interval;
	}

	public Integer getIndex() {

		return index;
	}

	public void setIndex(Integer index) {

		this.index = index;
	}

	public boolean isEnabled() {

		return enabled;
	}

	public void setEnabled(boolean enabled) {

		this.enabled = enabled;
	}

	public String getDescription() {

		return description;
	}

	public void setDescription(String description) {

		this.description = description;
	}

	public List<RandomBookingNumberMapping> getMappings() {

		return mappings;
	}

	public void setMappings(List<RandomBookingNumberMapping> mappings) {

		this.mappings = mappings;
	}

	@Override
	public int hashCode() {

		return Objects.hash(numberID);
	}

	@Override
	public boolean equals(Object obj) {

		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		RandomBookingNumber other = (RandomBookingNumber) obj;
		return Objects.equals(numberID, other.numberID);
	}

}
