package com.nordicpeak.flowengine.recommendedflows;

import java.io.Serializable;
import java.sql.Date;

import se.unlogic.standardutils.date.DateUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
public class RecommendedFlow extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 4193462052466705658L;

	private final Integer flowFamilyID;
	private final Integer flowInstanceCount;
	private final Date fromDate;
	private final Date toDate;

	@XMLElement
	private final String description;

	public RecommendedFlow(Integer flowFamilyID, Integer flowInstanceCount, java.util.Date fromDate, java.util.Date toDate, String description) {
		super();

		this.flowFamilyID = flowFamilyID;
		this.flowInstanceCount = flowInstanceCount;
		this.description = description;

		if (fromDate == null) {
			this.fromDate = null;
			
		} else {
			this.fromDate = DateUtils.setTimeToMidnight(new java.sql.Date(fromDate.getTime()));
		}

		if (toDate == null) {
			this.toDate = null;
			
		} else {
			this.toDate = DateUtils.setTimeToMaximum(new java.sql.Date(toDate.getTime()));
		}
	}

	public Integer getFlowFamilyID() {
		return flowFamilyID;
	}

	public Integer getFlowInstanceCount() {
		return flowInstanceCount;
	}

	public Date getFromDate() {
		return fromDate;
	}

	public Date getToDate() {
		return toDate;
	}

	public String getDescription() {
		return description;
	}

	@Override
	public String toString() {
		
		return getClass().getSimpleName() + " (flowFamilyID: " + flowFamilyID + ")";
	}

}
