<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ListFlowInstancesExtension"/>
		
	</xsl:template>
		
	<xsl:template match="ListFlowInstancesExtension">
	
		<div class="errands-wrapper draft">
			<div class="heading-wrapper">
				<h2><xsl:value-of select="title" /></h2>
				<h3 class="clearboth">
					<xsl:value-of select="description" disable-output-escaping="yes"/>
				</h3>
				<xsl:call-template name="createHelpDialog">
					<xsl:with-param name="id" select="'recommended-flows'" />
					<xsl:with-param name="text" select="helpText" />
				</xsl:call-template>
			</div>
			<table class="oep-table errand-table">
				<thead>
					<tr>
						<th class="icon"></th>
						<th class="name"><span><xsl:value-of select="$i18n.Column.FlowName" /></span></th>
						<th class="description"><span><xsl:value-of select="$i18n.Column.Description" /></span></th>
						<th class="link"></th>
					</tr>
				</thead>
				<tbody>
					<xsl:apply-templates select="Flows/RecommendedFlow" mode="list" />
				</tbody>
			</table>
		</div>
	
		<div class="divider errands" />
	
	</xsl:template>
	
	<xsl:template match="RecommendedFlow" mode="list">
	
		<tr>
			<td class="icon"><i data-icon-before="w"></i></td>
			<td data-title="{$i18n.Column.FlowName}" class="name"><xsl:value-of select="flowName" /></td>
			
			<td data-title="{$i18n.Column.Description}" class="description"><xsl:value-of select="description" /></td>
			<td class="link">
				<a class="btn btn-green vertical-align-middle" href="{URL}"><xsl:value-of select="$i18n.ListFlowInstancesExtension.start" /></a>
			</td>
		</tr>
		
	</xsl:template>
	
	<xsl:template name="createHelpDialog">
		
		<xsl:param name="id" />
		<xsl:param name="text" />
		<xsl:param name="class" select="''" />
		
		<div class="help {$class}">
			<a class="open-help" href="#" data-icon-after="?" data-help-box="helpdialog_{$id}">
				<span>
					<xsl:value-of select="$i18n.Help" />
				</span>
			</a>
			
			<div class="help-box" data-help-box="helpdialog_{$id}">
				<div>
					<div>
						<a class="close" href="#" data-icon-after="x"></a>
						<h2 class="h1 full" data-icon-before="?">
							<xsl:value-of select="title" />
						</h2>
						<xsl:value-of select="$text" disable-output-escaping="yes"/>
					</div>
				</div>
			</div>
		</div>
		
		<div class="help-backdrop" data-help-box="helpdialog_{$id}" />
		
	</xsl:template>
	
</xsl:stylesheet>