package com.nordicpeak.flowengine.remoteflowinstance;

import java.io.ObjectStreamException;
import java.io.Serializable;
import java.util.Map.Entry;

import se.unlogic.hierarchy.core.beans.Group;
import se.unlogic.hierarchy.core.handlers.SimpleAttributeHandler;
import se.unlogic.hierarchy.core.interfaces.attributes.AttributeHandler;
import se.unlogic.hierarchy.core.interfaces.attributes.MutableAttributeHandler;
import se.unlogic.hierarchy.foregroundmodules.groupproviders.SimpleGroup;

public class RemoteGroup implements Serializable {

	private static final long serialVersionUID = 3060996007410755136L;

	protected Integer groupID;

	protected String name;

	protected String description;

	protected boolean enabled;

	private SimpleAttributeHandler attributeHandler;

	public RemoteGroup() {}

	public RemoteGroup(Group group) {

		groupID = group.getGroupID();
		name = group.getName();
		description = group.getDescription();
		enabled = group.isEnabled();

		if (group.getAttributeHandler() != null && !group.getAttributeHandler().isEmpty()) {

			attributeHandler = new SimpleAttributeHandler(group.getAttributeHandler().getAttributeMap());
		}
	}

	public Integer getGroupID() {
		return groupID;
	}

	public String getName() {
		return name;
	}

	public String getDescription() {
		return description;
	}

	public boolean isEnabled() {
		return enabled;
	}

	public AttributeHandler getAttributeHandler() {

		return attributeHandler;
	}
	
	public Object readResolve() throws ObjectStreamException {
		
		SimpleGroup group = new SimpleGroup();
		group.setGroupID(groupID);
		group.setName(name);
		group.setDescription(description);
		group.setEnabled(enabled);

		if (attributeHandler != null) {

			MutableAttributeHandler userAttributeHandler = group.getAttributeHandler();

			for (Entry<String, String> entry : attributeHandler.getAttributeMap().entrySet()) {

				userAttributeHandler.setAttribute(entry.getKey(), entry.getValue());
			}
		}

		return group;
	}
}
