<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		<xsl:apply-templates select="ShowQueryForm"/>
		
	</xsl:template>
	
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
<!-- 				<xsl:if test="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/hideTitle = 'true'"> notitle</xsl:if> -->
				<xsl:if test="RemoteSinglesignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<article class="RemoteSinglesignquery show-mode">
				
<!-- 				<xsl:if test="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/hideBackground = 'true'"> -->
<!-- 					<xsl:attribute name="class">RemoteSinglesignquery show-mode nobackground</xsl:attribute> -->
<!-- 				</xsl:if> -->
				
				<div class="heading-wrapper">
				
<!-- 					<xsl:if test="not(RemoteSinglesignQueryInstance/RemoteSinglesignQuery/hideTitle = 'true')"> -->
						<h2>
							<xsl:value-of select="RemoteSinglesignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
						</h2>
<!-- 					</xsl:if> -->
				</div>
				
				<xsl:if test="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/description">
					<span class="italic">
						<xsl:value-of select="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>
				
				<fieldset>

					<div class="clearboth bigmarginbottom bordertop"></div>

					<div class="split ">
						<strong class="block"><xsl:value-of select="$i18n.CitizenID" /></strong>
						<xsl:value-of select="RemoteSinglesignQueryInstance/citizenID"/>
					</div>
					
					<div class="split">
						<strong class="block"><xsl:value-of select="$i18n.Firstname" /></strong>
						<xsl:value-of select="RemoteSinglesignQueryInstance/firstname"/>
					</div>
					
					<div class="split odd">
						<strong class="block"><xsl:value-of select="$i18n.Lastname" /></strong>
						<xsl:value-of select="RemoteSinglesignQueryInstance/lastname"/>
					</div>
					
					<div class="split">
						<strong class="block"><xsl:value-of select="$i18n.Email" /></strong>
						<xsl:value-of select="RemoteSinglesignQueryInstance/email"/>
					</div>
					
					<div class="split odd">
						<strong class="block"><xsl:value-of select="$i18n.MobilePhone" /></strong>
						<xsl:value-of select="RemoteSinglesignQueryInstance/mobilePhone"/>
					</div>
					
				</fieldset>

			</article>
				
		</div>
		
	</xsl:template>	
	
	<xsl:template match="ShowQueryForm">
	
		<xsl:variable name="shortQueryID" select="concat('q', RemoteSinglesignQueryInstance/RemoteSinglesignQuery/queryID)" />
	
		<xsl:variable name="queryID" select="concat('query_', RemoteSinglesignQueryInstance/RemoteSinglesignQuery/queryID)" />
	
		<div class="query RemoteSinglesignquery" id="{$queryID}">
			<xsl:attribute name="class">
				<xsl:text>query RemoteSinglesignquery</xsl:text>
<!-- 				<xsl:if test="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/hideTitle = 'true'"> notitle</xsl:if> -->
				<xsl:if test="EnableAjaxPosting"> enableAjaxPosting</xsl:if>
				<xsl:if test="RemoteSinglesignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="{$queryID}" />
		
			<xsl:if test="ValidationErrors/validationError">
				<div id="{$queryID}-validationerrors" class="validationerrors">
					<xsl:if test="ValidationErrors/validationError[messageKey]">
						<div class="info-box error">
							<xsl:apply-templates select="ValidationErrors/validationError[messageKey]"/>
							<div class="marker"></div>
						</div>
					</xsl:if>
				</div>
			</xsl:if>
	
			<article>
			
				<xsl:attribute name="class">
<!-- 					<xsl:if test="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/hideBackground = 'true'"> -->
<!-- 						<xsl:text> nobackground</xsl:text> -->
<!-- 					</xsl:if> -->
					
					<xsl:if test="ValidationErrors/validationError[messageKey]">
						<xsl:text> error</xsl:text>
					</xsl:if>
					
				</xsl:attribute>
			
				<div class="heading-wrapper">
					
<!-- 					<xsl:if test="not(RemoteSinglesignQueryInstance/RemoteSinglesignQuery/hideTitle = 'true')"> -->
						<h2>
							<xsl:value-of select="RemoteSinglesignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
						</h2>
<!-- 					</xsl:if> -->
					
					<xsl:if test="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/helpText">		
						<xsl:apply-templates select="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/helpText" />
					</xsl:if>
				</div>
				
				<xsl:if test="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/description">
					<span class="italic">
						<xsl:if test="/Document/useCKEditorForDescription = 'true'"><xsl:attribute name="class">italic html-description</xsl:attribute></xsl:if>
						<xsl:value-of select="RemoteSinglesignQueryInstance/RemoteSinglesignQuery/description" disable-output-escaping="yes" />
					</span>
				</xsl:if>

				<fieldset>

					<div class="clearboth bigmarginbottom bordertop"></div>

					<div class="split ">
						<strong class="block"><xsl:value-of select="$i18n.CitizenID" /></strong>
						<xsl:value-of select="RemoteSinglesignQueryInstance/citizenID"/>
					</div>
					
					<div class="split">
						<strong class="block"><xsl:value-of select="$i18n.Firstname" /></strong>
						<xsl:value-of select="RemoteSinglesignQueryInstance/firstname"/>
					</div>
					
					<div class="split odd">
						<strong class="block"><xsl:value-of select="$i18n.Lastname" /></strong>
						<xsl:value-of select="RemoteSinglesignQueryInstance/lastname"/>
					</div>
					
					<div class="split">
						
						<xsl:variable name="fieldName" select="concat($shortQueryID, '_email')" />
						
						<xsl:if test="ValidationErrors/validationError[fieldName = $fieldName] or ValidationErrors/validationError[messageKey = 'EmailAlreadyTaken']">
							<xsl:attribute name="class">
								<xsl:text>split invalid input-error</xsl:text>
							</xsl:attribute>
						</xsl:if>	
					
						<label for="{$fieldName}">
							<xsl:attribute name="class">
								<xsl:text>floatleft full </xsl:text>
							</xsl:attribute>
							
							<xsl:value-of select="$i18n.Email" />
						</label>
						
						<xsl:call-template name="createTextField">
							<xsl:with-param name="id" select="$fieldName" />
							<xsl:with-param name="name" select="$fieldName" />
							<xsl:with-param name="title" select="$i18n.Email"/>
							<xsl:with-param name="size" select="50"/>
							<xsl:with-param name="value" select="RemoteSinglesignQueryInstance/email"/>
						</xsl:call-template>
						
						<xsl:apply-templates select="ValidationErrors/validationError[fieldName = $fieldName]"/>
						
					</div>
					
					<div class="split odd">
						
						<xsl:variable name="fieldName" select="concat($shortQueryID, '_mobilephone')" />
						
						<xsl:if test="ValidationErrors/validationError[fieldName = $fieldName]">
							<xsl:attribute name="class">
								<xsl:text>split odd invalid input-error</xsl:text>
							</xsl:attribute>
						</xsl:if>
						
						<label for="{$fieldName}">
							<xsl:attribute name="class">
								<xsl:text>floatleft full </xsl:text>
							</xsl:attribute>
							
							<xsl:value-of select="$i18n.MobilePhone" />
						</label>
						
						<xsl:call-template name="createTextField">
							<xsl:with-param name="id" select="$fieldName" />
							<xsl:with-param name="name" select="$fieldName" />
							<xsl:with-param name="title" select="$i18n.MobilePhone"/>
							<xsl:with-param name="size" select="50"/>
							<xsl:with-param name="value" select="RemoteSinglesignQueryInstance/mobilePhone"/>
						</xsl:call-template>
						
						<xsl:apply-templates select="ValidationErrors/validationError[fieldName = $fieldName]"/>
					</div>
					
				</fieldset>
				
			</article>
		
		</div>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'EndpointError']">
		
		<span>
			<strong data-icon-before="!">
<!-- 				<xsl:if test="../../RequestMetadata/testing = 'true'"> -->
<!-- 					<xsl:attribute name="title"> -->
<!-- 						<xsl:value-of select="displayName"/> -->
<!-- 					</xsl:attribute> -->
<!-- 				</xsl:if> -->
				
				<xsl:choose>
					<xsl:when test="../../RemoteSinglesignQueryInstance/RemoteSinglesignQuery/endpointErrorText">
						<xsl:value-of select="../../RemoteSinglesignQueryInstance/RemoteSinglesignQuery/endpointErrorText" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$i18n.StandardEndpointErrorText"></xsl:value-of>
					</xsl:otherwise>
				</xsl:choose>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'ContactWayRequired']">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.ValidationError.ContactWayRequired"/>
			</strong>
		</span>
		
	</xsl:template>
	
	<xsl:template match="validationError[validationErrorType = 'RequiredField']">
		
		<i data-icon-after="!" title="{$i18n.ValidationError.RequiredField}"></i>
		
	</xsl:template>
	
	<xsl:template match="validationError[validationErrorType = 'InvalidFormat']">
		
		<i data-icon-after="!" title="{$i18n.ValidationError.InvalidFormat}"></i>
		
	</xsl:template>
	
	<xsl:template match="validationError">
		
		<span>
			<strong data-icon-before="!">
				<xsl:value-of select="$i18n.UnknownValidationError"/>
			</strong>
		</span>
		
	</xsl:template>
		
</xsl:stylesheet>