var i18nReservationModule = {
	"EMPTY_TABLE": "EMPTY_TABLE",
	"NEXT": "NEXT",
	"PREVIOUS": "PREVIOUS",
	"DELETE": "DELETE",
	"CONFIRM_DELETE": "CONFIRM_DELETE",
	"SEARCH": "SEARCH",
	"LENGTH_MENU": "LENGTH_MENU",
	"INFO": "INFO",
	"INFO_EMPTY": "INFO_EMPTY",
	"INFO_FILTERED": "INFO_FILTERED",
	"FETCH_ERROR": "FETCH_ERROR",
	"LOADING_RECORDS": "LOADING_RECORDS"
};
$(function() {
	
	var $tableElement = $("#reservations");
	
	var datatable = $tableElement.DataTable({
		"ajax": {
			url: $tableElement.data("reservations-url"),
			beforeSend: function(jqXHR, settings) {
				
				jqXHR.setRequestHeader('NoLoginRedirect', 'true');
			},
			error: function(jqXHR, textStatus, errorThrown) {
				
				if (jqXHR.status == 403) { // Access denied
				
					window.location.reload();
					
				} else {
					
					$tableElement.find("td.dataTables_empty").text(i18nReservationModule.FETCH_ERROR);
					
					if (console != undefined) {
						
						console.error(errorThrown);
					}
				}
			}
		},		
		"deferRender": true,
		"lengthMenu": [ 15, 50, 100, 200, 500 ],
		"order": [[ 4, 'desc' ]],
		"dom": 'frtipl',
		"autoWidth": false,
        "columns": [
    		{
    			"data": "reservationID"
    		},
    		{
    			"data": "objectID"
    		},
    		{
    			"data": "flowFamilyID"
    		},
    		{
    			"data": "flowInstanceID"
    		},
    		{
    			"data": "added"
    		},
    		{
    			"data": "expires"
    		},
    		{
				"render": function (data, type, row, meta) {
					
					var reservationID = row["reservationID"];
					var url = $tableElement.data("delete-url").replace("$reservationID", reservationID);
					var confirmText = i18nReservationModule.CONFIRM_DELETE + ": " + reservationID;
					
					return "<a class='btn btn-red nowrap' href='" + url + "' title='" + confirmText + "' onclick='return confirmHyperlinkPost(this);'>" + i18nReservationModule.DELETE + "</a>";
				}
    		}
    	],
		"language": {
			"emptyTable": i18nReservationModule.EMPTY_TABLE,
			"info":           i18nReservationModule.INFO,
			"infoEmpty":      i18nReservationModule.INFO_EMPTY,
			"infoFiltered":   i18nReservationModule.INFO_FILTERED,
			"infoPostFix":    "",
			"paginate": {
				"next": i18nReservationModule.NEXT,
				"previous": i18nReservationModule.PREVIOUS
			},
			"search": i18nReservationModule.SEARCH,
			"zeroRecords": i18nReservationModule.ZERO_RECORDS,
			"lengthMenu": i18nReservationModule.LENGTH_MENU,
			"loadingRecords": i18nReservationModule.LOADING_RECORDS,

		},
		"preDrawCallback": function(settings) {
			
			// Remove callback
			settings.aoPreDrawCallback.splice(0, 1);
			
			settings.oClasses.sPageButton = "btn btn-inline btn-light";
		},		
    });
			
	var filterDiv = $tableElement.closest(".dataTables_wrapper").find(".dataTables_filter");
	var filterInput = filterDiv.find("input");
	var filterLabel = filterDiv.find("label"); 
	filterInput.attr("placeholder", filterLabel.text());
	filterDiv.append(filterInput);
	filterLabel.remove();

});