package com.nordicpeak.flowengine.restrictedflowadmin;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.exceptions.AccessDeniedException;
import se.unlogic.openhierarchy.foregroundmodules.siteprofile.interfaces.SiteProfile;

import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.interfaces.FlowInstanceAccessController;
import com.nordicpeak.flowengine.interfaces.ImmutableFlowInstance;


public class RestrictedFlowAdminAccessController implements FlowInstanceAccessController {

	private final boolean mutable;
	private final RestrictedFlowAdminModule restrictedFlowAdminModule;
	
	public RestrictedFlowAdminAccessController(boolean mutable, RestrictedFlowAdminModule restrictedFlowAdminModule) {

		super();
		this.mutable = mutable;
		this.restrictedFlowAdminModule = restrictedFlowAdminModule;
	}

	@Override
	public void checkNewFlowInstanceAccess(Flow flow, User user, SiteProfile profile) throws AccessDeniedException {

		if (!restrictedFlowAdminModule.hasFlowAccess(user, flow)) {
			
			throw new AccessDeniedException("User is not restricted flow admin for flow type of " + flow);
		}
	}

	@Override
	public void checkFlowInstanceAccess(ImmutableFlowInstance flowInstance, User user) throws AccessDeniedException {}

	@Override
	public boolean isMutable(ImmutableFlowInstance flowInstance, User user) {

		return mutable;
	}

}
