<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output encoding="ISO-8859-1" method="html" version="4.0"/>

	<xsl:include href="classpath://com/nordicpeak/flowengine/queries/common/xsl/QueryAdminCommon.sv.xsl"/>
	<xsl:include href="CompanyDetailsQueryAdminTemplates.xsl"/>
	
	<xsl:variable name="java.queryTypeName">Fretagsuppgiftsfrga (SSBTEN/SSBTGU)</xsl:variable>
	<xsl:variable name="java.queryDescription">
Frgetypen Fretagsuppgiftsfrga (SSBTEN/SSBTGU) har koppling till Bolagsverkets sammansatta bastjnster fr grundlggande uppgifter om fretag och engagemang. 
I e-tjnsten kan inloggad anvndare vlja mellan de fretag som den r firmatecknare fr. E-tjnster dr denna frga skall anvndas mste anmlas till Bolagsverket.
Bolagsverket kommer d att registrera ett servicenamn som skall anges under instllningarna p frgan.
	</xsl:variable>
	
	<xsl:variable name="java.shareCapital">Aktiekapital</xsl:variable>
	<xsl:variable name="java.shareCount">Antal aktier</xsl:variable>
	<xsl:variable name="java.distributionOfIssuedShares">Frdelning av utgivna aktier</xsl:variable>
	<xsl:variable name="java.shareType">Aktieslag</xsl:variable>
	<xsl:variable name="java.count">Antal</xsl:variable>
	<xsl:variable name="java.voteValue">Rstvrde</xsl:variable>
	<xsl:variable name="java.hardCodedCompanyName">Enskild nringsverksamhet</xsl:variable>
	
	<xsl:variable name="i18n.CompanyDetailsQueryNotFound">Den begrda frgan hittades inte!</xsl:variable>
	<xsl:variable name="i18n.CompanyTypeSelection.Title">Vlj vilka fretagsformer som ska hmtas</xsl:variable>
	<xsl:variable name="i18n.CompanyTypeSelection.Description">Vlj vilka fretagsformer som ska hmtas frn bastjnsterna fr den inloggade anvndaren.</xsl:variable>
	<xsl:variable name="i18n.AB">Aktiebolag (AB)</xsl:variable>
	<xsl:variable name="i18n.BRF">Bostadsrttsfrening (BRF)</xsl:variable>
	<xsl:variable name="i18n.E">Enskild nringsverksamhet (E)</xsl:variable>
	<xsl:variable name="i18n.EK">Ekonomisk frening (EK)</xsl:variable>
	<xsl:variable name="i18n.HB">Handelsbolag (HB)</xsl:variable>
	<xsl:variable name="i18n.KB">Kommanditbolag (KB)</xsl:variable>
	
	<xsl:variable name="i18n.UDSelection.Title">Vlj vilka uppgifter som ska hmtas och visas (grundlggande uppgifter)</xsl:variable>
	<xsl:variable name="i18n.UDSelection.Description">Vlj vilka fretagsuppgifter som ska hmtas frn bastjnsterna. Vissa uppgifter r kopplade till bolagsform och hmtas drfr endast fr vissa bolagsformer.</xsl:variable>
	
	<xsl:variable name="i18n.UDSelectionExtension.Title">Vlj vilka uppgifter som ska hmtas och visas (utkade uppgifter)</xsl:variable>
	<xsl:variable name="i18n.UDSelectionExtension.Description">Dessa uppgifter kan till skillnad frn dom i tabellen ovan bara hmtas for vissa roller och krver drfr speciell hantering i e-tjnsterna. Om du vill skerstlla att dessa uppgifter alltid kommer med i tjnsten s mste du med hjlp av regler hantera dom fall dr dessa inte fr hmtas av den inloggade anvndaren. Detta kan gras exempelvis genom att visa en filuppladdningsfrga i dom fall d uppgifterna inte fr hmtas.</xsl:variable>	
	
	<xsl:variable name="i18n.UDName">Uppgift</xsl:variable>
	<xsl:variable name="i18n.UDSource">Ansvarig myndighet</xsl:variable>
	
	<xsl:variable name="i18n.Source.Bolagsverket">Bolagsverket</xsl:variable>
	<xsl:variable name="i18n.Source.Skatteverket">Skatteverket</xsl:variable>	
	
	<!-- <xsl:variable name="i18n.UseUD0001">Registrerat fretagsnamn (UD0001)</xsl:variable> -->
	
	<xsl:variable name="i18n.UseUD0003">Juridisk person postadress (UD0003)</xsl:variable>
	<xsl:variable name="i18n.UseUD0004">E-postadress till fretag (UD0004)</xsl:variable>
	<xsl:variable name="i18n.UseUD0006">Telefonnummer till fretag (UD0006)</xsl:variable>
	<xsl:variable name="i18n.UseUD0023">Enskild nringsidkares folkbokfringsadress (UD0023)</xsl:variable>
	
	<!-- <xsl:variable name="i18n.UseUD0025">Fretagsform (UD0025)</xsl:variable> -->
		
	<xsl:variable name="i18n.UseUD0029">F-skatt eller FA-skatt (UD0029, endast tillgnglig fr vissa roller)</xsl:variable>
	<xsl:variable name="i18n.UseUD0031">Momsregistrering (UD0031, endast tillgnglig fr vissa roller)</xsl:variable>
	<xsl:variable name="i18n.UseUD0033">Arbetsgivarregistrering (UD0033, endast tillgnglig fr vissa roller)</xsl:variable>		
		
	<xsl:variable name="i18n.UseUD0045">Firmateckning (UD0045)</xsl:variable>
	<xsl:variable name="i18n.UseUD0046">Verksamhetsbeskrivning (UD0046)</xsl:variable>
	<xsl:variable name="i18n.UseUD0047">Samlade funktionrer (UD0047)</xsl:variable>
	<xsl:variable name="i18n.UseUD0048">Aktiekapital (UD0048)</xsl:variable>
	
	<xsl:variable name="i18n.TargetEnvironment.Title">Instans av bastjnsterna</xsl:variable>
	<xsl:variable name="i18n.TargetEnvironment.Description">Vlj vilken instans av bastjnsterna som frgan ska kopplas mot.</xsl:variable>
	<xsl:variable name="i18n.TEST">Test</xsl:variable>
	<xsl:variable name="i18n.ACCEPTANCE">Acceptans</xsl:variable>
	<xsl:variable name="i18n.PRODUCTION">Produktion</xsl:variable>

	<xsl:variable name="i18n.ServiceName.Title">Servicenamn</xsl:variable>
	<xsl:variable name="i18n.ServiceName.Description">Fr att f sl mot bastjnstern s krvs att servicenamnet finns registrerat hos Bolagsverket. Ange det registrerade namnet nedan.</xsl:variable>
	<xsl:variable name="i18n.ServiceName">Servicenamn</xsl:variable>
	<xsl:variable name="i18n.CompanyTypes.ValidationError">Bolagsformer</xsl:variable>
	
	<xsl:variable name="i18n.CompanyTypeDescription.Title">Visning av fretagsform</xsl:variable>
	<xsl:variable name="i18n.ShowCompanyTypeDescription">Visa fretagsform i formulret med fretagsuppgifter</xsl:variable>
	<xsl:variable name="i18n.showCompaniesAsRadiosAndKeepShowing">Visa fretagsengagemang (fretagens namn och organisationsnummer) som radioknappfrga istllet fr rullista</xsl:variable>
	<xsl:variable name="i18n.showCompaniesAsRadiosAndKeepShowing.description">Nr du bockar i denna ruta visas alla fretagen som radioknappfrga och samtliga svarsalternativ visas i frhandsgranska-sidan, i rende och i rende-PDF. Inte bara det fretag som valts allts.</xsl:variable>
	
	<xsl:variable name="i18n.AdvancedSettings">Avancerade instllningar</xsl:variable>
	<xsl:variable name="i18n.setAsAttribute">Spara vrden som attribut</xsl:variable>
	<xsl:variable name="i18n.attributeName">Attributprefix</xsl:variable>
	<xsl:variable name="i18n.attributeDescription">Fljande attribut kommer att sparas (om aktiverade ovan) med det ovan valda prefixet. Anvndningsexempel om du valt prefixet 'test': $attribute{test.organizationNumber}</xsl:variable>
	<xsl:variable name="i18n.attributes.name">Attributnamn</xsl:variable>
	<xsl:variable name="i18n.attributes.value">Vrde</xsl:variable>
	
	<xsl:variable name="i18n.Attribute.organizationNumber">Organisationsnummer</xsl:variable>
	<xsl:variable name="i18n.Attribute.companyName">Registrerat fretagsnamn (UD0001)</xsl:variable>
	<xsl:variable name="i18n.Attribute.companyType">Fretagsform (UD0025) frkortat, ex AB</xsl:variable>
	<xsl:variable name="i18n.Attribute.companyTypeDescription">Fretagsform (UD0025), ex Aktiebolag</xsl:variable>

</xsl:stylesheet>
