package com.nordicpeak.flowengine.queries.ssbt;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.queries.basequery.BaseQueryCRUD;

public class CompanyDetailsQueryCRUD extends BaseQueryCRUD<CompanyDetailsQuery, CompanyDetailsQueryProviderModule> {

	protected AnnotatedDAOWrapper<CompanyDetailsQuery, Integer> queryDAO;

	public CompanyDetailsQueryCRUD(AnnotatedDAOWrapper<CompanyDetailsQuery, Integer> queryDAO, BeanRequestPopulator<CompanyDetailsQuery> populator, String typeElementName, String typeLogName, String listMethodAlias, CompanyDetailsQueryProviderModule callback) {

		super(CompanyDetailsQuery.class, queryDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);

		this.queryDAO = queryDAO;
	}

	@Override
	protected CompanyDetailsQuery populateFromUpdateRequest(CompanyDetailsQuery bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {

		CompanyDetailsQuery query = super.populateFromUpdateRequest(bean, req, user, uriParser);

		List<ValidationError> validationErrors = new ArrayList<ValidationError>();

		this.populateQueryDescriptor((QueryDescriptor) query.getQueryDescriptor(), req, validationErrors);

		if(!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}

		return query;
	}
}
