package com.nordicpeak.flowengine.queries.ssbt;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.interfaces.QueryRequestProcessor;


public class CompanyDetailsQueryRequestProcessor implements QueryRequestProcessor {

	private final CompanyDetailsQueryProviderModule provider;
	private final Company company;
	
	public CompanyDetailsQueryRequestProcessor(CompanyDetailsQueryProviderModule provider, Company company) {

		super();
		this.provider = provider;
		this.company = company;
	}

	@Override
	public void processRequest(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Exception {

		String html = provider.getCompanyDetailsView(company, user);

		res.setContentType("text/html");
		res.getWriter().write(html);
		res.getWriter().flush();
	}

	@Override
	public void close() throws Exception {}

}
