<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateStatusQueryStateEvaluator" />
		</div>

	</xsl:template>

	<xsl:template name="createCustomFormFields">
		
		<xsl:param name="queryStateEvaluator" />
		
		<label class="floatleft">
			<xsl:value-of select="$i18n.statuses.title" />
		</label>

		<div class="clearboth floatleft marginbottom">
			<xsl:value-of select="$i18n.statuses.description" />
		</div>
		
		<xsl:choose>
				<xsl:when test="Statuses/Status">
					<xsl:apply-templates select="Statuses/Status[not(contentType = 'NEW' or contentType = 'WAITING_FOR_MULTISIGN' or contentType = 'WAITING_FOR_PAYMENT')]" />
					
				</xsl:when>
				<xsl:otherwise>
					<p class="floatleft full">
						<xsl:value-of select="$i18n.FlowHasNoStatuses" />
					</p>
				</xsl:otherwise>
			</xsl:choose>
			
	</xsl:template>
	
	<xsl:template match="Status">

		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id">
						<xsl:value-of select="'status'"/>
						<xsl:value-of select="statusID"/>
					</xsl:with-param>				
					<xsl:with-param name="name" select="'statusID'" />
					<xsl:with-param name="value" select="statusID" />
					<xsl:with-param name="element" select="../../StatusQueryStateEvaluator/StatusIDs" />
				</xsl:call-template>

				<label for="status{statusID}">
					<xsl:value-of select="name" />
				</label>
			</div>
		</div>

	</xsl:template>

	<xsl:template match="UpdateStatusQueryStateEvaluator">

		<xsl:call-template name="createQueryStateEvaluatorForm">
			<xsl:with-param name="queryStateEvaluator" select="StatusQueryStateEvaluator" />
		</xsl:call-template>

	</xsl:template>

</xsl:stylesheet>