package com.nordicpeak.flowengine.evaluators.statusquerystate;

import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.SimplifiedRelation;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluator;

@Table(name = "status_query_state_evaluators")
@XMLElement
public class StatusQueryStateEvaluator extends BaseQueryStateEvaluator {

	private static final long serialVersionUID = 7582032280793947029L;

	@DAOManaged
	@OneToMany(autoAdd = true, autoGet = true, autoUpdate = true)
	@SimplifiedRelation(table = "status_query_state_evaluator_statuses", remoteValueColumnName = "statusID")
	@WebPopulate(paramName = "statusID")
	@XMLElement(fixCase = true, childName = "statusID")
	private List<Integer> statusIDs;

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		super.populate(xmlParser);

		statusIDs = xmlParser.getIntegers("StatusIDs/statusID");
	}

	public List<Integer> getStatusIDs() {
		return statusIDs;
	}

	public void setStatusIDs(List<Integer> statusIDs) {
		this.statusIDs = statusIDs;
	}

	@Override
	public boolean requiresInitialization() {

		return true;
	}

}
