package com.nordicpeak.flowengine.evaluators.tableattributeevaluator;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;
import com.nordicpeak.flowengine.interfaces.MutableQueryDescriptor;
import com.nordicpeak.flowengine.queries.basetablequery.BaseTableColumn;
import com.nordicpeak.flowengine.queries.basetablequery.BaseTableQuery;

public class TableAttributeEvaluatorCRUD extends BaseEvaluatorCRUD<TableAttributeEvaluator, TableAttributeEvaluationProviderModule> {

	private static final AnnotatedRequestPopulator<TableAttributeEvaluator> POPULATOR = new AnnotatedRequestPopulator<>(TableAttributeEvaluator.class);

	public TableAttributeEvaluatorCRUD(Class<TableAttributeEvaluator> beanClass, AnnotatedDAOWrapper<TableAttributeEvaluator, Integer> evaluatorDAO, TableAttributeEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "TableAttributeEvaluator", "table attribute evaluator", null, callback);
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	@Override
	protected void appendUpdateFormData(TableAttributeEvaluator evaluator, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {

		super.appendUpdateFormData(evaluator, doc, updateTypeElement, user, req, uriParser);

		BaseTableQuery query = (BaseTableQuery) callback.getQueryHandler().getQuery((MutableQueryDescriptor) evaluator.getEvaluatorDescriptor().getQueryDescriptor(), false);

		List<BaseTableColumn> columns = query.getColumns();

		if (columns != null) {

			Element columnsElement = XMLUtils.appendNewElement(doc, updateTypeElement, "Columns");

			XMLUtils.append(doc, columnsElement, columns);
		}
	}

}
