package com.nordicpeak.flowengine.integration.treserva.beans;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

import flexjson.JSON;

public class ApplicationDetails {

	private static final DateTimeFormatter DATE_FORMATTER = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
	private static final String VALID_TYPE = "eAnskan";

	@JSON(name = "AktualResDate")
	private String date;

	private LocalDateTime parsedDate;

	@JSON(name = "Avsertyper")
	private String type;

	public LocalDateTime getDate() {

		if (date == null) {

			return null;
		}

		if (parsedDate == null) {

			parsedDate = LocalDateTime.parse(date, DATE_FORMATTER);
		}

		return parsedDate;
	}

	public void setDate(String date) {

		this.date = date;
	}

	public String getType() {

		return type;
	}

	public void setType(String type) {

		this.type = type;
	}

	public boolean hasValidType() {

		return type != null && type.equalsIgnoreCase(VALID_TYPE);
	}

}
