<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="UnsecureMultiSignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{UnsecureMultiSignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="UnsecureMultiSignQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<div class="full display-table bigmarginbottom">
				
				<div class="floatleft fifty bigmarginbottom">
					<strong><xsl:value-of select="$i18n.Firstname" /></strong><br/>
					<xsl:value-of select="UnsecureMultiSignQueryInstance/firstname" />
				</div>
				
				<div class="floatleft fifty bigmarginbottom">
					<strong><xsl:value-of select="$i18n.Lastname" /></strong><br/>
					<xsl:value-of select="UnsecureMultiSignQueryInstance/lastname" />
				</div>
				
				<xsl:if test="UnsecureMultiSignQueryInstance/email">

					<div class="floatleft fifty bigmarginbottom">
						<strong><xsl:value-of select="$i18n.Email" /></strong><br/>
						<xsl:value-of select="UnsecureMultiSignQueryInstance/email" />
					</div>				
				
				</xsl:if>
				
				<xsl:if test="UnsecureMultiSignQueryInstance/mobilePhone">

					<div class="floatleft fifty bigmarginbottom">
						<strong><xsl:value-of select="$i18n.MobilePhone" /></strong><br/>
						<xsl:value-of select="UnsecureMultiSignQueryInstance/mobilePhone" />
					</div>				
				
				</xsl:if>				
				
			</div>
					
		</div>
		
	</xsl:template>		

</xsl:stylesheet>