package com.nordicpeak.flowengine.queries.usertreequery.beans;

import java.io.Serializable;

import se.unlogic.standardutils.xml.XMLElement;

public class TreeUser implements Comparable<TreeUser>, Serializable {

	private static final long serialVersionUID = 3052811179142292741L;

	@XMLElement
	private String firstname;

	@XMLElement
	private String lastname;

	@XMLElement
	private String providerUserID;

	@XMLElement
	private String citizenIdentifier;

	@XMLElement
	private String email;

	@XMLElement
	private String phone;

	public String getFirstname() {

		return firstname;
	}

	public void setFirstname(String firstname) {

		this.firstname = firstname;
	}

	public String getLastname() {

		return lastname;
	}

	public void setLastname(String lastname) {

		this.lastname = lastname;
	}

	public String getProviderUserID() {

		return providerUserID;
	}

	public void setProviderUserID(String providerUserID) {

		this.providerUserID = providerUserID;
	}

	public String getCitizenIdentifier() {

		return citizenIdentifier;
	}

	public void setCitizenIdentifier(String citizenIdentifier) {

		this.citizenIdentifier = citizenIdentifier;
	}

	public String getEmail() {

		return email;
	}

	public void setEmail(String email) {

		this.email = email;
	}

	public String getPhone() {

		return phone;
	}

	public void setPhone(String phone) {

		this.phone = phone;
	}

	@Override
	public int hashCode() {

		final int prime = 31;
		int result = 1;
		result = prime * result + ((citizenIdentifier == null) ? 0 : citizenIdentifier.hashCode());
		result = prime * result + ((providerUserID == null) ? 0 : providerUserID.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {

		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TreeUser other = (TreeUser) obj;
		if (citizenIdentifier == null) {
			if (other.citizenIdentifier != null)
				return false;
		} else if (!citizenIdentifier.equals(other.citizenIdentifier))
			return false;
		if (providerUserID == null) {
			if (other.providerUserID != null)
				return false;
		} else if (!providerUserID.equals(other.providerUserID))
			return false;
		return true;
	}

	@Override
	public int compareTo(TreeUser o) {

		int comparison = firstname.compareToIgnoreCase(o.getFirstname());

		if (comparison != 0) {
			return comparison;
		}

		return lastname.compareToIgnoreCase(o.getLastname());
	}

}
