package com.nordicpeak.flowengine.evaluators.setweightbydateevaluator;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class SetWeightByDateEvaluatorCRUD extends BaseEvaluatorCRUD<SetWeightByDateEvaluator, SetWeightByDateEvaluationProviderModule> {

	private static final AnnotatedRequestPopulator<SetWeightByDateEvaluator> POPULATOR = new AnnotatedRequestPopulator<SetWeightByDateEvaluator>(SetWeightByDateEvaluator.class);

	public SetWeightByDateEvaluatorCRUD(Class<SetWeightByDateEvaluator> beanClass, AnnotatedDAOWrapper<SetWeightByDateEvaluator, Integer> evaluatorDAO, SetWeightByDateEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "SetWeightByDateEvaluator", "set weight by date evaluator", null, callback);
	}

	@Override
	protected void validateUpdatePopulation(SetWeightByDateEvaluator bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, SQLException, Exception {

		List<ValidationError> errors = new ArrayList<ValidationError>();

		if (bean.getMinDayOfMonth() != null && bean.getMaxDayOfMonth() != null && bean.getMinDayOfMonth() > bean.getMaxDayOfMonth()) {

			errors.add(new ValidationError("MinDayOfMonthBiggerThanMaxDayOfMonth"));
		}

		if (bean.getMinDayOfMonth() == null && bean.getMaxDayOfMonth() == null) {

			errors.add(new ValidationError("NoDayOfMonthRangeSpecified"));
		}

		if (!errors.isEmpty()) {

			throw new ValidationException(errors);
		}

		bean.getEvaluatorDescriptor().setTargetQueryIDs(null);
	}

}
