package com.nordicpeak.flowengine.evaluators.setweightbygroupevaluator;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class SetWeightByGroupEvaluatorCRUD extends BaseEvaluatorCRUD<SetWeightByGroupEvaluator, SetWeightByGroupEvaluationProviderModule> {

	private static final AnnotatedRequestPopulator<SetWeightByGroupEvaluator> POPULATOR = new AnnotatedRequestPopulator<SetWeightByGroupEvaluator>(SetWeightByGroupEvaluator.class);

	public SetWeightByGroupEvaluatorCRUD(Class<SetWeightByGroupEvaluator> beanClass, AnnotatedDAOWrapper<SetWeightByGroupEvaluator, Integer> evaluatorDAO, SetWeightByGroupEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "SetWeightByGroupEvaluator", "set weight by group evaluator", null, callback);
	}

	@Override
	protected void appendUpdateFormData(SetWeightByGroupEvaluator query, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {
		super.appendUpdateFormData(query, doc, updateTypeElement, user, req, uriParser);
		
		if (query.getGroupIDs() != null) {
			XMLUtils.append(doc, updateTypeElement, "Groups", callback.getGroupHandler().getGroups(query.getGroupIDs(), true));
		}
	}
}
