<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateSetWeightEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateSetWeightEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="SetWeightEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="SetWeightEvaluator" />
			</xsl:call-template>

			<div class="floatleft full marginbottom">
	
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'useOnlyHighestWeight'" />
						<xsl:with-param name="name" select="'useOnlyHighestWeight'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="SetWeightEvaluator" />
					</xsl:call-template>
	
					<label for="useOnlyHighestWeight">
						<xsl:value-of select="$i18n.useOnlyHighestWeight" />
					</label>
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">

				<label for="weightType" class="floatleft full">
					<xsl:value-of select="$i18n.weightType" />
					<span class="required">*</span>
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weightType'" />
						<xsl:with-param name="name" select="'weightType'" />
						<xsl:with-param name="element" select="SetWeightEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<label class="floatleft">
				<xsl:value-of select="$i18n.alternatives.title" />
			</label>

			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.alternatives.description" />

				<xsl:choose>
					<xsl:when test="Alternatives/Alternative">
					
						<table>
							<thead>
								<tr>
									<th><xsl:value-of select="$i18n.alternatives.name" /></th>
									<th><xsl:value-of select="$i18n.alternatives.weight" /></th>
								</tr>
							</thead>
							<tbody>
								<xsl:apply-templates select="Alternatives/Alternative" />
							</tbody>
						</table>
					
					</xsl:when>
					<xsl:otherwise>
						<p>
							<xsl:value-of select="$i18n.QueryHasNoAlternatives" />
						</p>
					</xsl:otherwise>
				</xsl:choose>
			</div>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.UpdateSetWeightEvaluator.submit}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="Alternative">

		<xsl:variable name="alternativeID" select="alternativeID"/>

		<tr>
			<td>
				<xsl:value-of select="name" />
			</td>
			<td>
				<xsl:call-template name="createTextField">	
					<xsl:with-param name="name">
						<xsl:value-of select="'alternative'"/>
						<xsl:value-of select="alternativeID"/>
					</xsl:with-param>
					<xsl:with-param name="value" select="../../SetWeightEvaluator/AlternativeWeights/AlternativeWeight[alternativeID = $alternativeID]/weight" />
					<xsl:with-param name="requestparameters" select="../../requestparameters"/>
				</xsl:call-template>
			</td>
		</tr>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.weightType" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>